<%--
 *
 * (C) COPYRIGHT International Business Machines Corp. 2012
 * All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 * 
 * @author: psangolekar
 --%>

<%@ page pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.zeborg.expensemap.model3.DataSet"%>
<%@ page import="com.zeborg.cubem.model.DimensionMeta"%>
<%@ page import="com.zeborg.expensemap.view.*, com.emptoris.viewer.util.CSRFHelper" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>

	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/resources/dojo.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/ibmjs/idx/themes/oneui/oneui.css"/>
	
	<style type="text/css">
		#availableMeasures, #selectedMeasures { width: 175px; }
		.oneui .dijitButton .dijitButtonNode { min-width: 50px; }
		body { margin: 20px; border: 1px solid #ccc; margin: 0 5px 0 5px; padding-bottom: 10px; font-family: Arial,Helvetica,sans-serif !important; font-size: 11px !important; }
		#dimensionMappingsForm {  }
		#mainContentDiv { width: 650px; }
		.tableTRFirstTD { width: 10%; white-space: nowrap; }
	</style>
	
	<script type="text/javascript">
        var dojoConfig = {
            parseOnLoad: true,
			async: true,
            locale: '${localeForDojo}'
        };
    </script>
	<script src='/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/dojo.js'></script>

	<script type="text/javascript">
		var categoryDimensionId;
        var supplierDimensionId;
		var isFirstRun = true;
        
		//dojo.require("dojo/_base/lang");
		require(['spend/dimensionMapping'], function() {
			require(["dojo/ready",
				"dijit/form/Select",
		        "dijit/form/Button",
		        "dijit/form/Form",
		        "dijit/layout/ContentPane"], function(ready) {
					
					ready(function() {
						<c:if test="${!empty datasets}">
							firstTimeInitialization();
						</c:if>
						
						dojo.connect(dijit.byId("datasetSelection"), "onChange", populateDimensions);
					});
			});
		});
		
		function validateUserSession(responseData){
			if(responseData.error!=null && responseData.error!="undefined"){ // Session out 
				var timeOutURL = responseData.error.timeOutUrl;		
				window.parent.parent.location = timeOutURL;
			}
		}
		
		/* Populate datasets and default dimensions for first dataset from request parameters */
		function firstTimeInitialization() {
			<c:forEach items="${datasets}" var="dataset">
				dijit.byId("datasetSelection").addOption({"value": '${dataset.id}', "label": '${dataset.displayNameWithVersion}'});
			</c:forEach>
			
			<c:forEach items="${defaultDimensions}" var="dim">
				dijit.byId("supplierDimensionSelection").addOption({"value": '${dim.id}', "label": '${dim.label}'});
				dijit.byId("categoryDimensionSelection").addOption({"value": '${dim.id}', "label": '${dim.label}'});
			</c:forEach>
			
			<c:if test="${!empty categoryDimension}">
				categoryDimensionId = '${categoryDimension.id}';
				dijit.byId("categoryDimensionSelection").set('value', categoryDimensionId);
			</c:if>
			
			<c:if test="${!empty supplierDimension}">
				supplierDimensionId = '${supplierDimension.id}';
				dijit.byId("supplierDimensionSelection").set('value', supplierDimensionId);
			</c:if>
			
			<c:if test="${!empty selectedDatasetId}">
				dijit.byId("datasetSelection").set('value', '${selectedDatasetId}');
			</c:if>
		}
		
		function populateDimensions() {
			if (isFirstRun) {
				isFirstRun = false;
				return;
			}
			
			clearDimensions();
			
			// Ajax call to get available dimensions for chosen dataset
			 dojo.xhrPost({
			        url:"/expensemap/admin/integration/getDimensionsForDataset.jxhtm",
			        handleAs:"json",
			        content: {
			        	"datasetId" : dijit.byId("datasetSelection").value
			        },
			        load: function(data){
			        	validateUserSession(data);
			        	response = data.ResultSet;
			        	var dimensionsList = data.ResultSet.dimensionsList;
			            for(var i in dimensionsList) {
			            	var option = dojo.doc.createElement('option');
			            	option.value = dimensionsList[i].id;
			            	option.label = dimensionsList[i].name;
							option.innerHTML = dimensionsList[i].name;
			            	dijit.byId("supplierDimensionSelection").addOption(option);
							
							clonedOption = dojo.clone(option);
							dijit.byId("categoryDimensionSelection").addOption(clonedOption);
			            }
			            
			            // Set selected dimensions for respective select widgets
						if (data.ResultSet.categoryDimension != undefined) {
							categoryDimensionId = data.ResultSet.categoryDimension[0].id;
							dijit.byId("categoryDimensionSelection").set('value', categoryDimensionId);
						}
						
						if (data.ResultSet.supplierDimension != undefined) {
							supplierDimensionId = data.ResultSet.supplierDimension[0].id;
							dijit.byId("supplierDimensionSelection").set('value', supplierDimensionId);
						}
			        }
			    });
		}
		
		function clearDimensions() {
			var node = dijit.byId("supplierDimensionSelection");
			var totalOptions = node.options.length;
			for (i = totalOptions; i >= 0; i--) {
				node.removeOption(i);
			}
			
			node = dijit.byId("categoryDimensionSelection");
			totalOptions = node.options.length;
			for (i = totalOptions; i >= 0; i--) {
				node.removeOption(i);
			}				
		}
	
		function saveDimensions() {
			var form = document.getElementById("dimensionMappingsForm");
			form.action = "/expensemap/admin/integration/saveDimensionMappings.xhtm";
			form.method = "POST";
			form.submit();
		}
		
		function resetDimensions() {
			dijit.byId("categoryDimensionSelection").set('value', categoryDimensionId);
			dijit.byId("supplierDimensionSelection").set('value', supplierDimensionId);
		}
		
	</script>
	
</head>

<body class="oneui">
	<br />

	<div data-dojo-type="dijit.form.Form" id="dimensionMappingsForm" data-dojo-id="dimensionMappingsForm">
	<div id="mainContentDiv">
	        <div data-dojo-type="dijit.layout.ContentPane">
	           <table border="0" cellspacing="10" cellpadding="0" width="100%" class="contentTable">
	           	<tr>
	           		<td class="tableTRFirstTD"><b><bean:message key='ui.label.Dataset' /></b></td>
	           		<td>
						<select name="datasetId" id="datasetSelection" data-dojo-type="dijit.form.Select">
	           		</td>
	           	</tr>
				<c:if test="${!empty datasets}">
	           	<tr>
	           		<td class="tableTRFirstTD"><b><bean:message key='ui.label.integration.supplier.dimension' /></b></td>
	           		<td>
						<select name="supplierDimension" id="supplierDimensionSelection" data-dojo-type="dijit.form.Select">
	           		</td>
	           	</tr>
	           	<tr>
	           		<td class="tableTRFirstTD"><b><bean:message key='ui.label.integration.category.dimension' /></b></td>
	           		<td>
						<select name="categoryDimension" id="categoryDimensionSelection" data-dojo-type="dijit.form.Select">
	           		</td>
	           	</tr>	           		           	
	           	<tr>
	           		<td></td>
	           		<td>
	           			<button id="saveBtn" data-dojo-type="dijit.form.Button" type="submit" onClick="saveDimensions"><bean:message key='ui.button.integration.save' /></button>
	           			<button id="resetBtn" data-dojo-type="dijit.form.Button" type="button" onClick="resetDimensions"><bean:message key='ui.button.integration.reset' /></button>
	           		</td>
	           	</tr>
				</c:if>
	           </table>
	        </div>
	</div>
	<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
	</div>
	
</body>
</html>