<%--
 *
 * (C) COPYRIGHT International Business Machines Corp. 2012
 * All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 * 
 * @author: psangolekar
 --%>

<%@ page pageEncoding="UTF-8" contentType="text/html;charset=UTF-8"%>
<%@ taglib uri="http://www.springframework.org/tags" prefix="spring"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ page import="com.emptoris.viewer.util.CSRFHelper" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>

	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/resources/dojo.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/ibmjs/idx/themes/oneui/oneui.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/ibmjs/idx/themes/oneui/dojox/grid/oneuiGrid.css"/>
	
	<script type="text/javascript">
        var dojoConfig = {
            parseOnLoad: true,
			async: true,
            locale: '${localeForDojo}'
        };
    </script>	
	<script src='/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/dojo.js'></script>
	<style type="text/css">
		#gridDiv { width: 1000px; }
		.oneui .dojoxGrid { border-right: none !important; }
		.dojoxGridNonNormalizedCell {  }
		body { height: 100%; border: 1px solid #ccc; margin: 0 5px; padding-bottom: 10px; font-family: Arial,Helvetica,sans-serif !important; font-size: 11px !important; }
		#mainContainer { margin-left: 10px; }
		#integrationPropertiesForm { margin-top: 5px; }
		.errorMsg { color: red; font-size: 12px; margin-top: 5px; margin-left: 10px; }
	</style>

	<script>
		var grid;
		var dataStore;	
	
		require(["spend/importExportDimensions"], function() {
			require(["dojo/ready",
				"dojox/grid/DataGrid",
				"dojo/data/ItemFileWriteStore",
				"dijit/form/Button"], function(ready) {
				
				dojo.ready(function() {
					/*set up data store*/
					var data = {
					  identifier: 'id',
					  items: []
					};

					var data_list = [
					  { displayName: "<bean:message key='ui.label.em.webservice.enabled' />", propertyValue: '${enableWebService}', 
						description: "<bean:message key='ui.label.em.webservice.enabled' />", propertyName: "em.webservice.enabled" },
					  { displayName: "<bean:message key='ui.label.em.webservice.view.savwebcontext' />", 
						propertyValue: '${savWebcontext}', description: "<bean:message key='ui.label.em.webservice.view.savwebcontext' />", propertyName: "em.webservice.view.savwebcontext" },
					  { displayName: "<bean:message key='ui.label.em.webservice.view.savurl' />", propertyValue: '${savUrl}', 
						description: "<bean:message key='ui.label.em.webservice.view.savurl' />", propertyName: "em.webservice.view.savurl" },
					  { displayName: "<bean:message key='ui.label.em.default.dataset.name' />", propertyValue: '${defaultDataset}', 
						description: "<bean:message key='ui.doc.em.default.dataset.name' />", propertyName: "em.default.dataset.name" }
					];
					var rows = data_list.length;
					for(var i=0 ; i < rows; i++){
					  data.items.push(dojo.mixin({ id: i }, data_list[i]));
					}
					dataStore = new dojo.data.ItemFileWriteStore({data: data});
			
					/*set up layout*/
					var layout = [[
					  {'name': "<bean:message key='ui.usability.report.heading.display.name' />", 'field': 'displayName', 'width': 'auto'},
					  {'name': '<bean:message key="ui.label.Property.Value" />', 'field': 'propertyValue', 'width': 'auto', formatter: propertyValueFormatter, 'editable': 'true'},
					  {'name': '<bean:message key="ui.label.Description" />', 'field': 'description', 'width': 'auto'},
					  {'name': '<bean:message key="ui.label.Property.Name" />', 'field': 'propertyName', 'width': 'auto'}
					]];
			
					/*create a new grid:*/
					grid = new dojox.grid.DataGrid({
						id: 'grid',
						store: dataStore,
						autoHeight:true,
						structure: layout},
					  document.createElement('div'));
					
					/*append the new grid to the div*/
					dojo.byId("gridDiv").appendChild(grid.domNode);
			
					/*Call startup() to render the grid*/
					grid.startup();

					// Disable grid columns sorting
					grid.canSort = function(col){ return false; };
				});				
				
			});
		});

		function validate() {
			var savWebcontext = dataStore.getValue(grid.getItem(1), 'propertyValue');
			var savUrl = dataStore.getValue(grid.getItem(2), 'propertyValue');
			var defaultDatasetName = document.getElementById('datasetName').value;
			var alertMsg = "";

			if (dojo.string.trim(savWebcontext) == "") {
				alertMsg = alertMsg + '<fmt:message key="ui.validation.integration.base.url.property" />\n';
			}
			
			if (dojo.string.trim(savUrl) == "") {
				alertMsg = alertMsg + '<fmt:message key="ui.validation.integration.access.url" />\n';
			}
			
			if (dojo.string.trim(defaultDatasetName) == "") {
			alertMsg = alertMsg + '<fmt:message key="ui.validation.integration.default.dataset" />\n';
			}
			
			if (alertMsg != "") {
				alert(alertMsg);
			} else {
				saveProperties();
			}
		}
	
		/* This custom formatter will add respective select boxes for 1st and 4th row and input boxes for the rest */
		function propertyValueFormatter(fields, inRowIndex) {
			if (inRowIndex == '0') {
				var selectList = '<select name="webserviceSelect" id="webserviceSelect" data-dojo-type="dijit.form.Select" >';
					<c:choose>
						<c:when test="${enableWebService}">
							selectList += '<option value="true" selected><bean:message key="yes" /></option>';
							selectList += '<option value="false"><bean:message key="no" /></option>';
						</c:when>
						<c:otherwise>
							selectList += '<option value="true"><bean:message key="yes" /></option>';
							selectList += '<option value="false" selected><bean:message key="no" /></option>';						
						</c:otherwise>
					</c:choose>
				return selectList += '</select>';
			} else if(inRowIndex == '3') {
				var selectOptions = '<select name="datasetName" id="datasetName" data-dojo-id="datasetName" data-dojo-type="dijit.form.Select" >';
				<c:forEach items="${datasets}" var="ds">
					<c:if test="${ defaultDataset == ds.name }">
						selectOptions += '<option value="'+ '${ds.name}' + '" selected>' + '${ds.displayName}' +'</option>';
					</c:if>
					<c:if test="${ defaultDataset != ds.name }">
						selectOptions += '<option value="'+ '${ds.name}' + '">' + '${ds.displayName}' +'</option>';
					</c:if>
				</c:forEach>
				selectOptions += '</select>';
				return selectOptions;
			}

			return '<input type="text" size="50" value="'+ fields + '"/>';
		}
		
		function saveProperties() {
			var enableWebService = dojo.byId('webserviceSelect').value;
			var savWebcontext = dataStore.getValue(grid.getItem(1), 'propertyValue');
			var savUrl = dataStore.getValue(grid.getItem(2), 'propertyValue');
			var newValue = dojo.byId('datasetName').value;

			dojo.byId("enableWebService").value = enableWebService;
			dojo.byId("savWebcontext").value = savWebcontext;
			dojo.byId("savUrl").value = savUrl;
			dojo.byId("defaultDataset").value = newValue;
			var form = document.getElementById("integrationPropertiesForm");
			form.action = "/expensemap/admin/integration/integrationProperties.xhtm";
			form.method = "post";
			form.submit();
		}
	
		function resetProperties() {
			dataStore.setValue(grid.getItem(0), "propertyValue", '${enableWebService}');
			dataStore.setValue(grid.getItem(1), "propertyValue", '${savWebcontext}');
			dataStore.setValue(grid.getItem(2), "propertyValue", '${savUrl}');
			dataStore.setValue(grid.getItem(3), "propertyValue", '${defaultDataset}');
		}
	
	</script>
</head>

<body class="oneui">
	<div class="errorMsg">
		<c:forEach items="${error}" var="m" >
			<spring:message message="${m}" /> <br />
		</c:forEach>
		<br />
	</div>
	
	<div id="mainContainer">
		<div id="gridDiv"></div>
		
		<br />
		
		<form name="integrationPropertiesForm" id="integrationPropertiesForm" action="" method="post">
			<button id="saveBtn" data-dojo-type="dijit.form.Button" type="button" onClick="validate()"><bean:message key='ui.button.integration.save' /></button>
			<button id="resetBtn" data-dojo-type="dijit.form.Button" type="button" onClick="resetProperties()"><bean:message key='ui.button.integration.reset' /></button>
			
			<input type="hidden" name="enableWebService" id="enableWebService" value=""/>
			<input type="hidden" name="savWebcontext" id="savWebcontext" value=""/>
			<input type="hidden" name="savUrl" id="savUrl" value=""/>
			<input type="hidden" name="defaultDataset" id="defaultDataset" value=""/>
			<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
		</form>
	</div>
</body>
</html>