<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page pageEncoding="UTF-8" contentType="text/html;charset=UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%@page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@page import="org.apache.struts.Globals,com.zeborg.util.WebUtil,java.util.Locale" %>
<%@page import="com.zeborg.expensemap.view.HelpUtil, com.emptoris.viewer.util.CSRFHelper"%>
<%@page import="com.emptoris.service.cube.data.RollupLevel"%>
<%@page import="com.zeborg.cubem.model.MeasureMeta"%>



<html>
<head>
<LINK REL="stylesheet" TYPE="text/css" href="/expensemap/jsp/stylesheets/adminTableData.css"/>
<style TYPE="text/css">
body{
	font-family:verdana;
	font-size:11px;
}

.TREENODE {
	background-color: #A5B6DE;
	font-family:verdana; 
	font-size:11px; 
	font-weight:regular; 
	color:#31659C; 
	text-decoration:none;	
}

.errorMessage {
	text-align: center;
	font-weight: bold;
	color: red;
}
.row-1 {
	background-color:#dee3ef;
}
.row-0 {
	background-color:#ffffff;
}
.formula {
	word-break: break-all;
	word-wrap: break-word;
	min-width: 200px;
	max-width: 350px;	
}
</style>
<%

/////////////////changed code for help////////////////////
  	Locale locale =WebUtil.getAppLocale(pageContext);	
	HelpUtil emHelp = HelpUtil.getHelpUtil();
	String helpURL = emHelp.getHelpURLString("help.url.admin.system.management.measure.page", locale);	

	request.getSession(false).setAttribute(Globals.LOCALE_KEY, locale);

%>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script language="javascript">
function setOperation(operation) {
	document.getElementById('operation').value=operation;
	return true;
}

function confirmDelete() {
	var confirmDelete ="<spring:message code="ui.delete.alertmsg"/>";
	if (confirm(confirmDelete)) {
		setOperation("deleteMeasures");
	} else {
		return false;
	}
}
   
</script>
</head>
<body>
<form:form action="/expensemap/admin/manageMeasures.xhtm" method="post" id="measureForm" >
<c:if test="${! empty error }">
<c:forEach items="${error}" var="m" >
<div class="errorMessage"><spring:message message="${m}" /></div>
</c:forEach>
</c:if>
<!-- Begin tool bar -->
<table width="100%" border=0 cellpadding=1 cellspacing=0 bgcolor="#336699">
<tr>
	<td width="100%" height="21"></td><td align=right nowrap height="21">
   	<table width="100%" border=0 cellpadding=0 cellspacing=0 bgcolor="#336699">
    <tr>
    <td>
    	<c:if test="${canCreateMeasures}"><input type="button" value="<spring:message code="ui.button.Create"/>" id="createNew"></c:if>
    </td>
    <td></td>
    <td>
    	<input type="submit" value="<spring:message code="ui.label.Delete"/>" id="delete">
    </td>
    <td></td>
	<td>
		<a target="_blank" href="<%=helpURL%>"><img src="/expensemap/jsp/images/help.gif" width="16" height="16" border="0" title='<spring:message code="ui.label.Help"/>'></a>
	</td>
	</tr>
   	</table>
	</td>
	</tr>
</table>
<!--End tool bar-->
<br/>
<table border="0" bgcolor="#EFEFEF" cellspacing="1" cellpadding="1" >
	<tr>
		<td  class="TREENODE"><spring:message code="ui.label.Name"/></td>
		<td  class="TREENODE"><spring:message code="ui.label.Display.Name"/></td>
		<td  class="TREENODE"><spring:message code="ui.label.Formula"/></td>
		<td  class="TREENODE"><spring:message code="ui.label.Rollup.Type"/></td>
		<td  class="TREENODE"><spring:message code="ui.label.dynamic.masking"/></td>
		<td  class="TREENODE"><spring:message code="ui.measure.percentage.of.measures"/></td>
		<td  class="TREENODE"><spring:message code="ui.label.Format.Pattern"/></td>
		<td  class="TREENODE"><spring:message code="ui.label.Currency.Symbol"/></td>
		<td  class="TREENODE"><spring:message code="ui.label.Significant.Digits"/></td>
		<td class="TREENODE">
			<input type="checkbox" name="selectAll" id="selectAll" />
		</td>
	</tr>
	<c:forEach items="${ measures }" var="measureMeta" varStatus="status">
		<tr class="row-${status.count % 2}">
			<td class="tabledata">
				<A href="/expensemap/admin/manageMeasures.xhtm?id=${ measureMeta.id }&cubeMetaId=${ param.cubeMetaId }" >
					${ measureMeta.name }
				</A>
			</td>
			<td class="tabledata">${ measureMeta.displayName }</td>
			<td class="tabledata formula">${ measureMeta.formula }</td>
			<td class="tabledata"><spring:message code="${ measureMeta.rollupType }"/></td>
			<td class="tabledata">${ measureMeta.dimensionMeta.displayName }</td>
			<td class="tabledata">
			<c:choose>
				<c:when test="${ measureMeta.percentageOfMeasure == 0 }" >
					<spring:message code="ui.label.None"/>
				</c:when>
				<c:when test="${ measureMeta.percentageOfMeasure == 1 }" >
					<spring:message code="ui.measure.percentage.of.total.measure"/>
				</c:when>
				<c:otherwise>
					<spring:message code="ui.measure.percentage.of.drillpoint.measure"/>
				</c:otherwise>
			</c:choose>
			</td>
			<td class="tabledata">${ measureMeta.format }</td>
			<td class="tabledata">${ measureMeta.currencySymbol }</td>
			<td class="tabledata">${ measureMeta.significantDigits }</td>
			<td>
			<c:choose>
				<c:when test="${ measureMeta.dataClass == 'CALCULATION' }" >
					<input class="YAHOO.widget.DataTable.CLASS_CHECKBOX" type="checkbox" id="checkbox" name="selectedMeasureIds"
					 value="${ measureMeta.id }" class="tableData" >
				</c:when>
				<c:otherwise>
					<input type="checkbox" value="${ measureMeta.id }" class="tableData" disabled="disabled" >
				</c:otherwise>
			</c:choose>
			</td>
		</tr>
	</c:forEach>
</table>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
<input type="hidden" name="cubeMetaId" value="${param.cubeMetaId}" />
<input type="hidden" name="op" value="delete" />
</form:form>

<script type="text/javascript" src="/expensemap/scripts/selectAllCheckbox.js"></script>
<script>
(function() {
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	var selectAll = null;
	YAHOO.util.Event.onDOMReady(function() {
		selectAll = new YAHOO.emptoris.reports.widgets.selectAllCheckBox(Dom.get('selectAll'),Dom.get("measureForm"),'YAHOO.widget.DataTable.CLASS_CHECKBOX');
	});
	Event.on("createNew", "click", function() {
		var form = Dom.get("measureForm");
		form.method = "get";
		form.op.disabled = true;
		form.submit();
	});
	
	Event.on("measureForm", "submit", function(e) {
	
		var form = Dom.get("measureForm");
		if(selectAll.getSelectedCount() == 0 ) {
			Event.preventDefault(e);
			return false;
		}
		var confirmDelete ="<spring:message code="ui.delete.alertmsg"/>";
		if ( ! confirm(confirmDelete) ) {
			Event.preventDefault(e);
			return false;
		}
	});
})();
</script>
</body>
</html>