<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@page import="java.util.Date"%>
<%@page import="java.text.DateFormat"%>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@page import="com.zeborg.expensemap.view2.ZSession"%>

<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ page pageEncoding="UTF-8" contentType="text/html;charset=UTF-8"%>
<%
	ZSession   zs  = ZSessionUtil.getFromSession(pageContext);
	String headerImagePath = ExpenseMapAppProperties.getEmHeaderImagePath();
%>
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zs.getUser().getTimeZone().getID()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	


<html>
<head>
<title><%= ExpenseMapAppProperties.getExpensemapTitle()%><fmt:message key="ui.label.Admin" /></title>

<link rel="stylesheet" type="text/css" href="stylesheets/macromap.css">
<style type="text/css">
body {
	background-color: #FFFFFF;
	margin-left: 0px;
	margin-top: 0px;
	margin-right: 0px;
	margin-bottom: 0px;
}
.printTitle {
	font-family:verdana;
	font-size:24px;
	color:#003366;
}
.columnHeadingStyle {
	font-family: verdana;
	font-size: 12px;
	color: #003366;
	text-align:center;
	background-color: #DEE2EA;
}

.breadCrumbHeadingStyle {
	font-family: verdana;
	font-size: 12px;
	color: #003366;
	text-align:left;
}


.cellStyle { 
	font-family: verdana;
	font-size: 11px;
	color: black !important;
	text-align: center;
}

.breadcrumb {	font-family:verdana;	font-size: 11px; font-weight: normal; color: #000000;	padding-left: 10px;}

</style>

</head>

<body>
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
<br>

<span class="printTitle"><fmt:message key="ui.report.table.header.name" /> : <c:out value="${ usageReport.usageReportVO.reportName }" /></span>
<br/>
<br/>
<table border="0" cellpadding="0" cellspacing="0">
	<tr class="breadcrumb_new" >
	<td class="breadCrumbHeadingStyle"><fmt:message key="ui.label.Date.Created" /> : </td>
	<td class="breadCrumbHeadingStyle">
		<fmt:formatDate  value="${ usageReport.usageReportVO.creationDate }" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}"/>
	</td>
	</tr>
	<c:if test="${ ! usageReport.usageReportVO.olfUsageReportRequest}" >
		<tr class="breadcrumb_new" >
		<td class="breadCrumbHeadingStyle"><fmt:message key="ui.label.Company" /> : </td>
		<td class="breadCrumbHeadingStyle"><c:out value="${ usageReport.usageReportVO.companyId }" /></td>
		</tr>
		<tr class="breadcrumb_new" >
		<td class="breadCrumbHeadingStyle"><fmt:message key="ui.label.Dataset" /> : </td>
		<td class="breadCrumbHeadingStyle"><c:out value="${ usageReport.usageReportVO.datasetId }" /></td>
		</tr>
	</c:if>
	<tr class="breadcrumb_new" >
		<td class="breadCrumbHeadingStyle"><fmt:message key="ui.usability.startdate" />: </td>
		<td class="breadCrumbHeadingStyle">
				<fmt:formatDate  value="${usageReport.usageReportVO.startDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" />
		</td>
	</tr>
	<tr class="breadcrumb_new" >
		<td class="breadCrumbHeadingStyle"><fmt:message key="ui.usability.enddate" /> : </td>
		<td class="breadCrumbHeadingStyle">
			<fmt:formatDate  value="${usageReport.usageReportVO.endDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" />
		</td>
	</tr>	
</table>
<br/>

<table border="1" cellpadding="0" cellspacing="0">
<tr>
	<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.user" />&nbsp;&nbsp;</td>
		<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.display.name" />&nbsp;&nbsp;</td>
		<c:choose>
			<c:when test="${ usageReport.usageReportVO.olfUsageReportRequest}">
				<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.datasetname" />&nbsp;&nbsp;</td>
				<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.feedbackapplied.date" />&nbsp;&nbsp;</td>
				<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.addcount" />&nbsp;&nbsp;</td>
				<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.mapcount" />&nbsp;&nbsp;</td>
				<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.movecount" />&nbsp;&nbsp;</td>
				<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.renamecount" />&nbsp;&nbsp;</td>
				<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.total" />&nbsp;&nbsp;</td>
			</c:when>
			<c:otherwise>
				<c:if test="${usageReport.usageReportVO.login}">
					<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.logins" />&nbsp;&nbsp;</td>				
					<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.days" />&nbsp;&nbsp;</td>
					<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.firstday" />&nbsp;&nbsp;</td>
					<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.lastday" />&nbsp;&nbsp;</td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.datasetAccess}">				
					<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.dataset.viewed" />&nbsp;&nbsp;</td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.click}">	
					<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.clicks" />&nbsp;&nbsp;</td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.bookmark}">
					<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.bookmarks" />&nbsp;&nbsp;</td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.tabulation}">
					<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.crosstabs" />&nbsp;&nbsp;</td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.dashboard}">
					<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.dashboards" />&nbsp;&nbsp;</td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.analytic}">
					<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.analytics" />&nbsp;&nbsp;</td>
				</c:if>
				<c:if test="${usageReport.usageReportVO.feedback}">
					<td class="columnHeadingStyle">&nbsp;&nbsp;<fmt:message key="ui.usability.report.heading.feedbacks" />&nbsp;&nbsp;</td>
				</c:if>
			</c:otherwise>
		</c:choose>
</TR>

<c:forEach items="${ usageReport.usageReportRows }" var="row">
<tr class="breadcrumb_new" >
	<td class="cellStyle" style="text-align: left"><c:out value="${ row.userName }" /></td>
	<td class="cellStyle" style="text-align: left"><c:out value="${ row.displayName }" /></td>
	<c:choose>
		<c:when test="${ usageReport.usageReportVO.olfUsageReportRequest}">
			<td class="cellStyle"><c:out value="${ row.dataSetName }" /></td>
			<td class="cellStyle">
				<c:choose>
					<c:when test="${ empty row.feedBackAppliedDate }">&nbsp;-&nbsp;</c:when>
					<c:otherwise><fmt:formatDate value="${row.feedBackAppliedDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" /></c:otherwise>
				</c:choose>
			</td>
			<td class="cellStyle"><c:out value="${ row.addFeedBackCount }" /></td>
			<td class="cellStyle"><c:out value="${ row.mapFeedBackCount }" /></td>
			<td class="cellStyle"><c:out value="${ row.moveFeedBackCount }" /></td>
			<td class="cellStyle"><c:out value="${ row.renameFeedBackCount }" /></td>
			<td class="cellStyle"><c:out value="${ row.totalFeedBackCount }" /></td>
		</c:when>
		<c:otherwise>
			<c:if test="${usageReport.usageReportVO.login}">
				<td class="cellStyle"><c:out value="${ row.totalLogins }" /></td>			
				<td class="cellStyle"><c:out value="${ row.totalDays }" /></td>
				<td class="cellStyle">
					<c:choose>
						<c:when test="${ empty row.firstLoginDate }">&nbsp;-&nbsp;</c:when>
						<c:otherwise><fmt:formatDate value="${row.firstLoginDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern}" /></c:otherwise>
					</c:choose>
				</td>
				<td class="cellStyle">
					<c:choose>
						<c:when test="${ empty row.lastLoginDate }">&nbsp;-&nbsp;</c:when>
						<c:otherwise><fmt:formatDate value="${row.lastLoginDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern}" /></c:otherwise>
					</c:choose>
				</td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.datasetAccess}">
				<td class="cellStyle"><c:out value="${ row.datasetViewedCount }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.click}">
				<td class="cellStyle"><c:out value="${ row.totalClicks }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.bookmark}">
				<td class="cellStyle"><c:out value="${ row.bookmarksCreated }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.tabulation}">
				<td class="cellStyle"><c:out value="${ row.crosstabsRun }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.dashboard}">
				<td class="cellStyle"><c:out value="${ row.dashboardsViewed }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.analytic}">
				<td class="cellStyle"><c:out value="${ row.analyticsViewed }" /></td>
			</c:if>
			<c:if test="${usageReport.usageReportVO.feedback}">
				<td class="cellStyle"><c:out value="${ row.feedbacksSubmitted }" /></td>
			</c:if>
		</c:otherwise>
	</c:choose>
</tr>
</c:forEach>
</table>

<br/>
<table border="0" cellpadding="0" cellspacing="0">
<tr>
	<td class="breadcrumb" align="right"><fmt:message key="ui.label.Date.Printed." />&nbsp;</td>
	<td class="breadcrumb">&nbsp;<fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" value="<%= new Date() %>" /></td>

</tr>
<tr><td>&nbsp;</td></tr>
</table>
</body>
</html>