<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>


<%@ page pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<html>
<head>
<title><%=ExpenseMapAppProperties.getExpensemapTitle()%>&nbsp;</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<link rel="stylesheet" type="text/css" href="stylesheets/macromap.css">
<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/popupStyle.css">
<style type="text/css">
<!--
.TREENODE  { font-family:Arial; font-size:10px; font-weight:regular; color:#336699; text-decoration:none; }

.LIST_SORT_HEAD { FONT-WEIGHT: normal; FONT-SIZE: 11px; COLOR: #FFFFFF; FONT-FAMILY: arial, helvetica, sans-serif;TEXT-ALIGN: left; TEXT-DECORATION: none }
-->
.errorMessage {
	text-align: middle;
	font-weight: bold;
	color: red;
}
.infoMessage {
	text-align: middle;
	font-weight: bold;
	color: blue;
}

.scrollable
{
    position:fixed;
    border-left:1px solid black;
    border-right:1px solid black;
    border-bottom:1px solid black;
    border-top:1px solid black;
    width:50%;
    top:14%;
    height: 140px;
    overflow:auto;
    
}
</style>
<script language="javascript">

function selectDiffUser() {
	var pForm = document.getElementById("prefsMgmtForm");
	pForm.action="/expensemap/admin/showPrefMgmt.shtm";
	pForm.method="get";
	pForm.submit();
}

function validateForm() {
	var pForm = document.getElementById("prefsMgmtForm");
    if (checkAtLeastOneSelected(pForm)) {
    	pForm.action='/expensemap/admin/applyPreferences.shtm';
    	pForm.method="post";
    	pForm.submit();	
    } else {
		alert('Please select role to copy');
		return false;
    }
}

//Validate if at least one crosstab is selected.
function checkAtLeastOneSelected(pForm) {
    if (pForm.selectedRoleIds[0]) {
    	// if the checkbox group is an array (one check box is not an array)
    	var noOfRows = pForm.selectedRoleIds.length;
		for (i = 0; i < noOfRows; i++) {
		    if (pForm.selectedRoleIds[i].checked == true) {
				return true;
		    }
		}
    } else {
    	// There is only one check box (it's not an array)
		if (pForm.selectedRoleIds.checked) { // if the one check box is checked
		    return true;
		}
    }
    return false;
}

</script>
</head>
<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" >
<c:forEach items="${message}" var="m" >
<span class="infoMessage"><spring:message message="${m}" /></span><br/>
</c:forEach>
<c:forEach items="${error}" var="m" >
<span class="errorMessage"><spring:message message="${m}" /></span><br/>
</c:forEach>

<form:form cssClass="form" commandName="prefMgmtForm" id="prefsMgmtForm" action="/expensemap/admin/applyPreferences.shtm">
	<!-- Begin tool bar -->
	<table align="center" border="0" cellspacing="0" cellpadding="1" bgcolor="#336699" width="100%" >
	<tr>
		<td  align="left" class="LIST_SORT_HEAD">
			<b><fmt:message key="filters"/></b><form:checkbox path="includeSelfRoles" onclick="selectDiffUser();" />&nbsp;
			<fmt:message key="ui.label.Self.Roles"/>
		</td>
	</tr>
	<tr>
		<td align="left" class="LIST_SORT_HEAD" >
			<form:checkbox path="keepExistingPreferences" />&nbsp;<fmt:message key="ui.error.Do.Not.Override.Existing.Preferences"/>
		</td>		
	<tr>
	</table>
	<!--End tool bar-->
	<br>
	<table border="0" cellspacing="10" cellpadding="1" >
	<tr>
		<td style="font-family:Arial,Helvetica,sans-serif; font-size:16px;"><fmt:message key="ui.label.Available.Users" /></td>
		<td>&nbsp;</td>
	</tr>
	<tr>
	<td>
		<form:select path="selectedUserId" items="${userList}" size="10" itemValue="id" itemLabel="displayName" onclick="selectDiffUser();"/>
	</td>
	<td><!-- table for roles of user with checkboxes -->
	<div class="col-xs-6 col-sm-3 scrollable">
        <table border="1" cellspacing="0" cellpadding="0" align="center">
        	<tr>
        		<td>&nbsp;</td>
        		<c:forEach items="${roleList}" var="role" >
        		<td bgcolor="#ced7e7" nowrap="nowrap" class="TREENODE" align="center">
        			<c:out value="${role.name}"/>
        		</td>
        		</c:forEach>
        	</tr>
        	<tr>
        	<td bgcolor="#ced7e7" class="TREENODE">
        		<c:out value="${selectedUser.displayName}"/>
        	</td>
	        <c:forEach items="${roleList}" var="role" >
	        <td bgcolor="#ffffff" nowrap="nowrap" align="center">
	        	<form:checkbox path="selectedRoleIds" value="${role.id}" />
	        </td>
	        </c:forEach>	
        	</tr>
        </table>
		<br/>
        <br/>
        <table border="0" cellspacing="0" cellpadding="0" align="center" >
		<tr>
			<td align="center" colspan="2">
				<input type="button" name="submit1" value="<fmt:message key='ui.button.Apply.Preferences' />" onclick="return validateForm();" />
			</td>
		</tr>
	</table> 
	</div>
	</td>
	</tr>
	</table>
	<form:hidden path="cubeMetaId" />
	<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</form:form>
</body>