<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"> 
<html>
<head>
<title><%=ExpenseMapAppProperties.getExpensemapTitle()%>&nbsp;<spring:message code='ui.label.sharing.wizard' /></title>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<style type="text/css">
	.tableData {
		font-family: Arial, Helvetica, sans-serif;
		font-size: 11px;
		font-weight: normal;
		color: #0C209B;
		text-decoration: none;
	}

	.tdInGroup {
		font-family: Arial, Helvetica, sans-serif;
		font-size: 11px;
		font-weight: normal;
		color: #0C209B;
		font-style: italic;
	}

	.headerText {
		font-family: Arial, Helvetica, sans-serif;
		font-size: 13px;
		font-weight: bold;
		color: #000066;
		text-align: left
	}

	.header1Text {
		font-family: Arial, Helvetica, sans-serif;
		font-size: 13px;
		font-weight: bold;
		color: #FFFFFF;
		background-color: #000066;
		text-align: center
	}

	.header2Text {
		font-family: Arial, Helvetica, sans-serif;
		font-size: 12px;
		font-weight: bold;
		color: #0C209B;
		background-color: #D9E2EB;
	}

	.topText {
		font-family: Arial, Helvetica, sans-serif;
		font-size: 26px;
		font-weight: bold;
		color: #003366;
		text-align: left
	}

	.belowMast { margin: 0 8 0 8; }
	.userRoleListTable tr, .userRoleListHeaderTable tr { border-top: 1px solid #ffffff; line-height: 22px; }
	.userRoleListTable, .userRoleListHeaderTable { border-collapse: collapse; }
	.userRoleListTable input, .userRoleListTable img { vertical-align: middle; }
	.userRoleListHeaderDiv { margin-bottom: 1px; }
	.searchButtonImage { vertical-align: top; padding-top: 1px; padding-right: 2px; cursor: pointer; }
	.searchInputRow { line-height: 26px; } 
</style>

<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>

<script type="text/javascript">

function hideRow(elem, prf, id, needToUpdateHighlighting){
    obj = document.getElementById(prf + id);
    obj.style.display='none';
    obj = document.getElementById("img_" + prf + id);
    obj.src="/expensemap/jsp/images/expand_small.gif";
    obj.onclick=function() { showRow(elem, prf , id) };
	
	if (!needToUpdateHighlighting) {
		alternateRowHighlightingForTable(prf.replace("_", ""));
	}
}

function showRow(elem, prf, id, needToUpdateHighlighting){
    var obj = document.getElementById(prf + id);
    obj.style.display='table-row-group';
    obj = document.getElementById("img_" + prf + id);
    obj.src="/expensemap/jsp/images/collapse_small.gif";
    obj.onclick=function() { hideRow(elem, prf , id) };
	
	/* If needToUpdateHighlighting parameter is not passed, update highlighting.
	 * This is needed to handle call from openAll(), in which case 
	 * we don't want to fix alternate highlighting.
	 */
	if (!needToUpdateHighlighting) {
		alternateRowHighlightingForTable(prf.replace("_", ""));
	}
}

function openAll(prf){
    var tags = document.getElementsByTagName("TBODY");
    var tlen = tags.length;
    for ( var i = 0; i< tlen; i++ ){
        var obj = tags[i];
		var objId = obj.getAttribute('id');
		if (objId == null) {
			continue;
		}
		
        prefix = objId.substring(0,2);
        if (prefix == prf){
			id = objId.substring(3);
            img_id = "img_" + objId;
            showRow(document.getElementById(img_id), prf+'_', id, true);
        }
    }
}

function anyChecked(prf, val){
	var message="";	
	if(val=='share')
		message ='<spring:message htmlEscape="false" code="ui.label.Please.select.at.least.one.item.to.share" />';
	else 
		message ='<spring:message htmlEscape="false" code="ui.label.Please.select.at.least.one.item.to.unshare" />';
			
    var found = 0;
    var tags = document.getElementsByTagName(prf + "surch");
    var tlen = tags.length;
    for ( var i = 0; i< tlen; i++ ){
        var obj = tags[i];
        if (obj.nextSibling.nextSibling.checked) {
            found++;
            break;
        }
    }

    if (found == 0){
    	alert(message);
    }

    if ( found > 0 ) {
    	var frm = document.getElementById("sharingForm");
   		frm.action = "/expensemap/shareObject.shtm?action="+val;
   		frm.method = "post";
   		frm.submit();    	
        return true;
    } else {
        return false;
	}
}

function doSearch(prf){
    var box = document.getElementById(prf + "Search");
    search(prf, box.value );
}

var colorOdd="#CED7E7";
var colorEven="#EFEFEF";

function search(prf, searchStr){
    openAll(prf);
    var found = 0;
    var tags = document.getElementsByTagName(prf + "surch");
    if (!searchStr) {
		var tlen = tags.length;
		if (tlen != 0) {
		    for ( var i = 0; i< tlen; i++ ){
				var obj = tags[i];
				obj.parentNode.style.display='block';
				if (Math.floor(i/2)*2 != i){
				    obj.parentNode.style.background = colorEven;
				} else {
				    obj.parentNode.style.background = colorOdd;
				}
            }
			
			jQuery("#" + prf + "Div").scrollTop(0);
       }
	   
	   collapseAllGroups(prf);
       return;
    }
    
    lc_val = searchStr.toLowerCase();
    var tlen = tags.length;
    for ( var i = 0; i< tlen; i++ ){
    	var obj = tags[i];
        if ( obj.getAttribute("value") &&  obj.getAttribute("value").toLowerCase().indexOf(lc_val) >= 0 ) {
            lastFound=obj.parentNode;
            lastBackground=obj.parentNode.style.background;
            if (obj.parentNode.parentNode.tagName=='TBODY'){
                id = obj.parentNode.parentNode.getAttribute('id').substring(3);
                img_id = "img_" + obj.parentNode.parentNode.getAttribute('id');
                if (id!=""){
                    showRow(document.getElementById(img_id), prf+'_', id);
                }
            }
            if (found==0) {
                jQuery("#" + prf + "Div").scrollTop(0);
			}
			
            obj.parentNode.style.backgroundColor='yellow';
            obj.parentNode.style.display='block';
            found = 1;
        } else {
            obj.parentNode.style.display='none';
        }
    }	
}

/* Collapses all groups */
function collapseAllGroups(prf) {
	// Search all rows of groups and call hide function
	jQuery.each(jQuery("[id^=img_" + prf + "]"), function(i, roleImg) {
		hideRow(roleImg, prf, jQuery(roleImg).attr("id").replace("img_" + prf, ""), true);
	});
	
	alternateRowHighlightingForTable(prf);
}

/* Makes sure that the table rows are highlighted in alternate colors */
function alternateRowHighlightingForTable(prf) {
	// Do not update the highlighting when search results are populated
	if (jQuery.trim(jQuery("#" + prf + "Search").val()) != "") {
		return;
	}

	var visibleRows = jQuery("#" + prf + "Div td:visible");
	jQuery.each(visibleRows, function (i , row) {
		if (i % 2 == 0) {
			jQuery(row).css("background-color", colorOdd);
		} else {
			jQuery(row).css("background-color", colorEven);
		}
	});
}

/* When page is loaded, fix table highlighting */
jQuery(document).ready(function() {
	alternateRowHighlightingForTable("pr");
	alternateRowHighlightingForTable("iu");
});

</script>
</head>
	<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
		<a target="_blank" href="${helpURL}" style="float:right; margin-right: 8" >
			<img src="/expensemap/jsp/images/help.gif" width="16" height="16" border="0" title="<spring:message code="ui.label.Help" />">
		</a>

		<div class="belowMast" >
			<hr class="topText">
			<form method="post" id="sharingForm">			
				<table width="800" border="0" >
					<tr>
						<td class='headerText' colspan="3">
							<spring:message code="ui.label.share.object.${viewType}" />:<i><c:out value="${ objectName }"></c:out></i>&nbsp;<spring:message code="ui.label.is.currently" />&nbsp;
						</td>
					</tr>
						<!-- left column - where it is not visible -->
					<tr>
						<td valign="top">
							<div class="userRoleListHeaderDiv" style="width: 400px">
								<table class="userRoleListHeaderTable" width="400px" border="0">
									<tr>
										<td class='header1Text' >
											<spring:message code="ui.label.Not.Visible.To" />
										</td>
									</tr>
									<tr class="searchInputRow">
										<td class='header2Text'>
											<div style="text-align: left; float: left">
												&nbsp;<spring:message code="ui.label.Group.User" />&nbsp;(${invisibleUserCount})&nbsp;&nbsp;
											</div>
											<div style="text-align: right">
												<input id="prSearch" type='text' value="" onkeyup='search("pr",this.value)' size="32" />
													<img class="searchButtonImage" border="0" src="/expensemap/jsp/images/magnifying_glass_icon.gif" title="<spring:message code='ui.label.Group.User.Search'/>" onClick="javascript:doSearch('pr')"/>
											</div>
										</td>
									</tr>
								</table>
							</div>

							<div id="prDiv" style="width: 400px; height: 200px; overflow: scroll;">
								<table class="userRoleListTable" width="100%" border="0" bgcolor="#FFFFFF">
								<c:forEach items="${restrictedItems}" var="rItem" varStatus="ctr">
									<tr>
										<c:set var="colStyle" value="tableData" />
										<c:if test="${rItem.inGroup == true}">
											<c:set var="colStyle" value="tdInGroup" />
										</c:if>
										<td class="${colStyle}">
											<prsurch value="${rItem.name}"></prsurch>
											<c:choose>
												<c:when test="${rItem.hasSelfPermissions == true || rItem.viewerId == ownerSelfRoleId}">
													<input type="checkbox" disabled name="role" value="${rItem.viewerId }">
												</c:when>
												<c:otherwise>
													<input type="checkbox" name="role" value="${rItem.viewerId }">
												</c:otherwise>
											</c:choose>
											<c:choose>
												<c:when test="${rItem.group == true}">
													<img id="img_pr_${rItem.viewerId }" onClick="showRow(this, 'pr_','${rItem.viewerId }');"
													  src="/expensemap/jsp/images/expand_small.gif"/>&nbsp;
												</c:when>
												<c:otherwise>
													&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
												</c:otherwise>
											</c:choose>
											<c:out value="${ rItem.name }"></c:out>&nbsp;
											<c:if test="${rItem.self == false}">
												(${ rItem.userCount })
											</c:if>
										</td>
									</tr>
									<c:if test="${rItem.group == true}">
										<tbody id="pr_${rItem.viewerId }" style="display: none">
									</c:if>
									<c:if test="${rItem.inGroup == true && rItem.lastInGroup == true}">
										</tbody>
									</c:if>
								</c:forEach>
							</table>
							</div>
						</td>

						<!-- middle column, with buttons -->
						<td align="center">
							<table>
								<tr><td align="center"><input type="button" name="allowBtn" value="<spring:message code="ui.share.Allow" />" onclick="return anyChecked('pr','share');"/>&nbsp;</td></tr>
								<tr><td>&nbsp;</td></tr>
								<tr><td>&nbsp;</td></tr>
								<tr><td align="center"><input type="button" name="restrictBtn" value="<spring:message code="ui.share.Restrict" />" onclick="return anyChecked('iu','unshare');"/>&nbsp;</td></tr>
								<tr><td>&nbsp;</td></tr>            
							</table>
						</td>

					<!-- right column - where it is visible -->
					<td valign="top">
						<div class="userRoleListHeaderDiv" style="width: 400px">
						<table class="userRoleListHeaderTable" width="400px" border="0">
							<tr>
								<td colspan="2" class='header1Text'>
									<spring:message code="ui.label.Visible.To" />
								</td>
							</tr>
							<tr class="searchInputRow">
								<td class='header2Text'>
									<div style="text-align: left; float: left">
										&nbsp;<spring:message code="ui.label.Group.User" />&nbsp;(${visibleUserCount})&nbsp;&nbsp;
									</div>
									<div style="text-align: right">
										<input id="iuSearch" type='text' value="" onkeyup='search("iu",this.value)' size="32">&nbsp;
										<img class="searchButtonImage" onclick="javascript:doSearch('iu')" border="0" src="/expensemap/jsp/images/magnifying_glass_icon.gif" title="<spring:message code="ui.label.Group.User.Search" />">
									</div>
								</td>
							</tr>
						</table>
						</div>
						<div id="iuDiv" style="width: 400px; height: 200px; overflow: scroll;">
						<table class="userRoleListTable" width="100%" border="0">
						<c:forEach items="${allowedItems}" var="rItem" varStatus="ctr">
							<tr>
								<c:set var="colStyle" value="tableData" />
								<c:if test="${rItem.inGroup == true}">
									<c:set var="colStyle" value="tdInGroup" />
								</c:if>
								<td class="${colStyle}">
									<iusurch value="${rItem.name}"></iusurch>
									<c:choose>
										<c:when test="${rItem.inGroup == true || rItem.owner == true }">
											<input type="checkbox" disabled name="role" value="${rItem.viewerId }">
										</c:when>
										<c:otherwise>
											<input type="checkbox" name="role" value="${rItem.viewerId }">
										</c:otherwise>
									</c:choose>
									<c:choose>
										<c:when test="${rItem.group == true}">
											<img id="img_iu_${rItem.viewerId }" onClick="showRow(this, 'iu_','${rItem.viewerId }');"
											  src="/expensemap/jsp/images/expand_small.gif"/>&nbsp;
										</c:when>
										<c:otherwise>
											&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
										</c:otherwise>
									</c:choose>
									<c:out value="${ rItem.name }"></c:out>&nbsp;
									<c:if test="${rItem.self == false}">
										(${ rItem.userCount })
									</c:if>
								</td>
							</tr>
							<c:if test="${rItem.group == true}">
								<tbody id="iu_${rItem.viewerId }" style="display: none">
							</c:if>
							<c:if test="${rItem.inGroup == true && rItem.lastInGroup == true}">
								</tbody>
							</c:if>
						</c:forEach>
						</table>
						</div>
					</td>
				</tr>
			</table>
			
			<hr class='topText'>
			<div style="width: 900px; text-align: center;">
				<input  type="button"  name="close" value="<spring:message code='button.close' />" onclick="self.close()" />
			</div>
			<input type="hidden" name="id" id="id" value="${ param.id }" />
			<input type="hidden" name="viewType" id="viewType" value="${ param.viewType }" />
			</form>
		</div>
	</body>
</html>