<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>


<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%@ page language="java" contentType="text/html; charset=UTF-8"  pageEncoding="UTF-8"%>
<%@ page import="com.zeborg.expensemap.model3.DataSet"%>
<%@ page import="java.util.*,java.text.*"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.zeborg.expensemap.crosstab.util.CrosstabService" %>
<%@ page import ="com.zeborg.util.WebUtil,com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties" %>
<%@ page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.view.CubeUtil,com.emptoris.viewer.reports.ReportMeta"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@ page import="java.util.Locale,com.zeborg.acl.util.LocaleUtil,org.apache.struts.util.LabelValueBean" %>

<%
		ZSession zs = com.zeborg.expensemap.view.ZSessionUtil.getFromSession(pageContext);	
		Locale locale=zs.getUser().getLocale();		
		String cubeName = zs.getDataSet().getDisplayName();			
		String  helpURL = HelpUtil.getHelpUtil().getHelpURLString("help.url.crosstab.showall.page", locale);			
		EmResourceBundle baseBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_SRC_RESOURCE_BUNDLE, locale);
		String title = ExpenseMapAppProperties.getExpensemapTitle()+ " - "+ baseBundle.getValue("ui.emptoris.title.viewer.storedcrosstabs");
		CubeUtil.buildExpMapMastHead(out,"viewFrame_attachment.jsp",zs,true,null,locale,null);
%>

<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html;UTF-8">
		<title><%=title%></title>

		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit_rtl.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro_rtl.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid_rtl.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/claroGrid.css"/>
		<link rel="stylesheet" href="/expensemap/css/spendGridPageStyle.css"/>
		<link rel="stylesheet" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" type="text/css" />
		
		<style type="text/css">
			#pb {
				position: absolute;
				top: 200px;
				left: 200px;
			}
			#pb.yui-overlay { 
				background-image: url(/expensemap/jsp/images/dimension-viewer-progressbar/75p_white.png);
				border: 1px solid black;
				padding: 5px;
				margin: 10px;
				font-size: 13px;
				font-weight: bold;
				color: black;
			}			
		</style>		

		<script type="text/javascript">
			
			function getHeader() {
				return "<fmt:message key='ui.title.exporting.tabulation' />";
			}
			// Initialize the export UI. show/hide divs. It depends upon each module which div to show/hide. called from commonExportUI.jsp
			var enableUnmergeForXls = <%=ExpenseMapAppProperties.isEnableUnmergeForXls()%>
			function initDiv() {
				var dimensionOptionsDiv = document.getElementById("dimensionOptionsDiv");
				var dimensionNoOfRowsOptionsDiv = document.getElementById("dimensionNoOfRowsOptionsDiv");
				dimensionOptionsDiv.style.display = 'none';
				dimensionNoOfRowsOptionsDiv.style.display = 'none';
				document.getElementById("fileTypeXlsxSpan").style.display = "block";				
				document.getElementById("fileTypeXlsx").checked=true;
				document.getElementById("drNumberFormat").style.display = "none";
				document.getElementById("lableNumberFormat").style.display = "none";
				document.getElementById("trNumFormat").style.display = "none";
				document.getElementById("unmergeXlsSpan").style.display = "block";
			}

			// Returns level by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
			function getLevelsBydimId(dimId) {
				return 0;
			}

			//Returns no of rows by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
			function getNoOfRowsBydimId(dimId) {
				return 0;
			}
			
			// Returns the function name and its params as a string for calling export functionality from common export UI in commonExportUI.jsp
			function getParamString(name, id, status) {
				return "javascript:exportReport('"+ id +"', '"+status+"')";
			}
			
			//Export crosstab
			function exportReport(crossTabID,status) {
				if(status =='0' || status =='-1'){
					alert("<fmt:message key='ui.label.tabulation.needs.to.be.regenerated'/>  ");
					return;
				}

				var theForm = document.getElementById("crosstabListForm");
			    var url='';
			    var displayModeCsv = document.getElementById("fileTypeCsv");
			    var displayModeXls = document.getElementById("fileTypeXls");
				var unmergeXls = document.getElementById("chkunMergeCells").checked;
				var displayModeXlsx = document.getElementById("fileTypeXlsx");
				var fileName = trim(document.getElementById("fileName").value);
			  	theForm.userInputFileName.value = fileName;
				//method in commons.js
				if (validateFileName(fileName, "<fmt:message key='ui.error.file.name.required'/>", "<fmt:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + '\n  _   -')) {
					var numFormatObject = document.getElementById("exportNumberFormat");
					var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value; 
					document.getElementById("numberFormat").value=numFormat;
				    if ( displayModeCsv.checked == true ) {
				        url = "/expensemap/Export.do?operation=exportCrossTabCSV&ctId=" + crossTabID ;
				    } else if ( displayModeXls.checked == true ) {
				        url = "/expensemap/Export.do?operation=exportCrossTabExcel&ctId=" + crossTabID + "&unmergeXls=" + unmergeXls ;
				    }else if ( displayModeXlsx.checked == true ) {
				    	if(isExportable(crossTabID))
				    	{
				    		url = "/expensemap/Export.do?operation=exportCrossTabExcelx&ctId=" + crossTabID + "&unmergeXls=" + unmergeXls ;
				    	}
				    	else{
				    		alert("<fmt:message key='ui.message.use.export.option.csv.for.tabulation'/>  ");
							return;
				    	}
				    }
				    theForm.action = url;
				    theForm.method="post";
				    theForm.target = '_blank';
					theForm.submit();
					theForm.target = '_self';
					closeExportBox();
				}
			}
			
			function isExportable(ctid) {
				try {
					var url = "/expensemap/checkExportXlsxCrosstabAction.xhtm";
					var ajaxResponse = eval(jQuery.ajax({
						url: url,
						type: "GET",
						data: {ctid: ctid},
						async: false
					}).responseText);
					
					if (ajaxResponse[0] == "TRUE") {
						return true ;
					} else {
						return false ;
					} 
				} catch(e) {
					return false ;
				}
			}
			
			// Show/hide divs upon selection of csv/excel type. called from commonExportUI.jsp
			function toggleOptionDiv(fileType) {
				if (document.getElementById("fileTypeXlsx").checked ){
					document.getElementById("unmergeXlsSpan").style.display = "block";
					document.getElementById("drNumberFormat").style.display = "none";
					document.getElementById("lableNumberFormat").style.display = "none";
					document.getElementById("trNumFormat").style.display = "none";
				}else if((document.getElementById("fileTypeXls").checked && enableUnmergeForXls)){
					document.getElementById("unmergeXlsSpan").style.display = "block";
					document.getElementById("drNumberFormat").style.display = "block";
					document.getElementById("lableNumberFormat").style.display = "block";
					document.getElementById("trNumFormat").style.display = "table-row";
				}else{
					document.getElementById("unmergeXlsSpan").style.display = "none";
					document.getElementById("drNumberFormat").style.display = "block";
					document.getElementById("lableNumberFormat").style.display = "block";
					document.getElementById("trNumFormat").style.display = "table-row";
				}
			}

			//validates input pdf filename for special charactes
			//supported special characters are :'_','( )','-'
			function validateInput(inputStr) {
				if ( inputStr.indexOf('{') >-1 || inputStr.indexOf('}') >-1 
					|| inputStr.indexOf('[') >-1 || inputStr.indexOf(']') >-1 
					|| inputStr.indexOf('!') >-1 || inputStr.indexOf('"') >-1 
					|| inputStr.indexOf('\'')>-1 || inputStr.indexOf('&') >-1 
					|| inputStr.indexOf(';') >-1 || inputStr.indexOf('*') >-1
					|| inputStr.indexOf('/') >-1 || inputStr.indexOf('^') >-1
					|| inputStr.indexOf('\\')>-1 || inputStr.indexOf('?') >-1 
					|| inputStr.indexOf('|') >-1 || inputStr.indexOf('=') >-1
					|| inputStr.indexOf('`') >-1 || inputStr.indexOf('~') >-1
					|| inputStr.indexOf(':') >-1 || inputStr.indexOf('@') >-1
					|| inputStr.indexOf('#') >-1 || inputStr.indexOf('$') >-1
					|| inputStr.indexOf('%') >-1 || inputStr.indexOf('+') >-1
					|| inputStr.indexOf('(') >-1 || inputStr.indexOf(')') >-1) {

					return false;
				}
				return true;
			}

			// validate file name for blank or invalid chars.
			function validateFileName(fileName, nameRequired, invalidChars) {
				var message = '';
				if (IsEmptyString(fileName)) {
					message = nameRequired;
				} 
				if (!validateInput(fileName)) {
					if (message != '') {
						message += '\n';
					}
					message += invalidChars;
				}		
				if (message != '') {
					alert(message);
					return false;
				}
				return true;
			}

			//Checks if input string is undefined, null or blank (with/without spaces)
			function IsEmptyString(name) {
				return (!name || /^\s*$/.test(name));
			}

		</script>

		<script type="text/javascript">
			dojoConfig = {
				baseUrl : "/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/"					
			};
		</script>

		<script type="text/javascript" src="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/dojo.js" data-dojo-config="parseOnLoad: true" ></script>
		<SCRIPT type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></SCRIPT>
		<SCRIPT type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></SCRIPT>
		

		<script type="text/javascript">

			dojo.require("dojo/domReady");
			dojo.require("dojo/store/Memory");
			dojo.require("dojo/data/ObjectStore");
			dojo.require("dojox/grid/DataGrid");
			dojo.require("dojo/_base/xhr");
			dojo.require("dijit/layout/BorderContainer");
			dojo.require("dijit/form/Button");
			dojo.require("dijit/form/Select");
			dojo.require("dijit/TitlePane");
			dojo.require("dijit/form/TextBox");
			dojo.require("dijit/form/CheckBox");
			dojo.require('dijit/form/NumberTextBox');
			dojo.require("dijit/form/DateTextBox");
			dojo.require("dijit/form/ValidationTextBox");

			var tabulation_Grid_Layout, tabulation_Grid_Store, tabulation_Grid_Obj, dataStore , categoryLabelValue;
			var exportPermission;
			var progressBar = null;
			
			dojo.ready(function(){
				progressBar = new YAHOO.widget.Overlay("pb", { fixedcenter:true, visible:false, width:"180px" } );
				progressBar.render(document.body);
				showProgressBar();
				
				tabulation_Grid_Layout = [
											{														
												name: "<input id='selectAllRows' name='selectAllRows' type='checkbox' onClick='selectAll(this);'/>",
												fields :['id','bookMarkId','displayOption','showRegenerateOption','numStatus'],
												formatter:addCheckBox,
												width:"3%"
											},{
												id: 'name',
												name: '<fmt:message key="ui.label.Name" />',
												fields:['bookMarkId','name','topReport','privateTopReport','displayOption','showRegenerateOption','numStatus'],
												headerStyles:"cursor:pointer",
												formatter:createLink,																							
												width:"10%"
											},{
												id: 'owner',
												field:'submittedBy',
												name: '<fmt:message key="ui.label.Created.By"/>',
												width:"10%"							
											},{
												id: 'sharedBy',
												field:'sharedBy',
												formatter:renderSharedBy,
												name: '<fmt:message key="ui.label.Shared.By"/>',												
												width:"6%"
											},{
												id: 'dimensions',
												field:'dimensions',
												formatter:unscapeHTMLString,
												name: '<fmt:message key="ui.label.Dimensions"/>',												
												width:"15%"
											},{
												id: 'filter',
												field:'filter',
												formatter:unscapeHTMLString,
												name: '<fmt:message key="ui.label.Filters"/>',												
												width:"15%"												
											},{
												id: 'dateSubmitted',
												field:'dateSubmittedStr',
												name: '<fmt:message key="ui.label.Date.Submitted"/>',												
												headerStyles:"cursor:pointer",											
												width:"10%"
											},{
												id: 'dateCompleted',
												field:'dateCompletedStr',
												name: '<fmt:message key="ui.label.Date.Completed"/>',												
												headerStyles:"cursor:pointer",
												formatter:getDateString,
												width:"10%"
											},{
												id: 'status',
												field:'status',
												headerStyles:"cursor:pointer",
												name: '<fmt:message key="ui.label.Status"/>',																								
												width:"7%"
											},{
												id: 'share',
												fields:['bookMarkId','shareEnabled'],
												formatter:shareEnabled,
												name: '<fmt:message key="ui.label.Share"/>',																								
												width:"5%"												
											},{
												id: 'exportTabulation',
												fields:['id','name','numStatus','showRegenerateOption','displayOption'],
												formatter : renderExportTabulation,
												name: '<fmt:message key="ui.report.table.header.export"/>',																								
												width:"5%"	
											},{
												id: 'editTabulation',
												fields:['bookMarkId','numStatus','sharedBy'],
												formatter : editTabulation,
												name: '<fmt:message key="ui.label.Edit"/>',														
												width:"4%"	
											}
										];
				 /*
				 * This code will Fetch the list first time only. 
				 * 
				 */
				require(["dojox/grid/DataGrid", "dojo/store/Memory", "dojo/data/ObjectStore", "dojo/_base/xhr", "dojo/domReady", "dijit/form/Select"],

					function(DataGrid, Memory, ObjectStore, xhr){
						// Send request to fetch the list from the server. Post request.

						xhr.post({
							url: "/expensemap/fetchTabulationList.jxhtm",
							handleAs: "json",
							content:{theAction: "showAll"} // Add the request parameter. You can add N number of paratmeter by separating them by comma 
						}).then(function(responseData){
							tabulation_Grid_Store = new dojo.store.Memory({ data: responseData.crosstabList });
							categoryLabelValue = new dijit.form.Select({
																			id:"category",
																			name: "category",
																			store: new ObjectStore({ objectStore: new Memory({ data: responseData.categorylabelvalue })}),
																			maxHeight: -1
																		}
																			,"category_div");
							categoryLabelValue.startup();
							showTopReortDiv(responseData);
							configurePaginationComponent(responseData.crosstabListForm.paginatoin);
							exportPermission = responseData.ExportPermission;							
							dataStore = new ObjectStore({ objectStore: tabulation_Grid_Store });
							tabulation_Grid_Obj = new DataGrid({
																id:'tabulation_Grid',
																store: dataStore,																			
																canSort : canSort,
																rowSelector:'0px',
																selectionMode:"single",																
																autoHeight:true,
																structure : tabulation_Grid_Layout			
															},																		
															"Grid_Div"
													);// End of DataGrid.										
							tabulation_Grid_Obj.startup();							
						});

						hideProgressBar();
					}//End of function 
				);// End of require
				
				/*
					All button event handler  -- START
				*/
				require(["dojo/on", "dojo/topic", "dojo/dom-construct"],
							function(on, topic, domConstruct) {

								var resetSearch = dojo.byId("resetSearch");
								on(resetSearch, "click", function() {								
									resetSearchOptions();								
								});

								var search = dojo.byId("search");
								on(search, "click", function() {
									if(	dojo.byId("search_crosstabName").value=="" && 
										dojo.byId("search_FromDate").value=="" && 
										dojo.byId("search_ToDate").value=="" &&
										dojo.byId("search_createdBy").value=="")
										dojo.byId("theAction").value = "showAll";

									showAllCrossTab();
								});

								var showAll = dojo.byId("showAll");
								on(showAll, "click", function() {
									dojo.byId("theAction").value = "showAll";
									resetSearchOptions();
									showAllCrossTab();
								});
							
								var refresh = dojo.byId("refresh");
								on(refresh, "click", function() {
									dojo.byId("theAction").value="getCurrent";
									showAllCrossTab();
								});

								var deleteAction = dojo.byId("delete");
								on(deleteAction, "click", function() {
									dojo.byId("theAction").value="getCurrent";
									deleteTabulation();
								});

								var cancel = dojo.byId("cancel");
								on(cancel, "click", function() {
									dojo.byId("theAction").value="getCurrent";
									cancelJob();
								});
								
								var topReport = dojo.byId("topReport");
								on(topReport, "click", function() {								
									saveAsTopReport();
								});// Top Report event handler.	


								var applyPageSizeButton = dojo.byId("applyPageSize");
								on(applyPageSizeButton, "click",function() {								
									dojo.byId("pageSize").value = dojo.byId("userInput_pageSize").value;									
									dojo.byId("theAction").value="getCurrent";
									showAllCrossTab();
								});	
				});// End of Event handler require.

				/* All button event handler  -- END */
			
				

			});// end of dojo ready function.
			
			function renderSharedBy(field){
				if(field==null || field=='') return "&nbsp;";

				return field;
			}
			function unscapeHTMLString(htmlString){ 
				 htmlString = htmlString.replace(/&lt;/g,'<');
				 return htmlString;
			}

			function deleteTabulation(){
				var frm = document.getElementById("crosstabListForm");
				var isSelected = checkAtLeastOneSelected();				
				if (frm.crossTabIds.length > 0 && isSelected || frm.crossTabIds.value && isSelected) {
					if (confirm('<fmt:message key="ui.delete.alertmsg"/>')) {
						submitRequest("/expensemap/deleteTabulation.jxhtm");
					}
				}
			}
			
			function cancelJob() {	
				var frm = document.getElementById("crosstabListForm");
				if (frm.crossTabIds == null) {
					alert("<fmt:message key='ui.message.no.crosstabs.cancel' />");
					return;
				}

				var isSelected = checkAtLeastOneSelected();
				if (frm.crossTabIds.length > 0 && isSelected || frm.crossTabIds.value && isSelected) {
					var confirmCancel ="<fmt:message key='ui.job.cancel.message' />";
					if(confirm(confirmCancel)) {
						submitRequest("/expensemap/cancelTabulationJob.jxhtm");						
					}
				} else if (frm.crossTabIds.length > 0 && !isSelected || frm.crossTabIds.value && !isSelected) {
					alert("<fmt:message key='ui.message.select.crosstab.to.cancel' />");
				} else {
					alert("<fmt:message key='ui.message.no.crosstabs.cancel' />");
				}
			}
			

			function saveAsTopReport() {				
				var frm = document.getElementById("crosstabListForm");
				var isConfirmed=false;

				if (frm.crossTabIds == null) {
					alert("<fmt:message key='ui.message.No.Reports.to'/>  " +  "<fmt:message key='ui.msg.TopReport'/>");
					return;
				}

				var isSelected = checkAtLeastOneSelected();
				if (frm.crossTabIds.length > 0 && isSelected  || frm.crossTabIds.value && isSelected ) {
					for( var i=0; i< frm.crossTabIds.length; i++ ) {
						if(frm.crossTabIds[i].checked){
							var numStatus=frm.crossTabIds[i].value.substring(frm.crossTabIds[i].value.indexOf("_")+1);
							if(numStatus !='5'){
								if(confirm("<fmt:message key='ui.tabulation.confirm.message.to.save.as.top.report'/>")){
									isConfirmed=true;
									break;
								}else return;
							}
						}
					}
				var privateReport=frm.privateReport.checked;
				var confirmMsg = '';
				var finalConfirmation=false;
				if(privateReport) {
					if(confirm("<fmt:message key='ui.save.topreport.private.continue.alertmsg'/>"))
						finalConfirmation=true;
					else return;
				}else{
					if(isConfirmed || confirm("<fmt:message key='ui.save.topreport.alertmsg'/>"))
						finalConfirmation=true;
					else return;
				}

				if( isConfirmed ||  finalConfirmation){
					showProgressBar();
					var reportType=<%=ReportMeta.TOP_N_CROSSTAB%>
					var reportCategory = dijit.byId('category').value;
					var url = "/expensemap/saveCrossTabAsTopReport.jxhtm";					
					frm.action = url;
					var xhrArgs = {
						form: frm,
						handleAs: "json",
						content: {category: reportCategory,privateReport: privateReport},
						load: function(data){
							refreshGridStore(data);
						}// end of load.
					}// End of xhrArgs.
					dojo.xhrPost(xhrArgs);
				} else {return false;}
			
				} else if (frm.selectBox.length > 0 && !isSelected || frm.selectBox.value && !isSelected) {
					alert("<fmt:message key='ui.message.select.crosstab.for.top.report' />");
				} else  { 
					alert("<fmt:message key='ui.message.no.crosstabs.for.top.report'/>");
				}
			}

			function submitRequest(url){
				var frm = document.getElementById("crosstabListForm");
				showProgressBar();
				frm.action = url;
				var xhrArgs = {
					form: frm,					
					handleAs: "json",
					load: function(data){
						refreshGridStore(data);
					},// end of load.
					error: function() {
						hideProgressBar(); 
						gridMsgDiv.style.display = "block";
						gridMsgDiv.innerHTML = '<b>' + "<fmt:message key='ui.message.There.was.a.problem.retrieving.data.from.server'/>" + '</b>';
					}					
				}// End of xhrArgs.
				dojo.xhrPost(xhrArgs);
			}


			function checkAtLeastOneSelected() {				
				var frm = document.getElementById("crosstabListForm");
				if (frm.crossTabIds.length) { // if the checkbox group is an array (one check box is not an array)
					var noOfRows = frm.crossTabIds.length;
					for (i = 0; i < noOfRows; i++) {
						if (frm.crossTabIds[i].checked == true) {			
							return true;
						}
					}
				}else { // There is only one check box (it's not an array)
					if (frm.crossTabIds.checked) { // if the one check box is checked
						return true;
					}
				}
				return false;
			}

			function refreshGridStore(responseData){
				if(!validateUserSession(responseData)) return false; // function validateUserSession() defined with topMenu.jsp
				exportPermission = responseData.ExportPermission;
				displayErrorIfAny(responseData);
				showTopReortDiv(responseData);						
				configurePaginationComponent(responseData.crosstabListForm.paginatoin);				
				var newStore = new dojo.store.Memory({ data: responseData.crosstabList });					
				var newDataStore = new dojo.data.ObjectStore({ objectStore: newStore });				
				tabulation_Grid_Obj.setStore(newDataStore);		
				hideProgressBar();
			}

			function displayErrorIfAny(responseData){
				var gridMsgDiv = dojo.byId("errorMsg_grid");
				var searchMsgDiv = dojo.byId("errorMsg_search");
				gridMsgDiv.style.display = "none";
				gridMsgDiv.innerHTML =  "";
				searchMsgDiv.style.display = "none";						
				searchMsgDiv.innerHTML = "";						
				if(responseData.errorMsg_grid != 'undefined' && responseData.errorMsg_grid != null ){
					gridMsgDiv.style.display = "block";
					gridMsgDiv.innerHTML =  "<b>"+responseData.errorMsg_grid+"</b>";
				}
				if(responseData.errorMsg_search != 'undefined' && responseData.errorMsg_search != null){
					searchMsgDiv.style.display = "block";
					searchMsgDiv.innerHTML = "<b>" + responseData.errorMsg_search + "</b>";
				}
			}
			function showAllCrossTab(){						
				var frm = document.getElementById("crosstabListForm");
				submitRequest("/expensemap/fetchTabulationList.jxhtm");				
			}


			// SEARCH JAVA SCRIPT FUNCTION - START //
			function resetSearchOptions(){
				dijit.byId("search_crosstabName").set('value',"");				
				dijit.byId("search_FromDate").set('value',' ');
				dijit.byId("search_ToDate").set('value',' ');
				dijit.byId("search_createdBy").set('value','');
				resetStatusCheckBox();
				HideSearchErrDiv();
			}

			function resetStatusCheckBox(){
				dijit.byId("completed").set("checked",false);
				dijit.byId("running").set("checked",false);
				dijit.byId("submitted").set("checked",false);
				dijit.byId("canceled").set("checked",false);
				dijit.byId("failed").set("checked",false);
			}

			function HideSearchErrDiv(){
				var searchErrDiv = document.getElementById("errorMsg_search");
				if(searchErrDiv.style.display=='block'){
					searchErrDiv.innerHTML="";
					searchErrDiv.style.display='none';
				}
			}
			// SEARCH JAVA SCRIPT FUNCTION - END //
			



			//fields :['id','bookMarkId','displayOption','showRegenerateOption','numStatus'],
			function addCheckBox(fields){
				if(fields[2] && fields[3])
					return "<input type='checkbox' name='crossTabIds' value='null." + fields[0] + "_" + fields[4] + "' onclick='updateSelectAll();' />";
				return "<input type='checkbox' name='crossTabIds' value='" + fields[0] + "_" + fields[4] + "' onclick='updateSelectAll();' />";

			}

			function selectAll(selectAllControl) {				
				var theForm =  document.getElementById("crosstabListForm");
				if ( theForm.crossTabIds == null ) {
					document.getElementById("selectAllRows").checked=false;
					document.getElementById("selectAllRows").disabled=true;
					return false;	
				} 

				if ( theForm.crossTabIds.length ) {
					// There are more than one rows on this form.
					for( var i=0; i< theForm.crossTabIds.length; i++ ) {					
						theForm.crossTabIds[i].checked = selectAllControl.checked;
					}
				}				
				// There is just a single row on this form.
				theForm.crossTabIds.checked = selectAllControl.checked;				
			}

			function updateSelectAll(){				
				var theForm = document.getElementById("crosstabListForm");
				var selectAllControl = document.getElementById("selectAllRows");
				var allSelected = true;
				
				if ( ! theForm.crossTabIds.length ) {
					allSelected = theForm.crossTabIds.checked;
				}else {
					for( var i=0; i< theForm.crossTabIds.length; i++ ){
						if ( theForm.crossTabIds[i].checked == false ){
							allSelected = false;
							break;
						}	
					}
				}
				selectAllControl.checked = allSelected;
			}

			//fields:['bookMarkId','name','topReport','privateTopReport','displayOption','showRegenerateOption''numStatus'],			
			function createLink(fields){
				var linkString ="";
				
				if(fields[2]) 
					linkString = "<img src='/expensemap/jsp/images/report/reports_icon.gif' border='0' title='<fmt:message key='ui.topn.Top.Report' />' >";
				
				if(fields[3]) 
					linkString = "<img src='/expensemap/jsp/images/report/private_reports_icon.jpg' border='0' title='<fmt:message key='ui.topn.Private.Top.Report' />' >";
				
				if(fields[4]){
					var locationUrl ="/expensemap/getDimensionalView.do?viewCrossTab=true&viewSelected=dimension&bkid="+fields[0];
					if(fields[5]){ 					
						linkString += "<a href=# onclick=regenerateCrosstab(\'"+locationUrl+"\',\'"+fields[0]+"\');>"+fields[1]+"</a>";					
					}else{
						linkString += "<a href=# onclick=renderCrosstab(\'"+locationUrl+"\',\'"+fields[0]+"\',true,\'"+fields[6]+"\');>" + fields[1] + "</a>";
					}
				}else{ 
					linkString = "<esapi:html>"+fields[1]+"</esapi:html>";
				}				
				return linkString;		
			}
			
			//fields:['bookMarkId','shareEnabled'],
			function shareEnabled(fields){
				if(fields[1]){
					return '<a href="#" onclick="shareView(\'' + fields[0] + '\');"><img src="/expensemap/jsp/images/share_icon.gif" border="0"/></a>';
				}
				return "&nbsp;";
			}
			
			function shareView(id) {				
				var ht = 475;
				var wt = 935;
				var left = (screen.width/2)-(wt/2);
				var top = (screen.height/2)-(ht/2);	
				open('/expensemap/shareObject.shtm?viewType=crosstab&id=' + id, '_blank', "resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
			}

			//fields:['id','name','numStatus','showRegenerateOption','displayOption'],
			function renderExportTabulation(fields){				
				if(exportPermission){
					if(fields[4]  && !fields[3])
						return '<a href=# onclick=openExportBox("' + escape(fields[1]) + '","'+ fields[0]+'","'+ fields[2] + '") ><img src=/expensemap/jsp/images/excel.gif /></a>';					
				}
				return "&nbsp;";
			}
			//fields:['bookMarkId','numStatus','sharedBy'],
			function editTabulation(fields){
				
				if(fields[2] == "" && fields[1] ==5 ){
					return '<a href=# onclick=openEditView("' + fields[0] + '") ><img src=/expensemap/jsp/images/edit.gif /></a>';				
				}
				return "&nbsp;";
			}
			
			function openEditView(id){
				
				var locationUrl ="/expensemap/getDimensionalView.do?editCrossTab=true&viewSelected=dimension&bkid="+id;
				getTarget(parent).location.href=locationUrl;
			}
				
			function getDateString(field){
				if(field!=null && field!='') return field;
				return "&nbsp;"
			}

			function canSort(col){

				var returnVal = true;				
				//positive for an ascending sort and negative for a descending sort
				var sortingOrder = "desc";
				if(col > 0){
					sortingOrder="asc";
				}

				dojo.byId("listSortOrder").value = sortingOrder;

				var sortingColName;

				switch(col){
											
					case 2:	case -2:
						sortingColName = "name";
						break;
					case 7: case -7:
						sortingColName = "dateSubmitted";
						break;					
					case 8:	case -8:
						sortingColName = "dateCompleted";
						break;
					case 9:	case -9:
						sortingColName = "status";
						break;
					case 1:  case -1:
					case 3:	 case -3:
					case 4:	 case -4:
					case 5:  case -5:
					case 6:	 case -6:
					case 10: case -10:
					case 11: case -11:
						returnVal = false;
						break;					
									
				}				
				dojo.byId("listSortColumnName").value = sortingColName;
				dojo.byId("theAction").value="getCurrent";
				if(returnVal){showAllCrossTab();}

				return returnVal;
			}
			
			// TODO move methods getEpensemapFrame & getTarget to common JS file				
			// This function recursively traverse through frame tree structure 
			// and returns instance of expensemapFrame if found else null
			function getEpensemapFrame(fr){
				if( fr.name == "expensemapFrame"){
					return fr;
				} else if(fr.length > 0){
					for( var i=0; i<fr.length; i++){
						var currFr = getEpensemapFrame(fr[i]);
						if( currFr != null ){
							return currFr;
						}
					}
				}
			}

			function getTarget(defaultTarget) {
				if ( top.frames != null && top.frames.length > 0 ) {
					for(var i=0; i<top.frames.length; i++){
						var currFr = getEpensemapFrame(top.frames[i]);
						if(currFr != null){
							return currFr ;
						}
					}
				}
				return defaultTarget;
			}
			
			//Render crosstab on name click
			function renderCrosstab(location, bkid, needSizeCheck, status) {
				if(status ==<%=CrosstabService.STATUS_COMPLETED%> && needSizeCheck){
					var responseData = isLargeCrosstab(bkid);					
					if( responseData == "FALSE" || responseData == "MEASURE_PERMISSION_ISSUE"){
						getTarget(parent).location.href=location;
					}else{
						var msg = "<fmt:message key='crosstab.3x3.huge.report.message'/>";
						alert(msg.replace("</br>", "\n"));
						return;
					}
				}else{
					getTarget(parent).location.href=location;					
				}
			}
			
			function isLargeCrosstab(bkid) {
				try {
					var url = "/expensemap/checkLargeCrosstabAction.xhtm";
					var ajaxResponse = eval(jQuery.ajax({
						url: url,
						type: "GET",
						data: {bkid: bkid},
						async: false
					}).responseText);
					return ajaxResponse;
				} catch(e) {
					return false ;
				}
			}
			
			function regenerateCrosstab(location, bkid) {
				if (confirm("<fmt:message key='ui.alertmsg.regenerate.analytics'/>")){
				 renderCrosstab(location, bkid,false,0);
				}
			}
			// Show OR Hide create top report options.
			function showTopReortDiv(responseData){
				var topReortDiv = dojo.byId("topReortDiv");
				if(responseData.crosstabListForm.canCreateTopReports){
					topReortDiv.style.display="block";
				}else{
					topReortDiv.style.display="none";
				}					
				dijit.byId("privateReport").set("checked",false);				
			}

			function configurePaginationComponent(pageData){
				
				//Set all Hidden variables
				dojo.byId("startRec").value=pageData.startRec;				
				dojo.byId("pageSize").value=pageData.pageSize;
				dojo.byId("userInput_pageSize").value=pageData.pageSize;
				dojo.byId("limitRec").value=pageData.limitRec;
				dojo.byId("totalRec").value=pageData.totalRec;
				dojo.byId("listSortOrder").value=pageData.listSortOrder;
				dojo.byId("listSortColumnName").value=pageData.listSortColumnName;
				dojo.byId("lastRecord").value=pageData.lastRecord;		
				var totalObjectCount = pageData.totalRec;				

				if(totalObjectCount!='undefined' && totalObjectCount > 0){		
					dojo.byId("pagination_div").style.display="block";		
					dojo.byId("pagination_text").innerHTML="";
					var firstImg = dojo.byId("first");
					var prevImg = dojo.byId("prev");
					if(pageData.startRec==1){
						
						firstImg.src = '/expensemap/jsp/images/beginning_disabled.gif';
						firstImg.title="<fmt:message key='tooltip.you.are.at.top'/>";
						firstImg.onclick=function(){};//donothing
							
						prevImg.src = '/expensemap/jsp/images/back_disabled.gif';			
						prevImg.title="<fmt:message key='tooltip.you.are.at.top'/>"
						prevImg.onclick = function(){};//donothing
					}else{
						firstImg.src = '/expensemap/jsp/images/beginning_enabled.gif';
						firstImg.title="<fmt:message key='tooltip.go.top'/>";
						firstImg.onclick=goToFirst;

						prevImg.src = '/expensemap/jsp/images/back_enabled.gif';
						prevImg.title=getToolTip("<fmt:message key='ui.image.tooltip.movePrevious'/>",pageData.pageSize);
						prevImg.onclick = goToPrev;
					}

					var nextImg = dojo.byId("next");
					var lastImg = dojo.byId("last");		
					if(pageData.limitRec == pageData.totalRec){
						nextImg.src = '/expensemap/jsp/images/forward_disabled.gif';
						nextImg.title="<fmt:message key='tooltip.you.are.at.bottom' />";
						nextImg.onclick= function(){};//donothing
							
						lastImg.src = '/expensemap/jsp/images/end_disabled.gif';
						lastImg.title="<fmt:message key='tooltip.you.are.at.bottom' />";	
						lastImg.onclick = function(){};//donothing
					}else{			
						nextImg.src = '/expensemap/jsp/images/forward_enabled.gif';
						var argForToolTip = ((pageData.totalRec-pageData.limitRec)>=pageData.pageSize)? pageData.pageSize : (pageData.totalRec - pageData.limitRec);
						nextImg.title=getToolTip("<fmt:message key='ui.image.tooltip.moveNext' />", argForToolTip);
						nextImg.onclick = goToNext;
						
						lastImg.src = '/expensemap/jsp/images/end_enabled.gif';
						lastImg.title="<fmt:message key='tooltip.go.bottom' />";
						lastImg.onclick = goToLast;
					}	
					dojo.byId("pagination_text").innerHTML = getPaginationText("<fmt:message key='ui.label.pagination.text' />",pageData.startRec,pageData.limitRec,pageData.totalRec);
				}else{
					dojo.byId("pagination_div").style.display="none";
				}
		}
		
		function getToolTip(msg,arg){			
			msg = msg.replace("{0}",arg);					
			return msg;
		}
		
		function getPaginationText(msg,startRec, limitRec, totalRec){
			msg = msg.replace("{0}", startRec);			
			msg = msg.replace("{1}" , limitRec);			
			msg = msg.replace("{2}", totalRec);			
			return msg;
		}
		
		function goToFirst(){getMaxRows('getFirst', false);}
		function goToPrev(){getMaxRows('getPrev', false);}
		function goToNext(){getMaxRows('getNext', false);}
		function goToLast(){getMaxRows('getLast', false);}

		function getMaxRows(action,applied){			
			var prevPageSize =dojo.byId("pageSize").value;
			var currPageSize = dojo.byId("userInput_pageSize").value;	
			if(!applied && prevPageSize!=currPageSize){				
				alert("<fmt:message key='ui.analytics.Navigate' />");
				return false;
			}else{				
				dojo.byId("pageSize").value = currPageSize;
				dojo.byId("theAction").value = action;				
				showAllCrossTab();
			}											
		}

		//open help page
		function openHelp(){
			open( "<%=helpURL%>", "_blank" );	
		}

		function showFilters( bk){			
			var ht = 400;
			var wt = 550;
			var left = (screen.width/2)-(wt/2);
			var top = (screen.height/2)-(ht/2);	
			var frm = document.getElementById("crosstabListForm");
			var url ="/expensemap/crosstab/showFilterInfo.do?bkid="+bk; 
			window.open(url, "_blank", "resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
		}
		
		function hideProgressBar() {
			if(progressBar!=null){
				progressBar.hide();
			}
		}
		
		function showProgressBar() {
			progressBar.show();
		}		
		</script>
		
		
	</head>


<body class="claro yui-skin-sam">
	<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
	<jsp:include page="/jsp/topMenu.jsp">
		<jsp:param name="topMenuForm" value="CrosstabListForm"/>
	</jsp:include>  
	<div id="pb" style="visibility:hidden">
		<div class="hd" align="center" style="font-family: arial,helvetica,clean,sans-serif; font-size: 11px; color: darkblue;">
			<fmt:message key="ui.label.Processing.request"/>
		</div>
		<div class="bd" align="center"><img src="/expensemap/jsp/images/dimension-viewer-progressbar/rel_interstitial_loading_resized.gif" /></div>
	</div>		
	
<div id="containerDiv" class="container" >	
	<form:form action="/expensemap/showTabulationPage.xhtm" commandName="crosstabListForm" id="crosstabListForm">
			<jsp:include page="/jsp/includes/commonExportUI.jsp"/>
			<!-- Search Tabulation START --> 
			<table class="tableWithBorder">
				 <tr>
					<td class="headerText"><fmt:message key="rpt.crosstab.title" /></td>
					<td class="headerText" align="left"><fmt:message key="ui.usability.report.heading.datasetname" />:&nbsp;<%=cubeName.toUpperCase()%></td>	
					<td align="right">
						<a href="#" onclick="openHelp();">
							<img  src="/expensemap/jsp/images/help.gif" border="1" title="<fmt:message  key='ui.label.Help'/>"/>
						</a>						
					</td>
				</tr>
			</table>
			
			<div id="errorMsg_search" class="errorMsg"></div>
			<div id="searchDiv" class="searchContainer titleText" data-dojo-type="dijit/TitlePane" data-dojo-props="title: '<fmt:message key='ui.label.search' />',open:false,duration:1000" >
				<table width="" border="0" cellspacing="0" cellpadding="0" >
					<tr><td>
						<div class="searchComponentContainer">
							<div class="searchComponent">
								<fmt:message key="ui.crosstab.search.name"/> &nbsp;&nbsp;
								<input type="text" name="search.crosstabName" id="search_crosstabName" data-dojo-type="dijit/form/TextBox" data-dojo-props="trim:true"/>
							</div>							
							<div class="searchComponent">
								<fmt:message key="rpt.listing.search.fromDate"/>&nbsp;&nbsp;
								<input type="text" name="search.fromDateStr" id="search_FromDate" data-dojo-type="dijit/form/DateTextBox" constraints="{datePattern:'${userDatePattern}'}"/>
							</div>
							<div class="searchComponent">
								<fmt:message key="rpt.listing.search.toDate"/>&nbsp;&nbsp;
								<input type="text" name="search.toDateStr" id="search_ToDate" data-dojo-type="dijit/form/DateTextBox" constraints="{datePattern:'${userDatePattern}'}"/>							
							</div>
							<div class="searchComponent">
								<fmt:message key="ui.label.Created.By"/> &nbsp;&nbsp;
								<input type="text" name="search.createdBy" id="search_createdBy" data-dojo-type="dijit/form/TextBox" data-dojo-props="trim:true"/>
							</div>	
							<div class="searchComponent search_checkBox">
								<fmt:message key="ui.admin.dataset.status"/>:&nbsp;&nbsp;
								<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="completed" name="search.selectedStatuses" value="COMPLETED"/>&nbsp;<fmt:message key="ui.crosstab.search.Completed" />&nbsp;	
								<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="running" name="search.selectedStatuses" value="RUNNING" />&nbsp;<fmt:message key="ui.crosstab.search.Running" />&nbsp;
								<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="submitted" name="search.selectedStatuses" value="SUBMITTED" />&nbsp;<fmt:message key="ui.crosstab.search.Submitted" />&nbsp;
								<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="canceled" name="search.selectedStatuses" value="CANCELED" />&nbsp;<fmt:message key="ui.crosstab.search.Canceled" />&nbsp;
								<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="failed" name="search.selectedStatuses" value="FAILED" />&nbsp;<fmt:message key="ui.crosstab.search.Failed" />&nbsp;	
							</div>
						</div>
					</td></tr>
					<tr><td align="left" width="20%">				
						<div>
							<button data-dojo-type="dijit/form/Button" class="searchButton" id="search" name="search" type="button" >
								<fmt:message key="ui.label.search"/>
							</button>
							<button data-dojo-type="dijit/form/Button" class="searchButton" id="resetSearch" name="resetSearch" type="button" >
								<fmt:message key="button.reset"/>									
							</button>
						</div>	  
					</td></tr>
				</table>				
			</div>
			<!-- END OF SEARCH TITLE PANE-->
			
			<!-- GRID ELEMENTS -->
			<div id="errorMsg_grid" class="errorMsg"></div>
			<br>
			<div id="Grid_Div" name="Grid_Div" class="objectGridDiv"></div>
			<!-- GRID ELEMENTS -->

			<!-- Action Buttons -->

			<div id="actionContainerDiv" class="actionContainerDiv">
				
				<div class="actionButton">
					<button type="button" data-dojo-type="dijit/form/Button" id="showAll" name="showAll"><fmt:message key="ui.label.ShowAll"/></button>
					<button type="button" data-dojo-type="dijit/form/Button" id="refresh" name="refresh"><fmt:message key="ui.label.Refresh"/></button>
					<button type="button" data-dojo-type="dijit/form/Button" id="delete" name="delete"><fmt:message key="ui.label.Delete" /></button>
					<button type="button" data-dojo-type="dijit/form/Button" id="cancel" name="delete"><fmt:message key="ui.btn.cancel.reports" /></button>
				</div>
						
				<div id="topReortDiv" style="display:block; float:left;">
					<button data-dojo-type="dijit/form/Button" id="topReport" name="topReport" ><fmt:message key="button.SaveAsTopreports"/></button>					
					<div id="category_div"></div> &nbsp;
					<input type="checkbox" data-dojo-type="dijit/form/CheckBox" name="privateReport" id="privateReport" /> 
					<span><fmt:message key="ui.label.private.report"/></span>
				</div>

				
				<!--Paggination  -->
				<div id='pagination_div' class="paginationDiv">
					<img id="first" style="vertical-align:middle;"/> 
					<img id="prev" style="vertical-align:middle;"/> 
					<img id="next" style="vertical-align:middle;"/> 
					<img id="last" style="vertical-align:middle;"/> &nbsp;
					<label id="pagination_text"></label> &nbsp;
					<!--Msg need to externalized-->
					<input type="text" id="userInput_pageSize" required="true"
								   maxLength="3"									   
								   data-dojo-type="dijit/form/ValidationTextBox"
								   data-dojo-props="regExp:'\\d{0,3}',
													style:{width:'5em'},
													promptMessage: '<fmt:message key= 'ui.bookmark.grid.pagesize.promptmessage'/>',
													invalidMessage:'<fmt:message key= 'ui.alertmsg.rowsPerPage'/>',
													missingMessage:'<fmt:message key= 'ui.alertmsg.rowsPerPage'/>'														
													" />
							
					<button type="button" data-dojo-type="dijit/form/Button" id="applyPageSize" name="applyPageSize" ><fmt:message key="button.apply"/></button>
				</div>
				<!--Paggination -->

			</div>
			<!-- Action Buttons -->

			<form:hidden id="startRec" path="paginatoin.startRec" />
			<form:hidden id="pageSize" path="paginatoin.pageSize" />
			<form:hidden id="limitRec" path="paginatoin.limitRec" />
			<form:hidden id="totalRec" path="paginatoin.totalRec" />
			<form:hidden id="lastRecord" path="paginatoin.lastRecord" />						
			<form:hidden id="listSortColumnName" path="paginatoin.listSortColumnName" />
			<form:hidden id="listSortOrder" path="paginatoin.listSortOrder" />
			<form:hidden id="theAction" path="theAction"/>			
			<input type ='hidden' name="AuthCode" id="AuthCode" value="<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>"/>
			<input type ='hidden' name="numberFormat" id="numberFormat" value=""/>
			<input TYPE="hidden" NAME="userInputFileName" value="" />
			
	</form:form>
</div>
</body>
</html>