<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf"%>
<%@ page import="java.util.Locale"%>
<%@ page import="com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import ="com.zeborg.expensemap.view2.*,com.zeborg.expensemap.view.*"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.emptoris.viewer.ReportViewType"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle"%>
<%@ page import="org.owasp.esapi.ESAPI"%>
<%@ page import="com.emptoris.charts.ChartType"%>

<%

ZSession zs = ZSessionUtil.getZSession(pageContext);
Locale locale =zs.getUser().getLocale();
EmResourceBundle srcBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_SRC_RESOURCE_BUNDLE, locale);
String bkid = request.getParameter("bkid");
String helpURL = com.zeborg.expensemap.view.HelpUtil.getHelpUtil().getHelpURLString("ui.crosstab.preferences.help.page",locale);

String tabType = (String)request.getAttribute("viewType");
%>
<html>
<head>
<TITLE><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <%=srcBundle.getValue("ui.label.chart.preferences")%></TITLE>
<fmt:setBundle basename="ExpensemapMessagesBundle" />
<c:set var="displayNumberFormat" value="##.##" />	
 
 

<script type="text/javascript">

function initFrm(){
	//for enabling,disabling listBox according to checkbox(checked) 
	var currentTabType = "<c:out value='${requestScope.viewType}'/>";
		if(currentTabType=='chart'){
			document.getElementById('chartType').focus();
		}else if(currentTabType=='legend'){
			document.getElementById('showLegend').focus();
		}else if(currentTabType=='formatting'){
			document.getElementById('fontName').focus();					
		}

	enableDisableLegendPosition();

}

function savePreferences(){
        if(document.getElementById("chartType").value == ""){
		alert('<%=srcBundle.getValue("ui.label.select.err.msg")%>');
		document.getElementById("chartType").focus();
		return false;
	}
    var pieIndex = <%= ChartType.PIE.ordinal()%>;
    var pie3DIndex = <%= ChartType.PIE_3D.ordinal()%>;
	//validation for maxNoOfChars
	var msg='';
	var noOfChars  = trim(document.getElementById("numberOfCharacters").value);
	if(noOfChars == '') {
		msg = msg + "<bean:message key='ui.message.max.x.label.characters' bundle='dashboard' />" + "\n ";
		myTabs.selectTab(0);
		document.getElementById("numberOfCharacters").focus();
	} else if(!IsNumeric(noOfChars)) {
		msg=msg + "<bean:message key='ui.message.valid.value.max.x.label.characters' bundle='dashboard' />" + "\n";
		myTabs.selectTab(0);
		document.getElementById("numberOfCharacters").focus();
	}
	var temp = parseInt(noOfChars);
	if(temp == 0 || temp < 0){
		msg = msg + "<bean:message key='ui.message.zero.less.max.x.label.characters' bundle='dashboard' />" + "\n";
		myTabs.selectTab(0);
		document.getElementById("numberOfCharacters").focus();
	}

	var rot = document.getElementById("rotation").value;
	if(trim(rot)==''){
		msg=msg+"<bean:message key='ui.message.rotation' bundle='dashboard'/>  \n ";
		myTabs.selectTab(3);
		document.getElementById("rotation").focus();
	}else if(!IsNumeric(trim(rot))){
		msg=msg+"<bean:message key='ui.message.valid.value.rotation' bundle='dashboard'/>  \n ";
		myTabs.selectTab(3);
		document.getElementById("rotation").focus();
	}else if(!isWithinRange(trim(rot), -90, +90)){
		msg=msg+"<bean:message key='ui.message.valid.range.value.rotation' bundle='dashboard'/>  \n ";
		myTabs.selectTab(3);
		document.getElementById("rotation").focus();
	}

	var elev = document.getElementById("elevation").value;
	if(trim(elev)==''){
		msg=msg+"<bean:message key='ui.message.elevation' bundle='dashboard'/>  \n ";
		myTabs.selectTab(3);
		document.getElementById("elevation").focus();
	}else if(!IsNumeric(trim(elev))){
		msg=msg+"<bean:message key='ui.message.valid.value.elevation' bundle='dashboard'/>  \n ";
		myTabs.selectTab(3);
		document.getElementById("elevation").focus();
	}else if(!isWithinRange(trim(elev), -90, +90)){
		msg=msg+"<bean:message key='ui.message.valid.range.value.elevation' bundle='dashboard'/>  \n ";
		myTabs.selectTab(3);
		document.getElementById("elevation").focus();
	}	
	
	var dep = document.getElementById("depth").value;
	if(trim(dep)==''){
		msg=msg+"<bean:message key='ui.message.depth' bundle='dashboard'/>  \n ";
		myTabs.selectTab(3);
		document.getElementById("depth").focus();
	}else if(!IsNumeric(trim(dep))){
		msg=msg+"<bean:message key='ui.message.valid.value.depth' bundle='dashboard'/>  \n ";
		myTabs.selectTab(3);
		document.getElementById("depth").focus();
	}else if(!isWithinRange(trim(dep), 0, 100)){
		msg=msg+"<bean:message key='ui.message.valid.range.value.depth' bundle='dashboard'/>  \n ";
		myTabs.selectTab(3);
		document.getElementById("depth").focus();
	}

	var depg = document.getElementById("depthGap").value;
	if(trim(depg)==''){
		msg=msg+"<bean:message key='ui.message.depth.gap' bundle='dashboard'/>  \n ";
		myTabs.selectTab(3);
		document.getElementById("depthGap").focus();
	}else if(!IsNumeric(trim(depg))){
		msg=msg+"<bean:message key='ui.message.valid.value.depth.gap' bundle='dashboard'/>  \n ";
		document.getElementById("depthGap").focus();
		myTabs.selectTab(3);
	}else if(!isWithinRange(trim(depg), 0, 100)){
		msg=msg+"<bean:message key='ui.message.valid.range.value.depth.gap' bundle='dashboard'/>  \n ";
		myTabs.selectTab(3);
		document.getElementById("depthGap").focus();
	}

	var minValue  = trim(document.getElementById("yScaleMinValue").value);
	if(minValue == '') {
		msg = msg + "<bean:message key='ui.message.enter.min.value' bundle='dashboard' />" + "\n ";
		myTabs.selectTab(5);
		document.getElementById("yScaleMinValue").focus();
	} else if(!isDecimal(minValue)) {
		msg=msg + "<bean:message key='ui.message.valid.value.min.axis.option' bundle='dashboard' />" + "\n";
		myTabs.selectTab(5);
		document.getElementById("yScaleMinValue").focus();
	}
	
	var maxValue  = trim(document.getElementById("yScaleMaxValue").value);
	if(maxValue == '') {
		msg = msg + "<bean:message key='ui.message.enter.max.value' bundle='dashboard' />" + "\n ";
		myTabs.selectTab(5);
		document.getElementById("yScaleMaxValue").focus();
	} else if(!isDecimal(maxValue)) {
		msg=msg + "<bean:message key='ui.message.valid.value.max.axis.option' bundle='dashboard' />" + "\n";
		myTabs.selectTab(5);
		document.getElementById("yScaleMaxValue").focus();
	}
	
	if(!(document.getElementById("chartType").value == pieIndex || document.getElementById("chartType").value == pie3DIndex)){
		if(parseFloat(minValue) >= parseFloat(maxValue)) {
			msg=msg + "<bean:message key='ui.message.valid.value.min.max.axis.option' bundle='dashboard' />" + "\n";
			myTabs.selectTab(5);
			document.getElementById("yScaleMaxValue").focus();
		}
	}
	
	if(msg != '') {
		alert(msg);
		return false;
	}
	
	var frm = document.getElementById("tabulationPrefForm");
	frm.action = "/expensemap/crosstab/savePreferences.do?bkid="+"<%=ESAPI.encoder().encodeForJavaScript(bkid)%>"; 
	frm.submit();
}

/* This function will check if the given value is within min and max range.*/
function isWithinRange(val, min, max){
	if (val >= min && val <= max){
		return true;
	}else{
		return false;
	} 
}

function closePrefsWindow(){
window.close();
}

function trim(str, chars) {
    return ltrim(rtrim(str, chars), chars);
}

function ltrim(str, chars) {
    chars = chars || "\\s";
    return str.replace(new RegExp("^[" + chars + "]+", "g"), "");
}

function rtrim(str, chars) {
    chars = chars || "\\s";
    return str.replace(new RegExp("[" + chars + "]+$", "g"), "");
}

// Check for numeric value.
function IsNumeric(strString){
	var strValidChars = "0123456789-";
	var strChar;
	var blnResult = true;
	if (strString.length == 0) return false;
	//  test strString consists of valid characters listed above
	for (i = 0; i < strString.length && blnResult == true; i++){
		strChar = strString.charAt(i);
		if (strValidChars.indexOf(strChar) == -1) {
      		blnResult = false;
      	}
   }
   return blnResult;
}

// Generic function : returns true if number is valid  
// var tests = [1, '89 768', 1099511627776,20000000, 0, 1, "0", 0x0, 0x000, "0000", "0x89f", 8e5, 0x23, -0, 0.0, "1.0", 1.0, -1.5, 0.42, '075', "01", '-01', "0.", ".0", "a", "a2", true, false, "#000", '1.2.3', '#abcdef', '', "", "\n", "\t", '-', null, undefined];
function isNumber(n) {   
     return !isNaN(parseFloat(n)) && isFinite(n);
 }
 
function isDecimal(n) {
	return isNumber(n)
}

//Method used for enabling,disabling listBox according to checkbox(Legend visible)
function enableDisableLegendPosition(){
	var legendPosition=document.getElementById("legendPosition")
	var legend=document.getElementById("showLegend")
	if (legend.checked){
		legendPosition.disabled=false;
	}
	else{
		legendPosition.disabled=true;
	}
}

</script>
<style>
.panelHeadingStyle { font-family: Arial, Helvetica, sans-serif;font-weight:bold;font-size: 13px; color: #000000; text-align:left; background-color: #ECF4FE; }
.rowHeadingStyle { font-family: Arial, Helvetica, sans-serif;font-size: 12px; color: #000000; text-align:left; background-color: #ECF4FE; }
.infoStyle { font-family: Arial, Helvetica, sans-serif;font-size: 11px; color: red; text-align:left; background-color: #ECF4FE; }

table.my {background-color: #ECF4FE;border: 1px solid light gray;}
</style>

<!-- Dependencies -->
<!-- Sam Skin CSS for TabView -->
<link rel="stylesheet" type="text/css"
	href="/expensemap/jsp/javascript/yui/build/tabview/assets/skins/sam/tabview.css">
	<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/dashboardscss.css">
<!-- JavaScript Dependencies for Tabview: -->
<script type="text/javascript"
	src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript"
	src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<!-- OPTIONAL: Connection (required for dynamic loading of data) -->
<script type="text/javascript"
	src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<!-- Source file for TabView -->
<script type="text/javascript"
	src="/expensemap/jsp/javascript/yui/build/tabview/tabview-min.js"></script>
<script type="text/javascript">
//Instantiate Tab View
//divs appearing in markup below render tabs for the TabView
var myTabs = new YAHOO.widget.TabView("demo");
</script>
<style>
	.yui-navset {
		position: inherit;
}

</style>

</head>
<body class="yui-skin-sam" onload="javascript:initFrm();">
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
&nbsp;

<html:form action="/savePreferences.do" styleId="tabulationPrefForm" method="post">
<div style="float: right; z-index: 9999; text-align: right; width: 50px;">
	<IMG class=yuimenubaritemlabel onmouseover="MM_swapImage
	('helpIcon','','/expensemap/jsp/cap_area/btn_help_ovr.gif',1)" style="CURSOR: pointer; position:absolute; right:2" 
	onclick="window.open('<%=helpURL%>','help','')" 
	onmouseout=MM_swapImgRestore() title="<bean:message key='ui.label.Help' bundle='emMessages'/>"
	src="/expensemap/jsp/cap_area/btn_help_up.gif" name=helpIcon />
</div>

<div id="demo" class="yui-navset">
<ul class="yui-nav">
	<li class="selected"><a id="tabStyle" href="#tab1" ><em><bean:message key='ui.label.mainViewMode.Chart' bundle='dashboard' /></em></a></li>
	<li><a id="tabStyle" href="#tab2" ><em><bean:message key='ui.dashboard.label.gridlines' bundle='dashboard' /></em></a></li>
	<li><a id="tabStyle" href="#tab3" ><em><bean:message key='ui.dashboard.label.legend' bundle='dashboard' /></em></a></li>
	<li><a id="tabStyle" href="#tab4" ><em><bean:message key='ui.dashboard.label.threed.view' bundle='dashboard' /></em></a></li>
	<li><a id="tabStyle" href="#tab5" ><em><bean:message key='ui.dashboard.label.titles'bundle='dashboard' /></em></a></li>
	<li><a id="tabStyle" href="#tab6" ><em><bean:message key='ui.dashboard.label.formatting' bundle='dashboard' /></em></a></li>
</ul>
<div class="yui-content">
<!-- #tab1 : chart options -->
<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message bundle="crosstab" key="ui.label.Display.Type" />:</TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
			<html:select styleClass="controlStyleDDLB" name="tabulationPrefForm" size="1" property="chartType" styleId="chartType">
				<html:optionsCollection name="tabulationPrefForm" property="graphTypes" label="label" value="value" />
			</html:select>
		</TD>
	</TR>
	<TR>
<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.crosstab.label.max.x.characters' bundle='dashboard' /></TD>
	<TD rowspan="1" colspan="1" align="left" nowrap>
	<html:text name="tabulationPrefForm" property="numberOfCharacters" styleId="numberOfCharacters" size="5" maxlength="2" />
	</TD>			
</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.label.show.data.points' bundle='dashboard' /></TD>
		<TD NOWRAP  rowspan="1" colspan="1" align="left"><html:checkbox name="tabulationPrefForm" property="showDataPoints" styleId="showDataPoints" ></html:checkbox></TD>			
	</TR>

</TABLE>
</div>
<!-- #tab2 : grid lines options -->
<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.show.xgrid' bundle='dashboard' /></TD>
		<TD NOWRAP rowspan="1" colspan="1" align="left"><html:checkbox name="tabulationPrefForm" styleId="ygrid" property="ygrid" ></html:checkbox></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.show.ygrid' bundle='dashboard' /></TD>
		<TD NOWRAP rowspan="1" colspan="1" align="left"><html:checkbox name="tabulationPrefForm" property="xgrid" styleId="xgrid"></html:checkbox></TD>
	</TR>
</TABLE>
</div>
<!-- #tab3 : legend options -->
<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message
			key='ui.dashboard.label.show.legend' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:checkbox name="tabulationPrefForm" property="legendVisible" styleId="showLegend" onclick="enableDisableLegendPosition();" ></html:checkbox>
			
			</TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message
			key='ui.dashboard.label.legend.position' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:select name="tabulationPrefForm" size="1" style="width:185px" property="legendPosition" styleId="legendPosition" >
			<html:option value="TOP"><bean:message key="ui.dashboard.label.legend.position.top" bundle="dashboard"/></html:option>
			<html:option value="RIGHT"><bean:message key="ui.label.Right" bundle="dashboard"/></html:option>
			<html:option value="BOTTOM"><bean:message key="ui.dashboard.label.legend.position.bottom" bundle="dashboard"/></html:option>
			<html:option value="LEFT"><bean:message key="ui.label.Left" bundle="dashboard"/></html:option>
		</html:select></TD>
	</TR>
</TABLE>
</div>
<!-- #tab4 : 3D view options -->
<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.projection' bundle='dashboard' /></TD>
		<TD NOWRAP rowspan="1" colspan="1" align="left">
			<html:select name="tabulationPrefForm" size="1" style="width:185px" property="projection" styleId="projection" >
				<html:option value="1"><bean:message key="ui.dashboard.label.oblique" bundle="dashboard"/></html:option>
				<html:option value="0"><bean:message key="ui.dashboard.label.orthographic" bundle="dashboard"/></html:option>
			</html:select></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message	key='ui.dashboard.label.rotation' bundle='dashboard' /></TD>
		<TD NOWRAP class="infoStyle" rowspan="1" colspan="1" align="left"><html:text name="tabulationPrefForm" property="rotation" styleId="rotation" size="5" />&nbsp;<bean:message key="ui.dashboard.label.rotation.range" bundle="dashboard"/></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.elevation' bundle='dashboard' /></TD>
		<TD NOWRAP class="infoStyle" rowspan="1" colspan="1" align="left"><html:text name="tabulationPrefForm" property="elevation" styleId="elevation" size="5" />&nbsp;<bean:message key="ui.dashboard.label.elevation.range" bundle="dashboard"/></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.depth' bundle='dashboard' /></TD>
		<TD NOWRAP class="infoStyle" rowspan="1" colspan="1" align="left"><html:text name="tabulationPrefForm" property="depth" size="5" styleId="depth"/>&nbsp;<bean:message key="ui.dashboard.label.depth.range" bundle="dashboard"/></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.depth.gap' bundle='dashboard' /></TD>
		<TD NOWRAP class="infoStyle" rowspan="1" colspan="1" align="left"><html:text name="tabulationPrefForm" property="depthGap" styleId="depthGap" size="5"/>&nbsp;<bean:message key="ui.dashboard.label.depth.gap.range" bundle="dashboard"/></TD>
	</TR>
</TABLE>
</div>
<!-- #tab5 : tiltles options -->
<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.chart.title' bundle='dashboard' /></TD>
		<TD NOWRAP class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><html:text name="tabulationPrefForm" property="header" styleId="header" size="25"/></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.chart.footer' bundle='dashboard' /></TD>
		<TD NOWRAP class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><html:text name="tabulationPrefForm" property="footer" styleId="footer" size="25"/></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.xaxis.title' bundle='dashboard' /></TD>
		<TD NOWRAP rowspan="1" colspan="1" align="left"><html:text name="tabulationPrefForm" property="xtitle" styleId="xtitle" size="25"/></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message	key='ui.dashboard.label.yaxis.title' bundle='dashboard' /></TD>
		<TD NOWRAP class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><html:text name="tabulationPrefForm" property="ytitle" styleId="ytitle" size="25"/></TD>
	</TR>
</TABLE>
</div>
<!-- #tab6 : Formatting options -->
<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.font' bundle='dashboard' /></TD>
		<TD NOWRAP rowspan="1" colspan="1" align="left">
			<html:select name="tabulationPrefForm" size="1" style="width:185px" property="fontName" styleId="fontName">
				<html:option value="Arial"><bean:message key="ui.dashboard.label.arial" bundle="dashboard"/></html:option>
				<html:option value="Arial Black"><bean:message key="ui.dashboard.label.arialblack" bundle="dashboard"/></html:option>
				<html:option value="Arial Narrow"><bean:message key="ui.dashboard.label.arialnarrow" bundle="dashboard"/></html:option>
				<html:option value="Arial Rounded MT Bold"><bean:message key="ui.dashboard.label.arialroundedbold" bundle="dashboard"/></html:option>
				<html:option value="Courier"><bean:message key="ui.dashboard.label.courier" bundle="dashboard"/></html:option>
				<html:option value="Courier New"><bean:message key="ui.dashboard.label.couriernew" bundle="dashboard"/></html:option>
				<html:option value="default"><bean:message key="ui.label.Default" bundle="dashboard"/></html:option>
				<html:option value="Dialog"><bean:message key="ui.dashboard.label.dialog" bundle="dashboard"/></html:option>
				<html:option value="Times"><bean:message key="ui.dashboard.label.times" bundle="dashboard"/></html:option>
				<html:option value="Times New Roman"><bean:message key="ui.dashboard.label.timesnewroman" bundle="dashboard"/></html:option>
				<html:option value="Verdana"><bean:message key="ui.dashboard.label.verdana" bundle="dashboard"/></html:option>
			</html:select></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.font.style' bundle='dashboard' /></TD>
		<TD NOWRAP rowspan="1" colspan="1" align="left">
			<html:select name="tabulationPrefForm" size="1" style="width:185px" property="fontStyle" styleId="fontStyle" >
				<html:option value="0"><bean:message key="ui.dashboard.label.regular" bundle="dashboard"/></html:option>
				<html:option value="1"><bean:message key="ui.dashboard.label.bold" bundle="dashboard"/></html:option>
				<html:option value="2"><bean:message key="ui.dashboard.label.italic" bundle="dashboard"/></html:option>
				<html:option value="3"><bean:message key="ui.dashboard.label.bolditalic" bundle="dashboard"/></html:option>
			</html:select></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.font.size' bundle='dashboard' /></TD>
		<TD NOWRAP rowspan="1" colspan="1" align="left">
			<html:select name="tabulationPrefForm" size="1" style="width:185px" property="fontSize" styleId="fontSize" >
				<html:option value="7"><bean:message key="ui.dashboard.label.seven" bundle="dashboard"/></html:option>
				<html:option value="8"><bean:message key="ui.dashboard.label.eight" bundle="dashboard"/></html:option>
				<html:option value="9"><bean:message key="ui.dashboard.label.nine" bundle="dashboard"/></html:option>
				<html:option value="10"><bean:message key="ui.dashboard.label.ten" bundle="dashboard"/></html:option>
				<html:option value="11"><bean:message key="ui.dashboard.label.eleven" bundle="dashboard"/></html:option>
				<html:option value="12"><bean:message key="ui.dashboard.label.twelve" bundle="dashboard"/></html:option>
				<html:option value="13"><bean:message key="ui.dashboard.label.thirteen" bundle="dashboard"/></html:option>
				<html:option value="14"><bean:message key="ui.dashboard.label.fourteen" bundle="dashboard"/></html:option>
				<html:option value="15"><bean:message key="ui.dashboard.label.fifteen" bundle="dashboard"/></html:option>
				<html:option value="16"><bean:message key="ui.dashboard.label.sixsteen" bundle="dashboard"/></html:option>
				<html:option value="17"><bean:message key="ui.dashboard.label.seventeen" bundle="dashboard"/></html:option>
				<html:option value="18"><bean:message key="ui.dashboard.label.eighteen" bundle="dashboard"/></html:option>
				<html:option value="19"><bean:message key="ui.dashboard.label.nineteen" bundle="dashboard"/></html:option>
				<html:option value="20"><bean:message key="ui.dashboard.label.twenty" bundle="dashboard"/></html:option>
				<html:option value="21"><bean:message key="ui.dashboard.label.twentyone" bundle="dashboard"/></html:option>
			</html:select></TD>
	</TR>
<TR>
<TD class="rowHeadingStyle" rowspan="1" colspan="2" align="left"><b><bean:message
			key='ui.label.axis.options' bundle='dashboard' /></b></TD>
</TR>
<TR>
<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.label.axis.option.min.value' bundle='dashboard' /></TD>
	<TD rowspan="1" colspan="1" align="left" nowrap>
	<fmt:formatNumber pattern="${displayNumberFormat}" value="${tabulationPrefForm.yScaleMinValue}" var="yScaleMinValue_fmt"/>	
	<html:text name="tabulationPrefForm" property="yScaleMinValue" styleId="yScaleMinValue" size="16" maxlength="16" value="${yScaleMinValue_fmt}"  />
	</TD>
</TR>
<TR>
<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.label.axis.option.max.value' bundle='dashboard' /></TD>
	<TD rowspan="1" colspan="1" align="left" nowrap>
	<fmt:formatNumber pattern="${displayNumberFormat}" value="${tabulationPrefForm.yScaleMaxValue}" var="yScaleMaxValue_fmt"/>	
	<html:text name="tabulationPrefForm" property="yScaleMaxValue" styleId="yScaleMaxValue" size="16" maxlength="16" value="${yScaleMaxValue_fmt}"  />
	</TD>			
</TR>
</TABLE>
</div>

</div>
</div>
<TABLE class="my" width="100%">
	<TR>
		<TD rowspan="1" colspan="1" align="right" nowrap>
		<html:button property="saveButton" onclick="javascript:return savePreferences();"><bean:message
			key='ui.label.Save' bundle='dashboard' /></html:button>
		</TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:button property="cancelButton" onclick="javascript:closePrefsWindow();"><bean:message
			key='ui.label.Cancel' bundle='dashboard' /></html:button>
		</TD>
	</TR>
</TABLE>
<html:hidden name="tabulationPrefForm" property="chartStateId" styleId="chartStateId"/>
<html:hidden name="tabulationPrefForm" property="viewType" styleId="viewType"/>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>

</html:form>
</body>
</html>
