<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%@include file="../includes/tlib.jspf"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession" %>
<%@ page import="com.zeborg.expensemap.view2.TableView" %>
<%@ page import="com.zeborg.cubem.model.EMDimensionPreferences" %>
<%@ page import="java.util.List, org.apache.struts.Globals" %>
<%@ page import="java.util.ArrayList, com.emptoris.viewer.util.CSRFHelper" %>
<%@ page import="com.zeborg.cubem.model.EMChartState" %>
<%@ page import="com.zeborg.cubem.model.EMCrossTabDimensionDetails" %>
<%@ include file="../begin_page.jspf"%>
<%    
	//call addtype so that UTF-8 will be set as the encoding for all jsp pages
	WebUtil.addNoCache(response);
	WebUtil.addType(response, request);	
	EMChartState state = zs.getChartState();
    List<Integer> dimVals = new ArrayList<Integer>();
    List<String> allDims = new ArrayList<String>();
    List<Integer> dimLevels = new ArrayList<Integer>();
    List<Integer> selDimLevels = new ArrayList<Integer>();
    
    for (TableView tv : zs.getContextView().getTableViews() ) {
    	EMDimensionPreferences dimPref = tv.getDimensionPreferences();
    	int selectedLevel = 0, selectedVal = dimPref.getTopN();
		// Commented the below if as part of the defect EXP-11086 fix.
		//if (dimPref.isVisible()) {
			if (state != null && state.isOverride()) {
					boolean found = false;
					List<EMCrossTabDimensionDetails> rowList = state.getRowDimensions();
					List<EMCrossTabDimensionDetails> colList = state.getColumnDimensions();
					for (EMCrossTabDimensionDetails item : rowList) {
						if (item.getDimensionMeta().getName().equals(dimPref.getDimensionMeta().getName())) {
							selectedLevel = item.getMaxLevelNodeToDisplay()-1;
							selectedVal = item.getMaxNoOfRowToDisplay();
							found = true;
						}
					}
					if (!found) {
						for (EMCrossTabDimensionDetails item : colList) {
							if (item.getDimensionMeta().getName().equals(dimPref.getDimensionMeta().getName())) {
								selectedLevel = item.getMaxLevelNodeToDisplay()-1;
								selectedVal = item.getMaxNoOfRowToDisplay();
								found = true;
							}
						}
					}
			}	
			dimVals.add(selectedVal);
			allDims.add(tv.getDimension().getName());
			dimLevels.add(tv.getDimension().getLevels());
			selDimLevels.add(selectedLevel);
		//}
    }
%>

<HTML>
<HEAD>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<link REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/css/spend-one-ui-theme.css">

<STYLE type="text/css">
.POPTD {
		BORDER: #B3B3B3 1px outset;
		border-collapse: collapse;
		font-family: Arial, Helvetica, sans-serif;
		font-size: 11px;
}
.controlStyleDDLB { font-family: Arial, Helvetica, sans-serif; font-size: 11px; color: #000000;}
.POPTABLE {
		BORDER: gray 1px outset;
		border-collapse: collapse;
}
.dimTitle { font-family:Arial, Helvetica, sans-serif; font-size:13px; }
.WAIT_PAGE{FONT-WEIGHT:NORMAL; FONT-SIZE:10pt;COLOR:#7B799C; FONT-FAMILY:arial, helvetica, sans-serif;}
.LATER_PAGE{FONT-WEIGHT:NORMAL; FONT-SIZE:14pt;COLOR:#FF0000; FONT-FAMILY:arial, helvetica, sans-serif;}
form { padding:0; margin: 0; }
#noOfRowColTR { display: none }
</STYLE>

<SCRIPT LANGUAGE="JavaScript">
 //Implementing a trim function for strings in javascript
 //White space in regular expressions is described as \s. 
 //The beginning of the string is matched by ^ (see the first regex) 
  //and the end is matched by $ - in the second regex. 
	function trim(value) {
		return value.replace(/^\s*/, "").replace(/\s*$/, "");
	}


//Submit new crosstab request.
function submitCrosstabForm() {
	var frm = document.createCrosstabForm;
 	var returnValue = validateCrosstabForm(); 	
	var editCrosstab='${ editcrosstab }';
	var bkid = '${ bkid }';
 	if(returnValue ){
		document.getElementById("btnSubmit").disabled=true;
		if(editCrosstab){
			if (confirm("<bean:message key='ui.confirm.override.tabulation'/>")) {
				frm.action = "/expensemap/crosstab/saveCrosstab.do?edit=true&bkid="+bkid;
			}else{
				document.getElementById("btnSubmit").disabled=false;
				return;
			}
		}else{
			frm.action = "/expensemap/crosstab/saveCrosstab.do";
		}
 		frm.submit();
 	}
}

//Validate form before submit.
function validateCrosstabForm() {
	var isValid=true;
	var name = document.getElementById("name");
	if ( trim(name.value) == '' ) {
		alert("<bean:message key='ui.ruleform.reportname.label' bundle='crosstab'/>");
		name.value='';
		name.focus();
	    return false;
	}
	if(!validateSelectedMeasures()){
    	alert("<bean:message key='crosstab.form.measure.not.selected' bundle='crosstab'/>");
    	return false;
  	}
	 
	
	//Check Max row column  validation end
  	if ( checkDropDowns() ) {
   		var valid = validatePrefValues();
		if(valid){
			return true;
		}else{
			return false;
		}
    } else {
    	return false;
    }

	return isValid;
}

//Check if at least one measure is selected to display. Valid only in table mode.
function validateSelectedMeasures() {
	var validSelection = false;
	var displayType = document.getElementById("displayChart");
	if(!displayType.checked){
		return true; //graph type
	}
	var measureSize = document.getElementById("createCrosstabForm").selectedMeasures.length;
	if(measureSize){
		for (i = 0; i < measureSize; i++) {
			var obj = document.getElementById("createCrosstabForm").selectedMeasures[i];
			if(obj.checked){
				validSelection = true;
			}
		}
	} else {
		//single measure
		if(document.getElementById("selectedMeasures").checked) {
			validSelection = true;
		}
	}
	return validSelection;
}

//Validate selected dimensions. If they are equal, show error message.
function checkDropDowns() {
	var maxCol = document.getElementById("maxNoOfColumn").value;
	var contentType = document.getElementById("contentType");
	var selectedColDim = new Array();
	var selectedRowDim = new Array();
	var maxRow ;	
	if (contentType.checked == true){
		maxRow = document.getElementById("maxPivotTableRows").value;
	}else{
		maxRow = document.getElementById("maxNoOfRows").value;
	}
	for(i=0; i < maxRow; i++ ){
		selectedRowDim[i] = document.getElementById("selectedRowDimension_" + (i+1)).value;	
	}	
	for(i=0; i < maxCol; i++ ){
		selectedColDim[i] = document.getElementById("selectedColumnDimension_" + (i+1)).value;		
	}
	
	var displayType = document.getElementById("displayChart");
	var selectedColumnDimension1 = null;
	var selectedColumnDimension2 = null;
	
	if (selectedColDim != null ) {
		selectedColumnDimension1 = selectedColDim[0];
		selectedColumnDimension2 = selectedColDim[1];
	}
	
	var selectedRowDimension1 = selectedRowDim[0];
	var selectedRowDimension2 = selectedRowDim[1];
	
	var contentType = document.getElementById("contentType");	
	if (contentType.checked == true && selectedRowDimension2.toLowerCase()=="none") {
	    alert("<bean:message key='crosstab.valid.row.dimension.required' bundle='crosstab'/>");
	    return false;
    	}
    	
 	if(selectedColumnDimension1 != null && selectedColumnDimension2 != null && (selectedColumnDimension1.toLowerCase() == selectedColumnDimension2.toLowerCase())&&(!displayType.checked)) {
		alert("<bean:message key='crosstab.graph.view.not.supported' bundle='crosstab'/>");
		return false;
	} 	
	 //if there is 2*1 or 2*2 table and viw selected is graph ,then show alert message.
	else if(selectedColumnDimension1 != null && !(selectedRowDimension1.toLowerCase()=="none") && !(selectedRowDimension2.toLowerCase()=="none") && !(selectedColumnDimension1.toLowerCase()=="none") && (!displayType.checked)){
		alert("<bean:message key='crosstab.graph.view.not.supported' bundle='crosstab'/>");
		return false;
    } else if(selectedColumnDimension1 != null && selectedColumnDimension2 != null && 
    		!(selectedRowDimension1.toLowerCase()=="none") && !(selectedRowDimension2.toLowerCase()=="none")&&!(selectedColumnDimension1.toLowerCase()=="none") &&!(selectedColumnDimension2.toLowerCase()=="none") && (!displayType.checked)){
		alert("<bean:message key='crosstab.graph.view.not.supported' bundle='crosstab'/>");
		return false;
    } else if(selectedColumnDimension1 != null && selectedColumnDimension2 != null && 
    		!(selectedRowDimension1.toLowerCase()=="none") && !(selectedColumnDimension1.toLowerCase()=="none") &&!(selectedColumnDimension2.toLowerCase()=="none") &&(!displayType.checked)){
		alert("<bean:message key='crosstab.graph.view.not.supported' bundle='crosstab'/>");
		return false;
    } else if (selectedColumnDimension1 != null && selectedColumnDimension1.toLowerCase() == "none" && selectedRowDimension2.toLowerCase() == "none") {
		alert("<bean:message key='crosstab.valid.dimension.required' bundle='crosstab'/>");
		return false;
    }  else if ((selectedColumnDimension1 == null || selectedColumnDimension1=="none") && selectedRowDimension2.toLowerCase()=="none") {
		alert("<bean:message key='crosstab.valid.dimension.required' bundle='crosstab'/>");
		return false;
    }
    
	for(i=0;i< selectedRowDim.length;i++){		
		if(selectedRowDim[i] =="None"){
			continue;
		}
		for(j=0;j< selectedRowDim.length;j++){
			if(i==j ){
				continue;
			}
			if(selectedRowDim[i]==selectedRowDim[j]){
				alert("<bean:message key='ui.message.Please.select.different.Row.dimensions.to.view.Thank.you' bundle='crosstab'/>");
				return false;
			}
		}
		
		if (contentType.checked == false && selectedColDim != null) {
			for(j=0;j< selectedColDim.length;j++){
				if(selectedRowDim[i]==selectedColDim[j]){
					alert("<bean:message key='ui.message.Please.select.different.Row.and.Column.dimensions.to.view.Thank.you' bundle='crosstab'/>");
					return false;
				}
			}
		}
	}
	if (contentType.checked == false && selectedColDim != null) {
		for(i=0;i<selectedColDim.length;i++){
			if(selectedColDim[i] =="None"){
				continue;
			}
			for(j=0;j<selectedColDim.length;j++){
				if(i==j ){
					continue;
				}
				if(selectedColDim[i]==selectedColDim[j]){					
					alert("<bean:message key='ui.message.Please.select.different.Column.dimensions.to.view.Thank.you' bundle='crosstab'/>");
					return false;
				}
			}
		}
	}
   	return true;
}
// Global variables to maintain INNER HTML fragments for Measure selection.
var chkMsr;
var drpMsr;

// initialition method
function init() {
	var prefDispChart = ${ createCrosstabForm.displayChart};
	var overridePrefs = ${ createCrosstabForm.overridePreferences };
	var editCrosstab = '${ editcrosstab }';
	if(editCrosstab && document.getElementById("crosstabTypeTop").checked ){
		document.getElementById("crosstabTypeOrig").disabled=true;
	}
	// On init load the INNER HTML values into global variable.
	chkMsr = document.getElementById("displayMeasuresChk").innerHTML;
	document.getElementById("displayMeasuresChk").innerHTML = '';
	drpMsr = document.getElementById("displayMeasuresDrdw").innerHTML;
	document.getElementById("displayMeasuresDrdw").innerHTML = '';
	toggleDiv(prefDispChart);
	document.getElementById("prefType").value='restrict';
	
	var pivottablerowdiv = document.getElementById("ptabrowdiv");
	var rowvaldiv = document.getElementById("rowValDiv");

	pivottablerowdiv.style.display = 'none';
	rowvaldiv.style.display = 'none';
	
	
	//togglePrefDiv(overridePrefs);
	if ( overridePrefs ) {
		selectPreferenceType("override");
	}
	
	var contentType = document.getElementById("contentType");

	if (contentType.checked == true) {
		displayPivotTable();
	}
	document.getElementById("name").focus();
}

//Toggle div's for TABLE & GRAPH selection.
function toggleDiv(prefDispChart) {
	
	var measuresTD = document.getElementById("measures");
	if ( prefDispChart ) {
		measuresTD.innerHTML = drpMsr;
	} else {
		measuresTD.innerHTML = chkMsr;
	}
}

//These arrays are used for dimensions to Levels & No of rows to display values 
var allNameArray = new Array();
var allDimLevelArray = new Array();
var allDimValueArray = new Array();
var selDimLevelsArray = new Array();

<%for(int i=0;i < allDims.size();i++){%>
	allNameArray[<%=i%>] = '<%=allDims.get(i)%>';
	allDimLevelArray[<%=i%>] = <%=dimLevels.get(i)%>;
	allDimValueArray[<%=i%>] = <%=dimVals.get(i)%>;
	selDimLevelsArray[<%=i%>] = <%=selDimLevels.get(i)%>;
<%}%>

//Show level, value div's if override preference option is selected. otherwise they will be hidden.
function selectPreferenceType(selVal){
	var noOfRowColTR = document.getElementById("noOfRowColTR");
	var val1div = document.getElementById("val1div");	
	var prefType = document.getElementById("prefType");
	var contentType = document.getElementById("contentType");
	var rowvaldiv = document.getElementById("rowValDiv");
	var colvaldiv = document.getElementById("colValDiv");
	
		
	if(selVal=='override') {
		noOfRowColTR.style.display = 'table-row';
		val1div.style.visibility = 'visible';
		val1div.style.display = '';
		if (contentType.checked == true) {
			rowvaldiv.style.visibility = 'visible';
			rowvaldiv.style.display = '';
		} else {
			colvaldiv.style.visibility='visible';
		}
		
		prefType.value = selVal;
		setDimensionLevels();
	} else {
		noOfRowColTR.style.display='none';
		val1div.style.visibility='hidden';
		val1div.style.display = 'none';
		rowvaldiv.style.visibility = 'hidden';
		rowvaldiv.style.display = 'none';
		colvaldiv.style.visibility='hidden';
		prefType.value = 'restrict';
	}	 
}

//Set the dimension levels.
function setDimensionLevels() {
	var XAxisDim = new Array(); 
	var YAxisDim = new Array();
	var xDimArray = new Array();
	var yDimArray = new Array();	
	var maxCol = document.getElementById("maxNoOfColumn").value;
	var maxRow ;
	var contentType = document.getElementById("contentType");
	if (contentType.checked == true){
		maxRow = document.getElementById("maxPivotTableRows").value;
	}else{
		maxRow = document.getElementById("maxNoOfRows").value;
	}

	for(i=0; i < maxCol; i++ ){
		xDimArray[i] = document.getElementById("selectedColumnDimension_" + (i+1));
	}
	if (xDimArray != null ) {
		for(i=0 ; i < xDimArray.length ; i++){
			obj = xDimArray[i];
			for (j=0; j<obj.options.length; j++) {
				if (obj.options[j].selected) {
					XAxisDim[XAxisDim.length] = obj.options[j];
					break;
				}
			}
		}
	}

	for(i=0; i < maxRow; i++ ){
		yDimArray[i] = document.getElementById("selectedRowDimension_" + ( i + 1 ));
	}
	
	for(i = 0 ; i < yDimArray.length ; i++){
		obj = yDimArray[i];
		for (j=0; j<obj.options.length; j++) {
			if (obj.options[j].selected) {
				YAxisDim[YAxisDim.length] = obj.options[j];
				break;
			}
		}	
	}

	for(i=0;i<XAxisDim.length;i++){
		var selectedColumnDimensionLevelObject = document.getElementById("selectedColumnDimensionLevel_" + ( i + 1 ));
		var selectedColumnDimensionValObject = document.getElementById("selectedColumnDimensionVal_" + ( i + 1 ));
		if(XAxisDim[i].value!="None"){
			var xLevel=getLevelsBydimensionId(XAxisDim[i]);
			var xSelLevel=getSelLevelByDimId(XAxisDim[i]);	
			var value = getValueByDimId(XAxisDim[i]);
			
			for(j=1;j<=xLevel;j++) {
				selectedColumnDimensionLevelObject.options[j-1]=new Option(j-1,j);	  	     
			}
			selectedColumnDimensionLevelObject.options[xSelLevel].selected=true;	 
			selectedColumnDimensionValObject.value= value;
			selectedColumnDimensionLevelObject.disabled=false;
			selectedColumnDimensionValObject.disabled=false;
		 }else{
		 	 selectedColumnDimensionLevelObject.options[0]=new Option(0,1);
		 	 selectedColumnDimensionLevelObject.options[0].selected=true;
			 selectedColumnDimensionLevelObject.disabled=true;
			 selectedColumnDimensionValObject.value ='';
			 selectedColumnDimensionValObject.disabled=true;
		 }
	}
	
	for(i=0;i<YAxisDim.length;i++){
		var selectedRowDimensionLevelObject = document.getElementById("selectedRowDimensionLevel_" + (i+1));
		var selectedRowDimensionValObject = document.getElementById("selectedRowDimensionVal_" + (i+1));
		if(YAxisDim[i].value!="None"){
			var yLevel=getLevelsBydimensionId(YAxisDim[i]);
			var ySelLevel=getSelLevelByDimId(YAxisDim[i]);	
			var value = getValueByDimId(YAxisDim[i]);
			for(j=1;j<=yLevel;j++) {
				selectedRowDimensionLevelObject.options[j-1]=new Option(j-1,j);	  	     
			}
			selectedRowDimensionLevelObject.options[ySelLevel].selected=true;	 
			selectedRowDimensionValObject.value= value;
			selectedRowDimensionLevelObject.disabled=false;
			selectedRowDimensionValObject.disabled=false;
		 }else{
		 	 selectedRowDimensionLevelObject.options[0]=new Option(0,1);
		 	 selectedRowDimensionLevelObject.options[0].selected=true;
			 selectedRowDimensionLevelObject.disabled=true;
			 selectedRowDimensionValObject.value ='';
			 selectedRowDimensionValObject.disabled=true;
		 }
	}
	
}

//Get Dimension levels
function getLevelsBydimensionId(dimId) {
	for(var j=0; j < allNameArray.length; j++ ){
		if (dimId.value.toLowerCase() == allNameArray[j].toLowerCase() ) {
			return allDimLevelArray[j];
		}
	}
}

//Get Dimension value. i.e. no of rows to display for a dimension
function getValueByDimId(dimId) {
	for(var i=0; i < allNameArray.length; i++) {
		if(dimId.value.toLowerCase() == allNameArray[i].toLowerCase()) {
			return allDimValueArray[i];
		}
	}
}

//Get selected level for dimension.
function getSelLevelByDimId(dimeId) {
	for(var j=0; j<allNameArray.length; j++ ) {
		if (dimeId.value.toLowerCase() == allNameArray[j].toLowerCase() ) {
			return selDimLevelsArray[j];
		}
	}	
}

//Validate no of rows to display field.
function validatePrefValues(){	
	var prefValue = document.getElementById("prefType").value;
	if(prefValue == 'restrict'){
		return true;
	}
	if(prefValue == 'override'){
		var x=true;var y=true;var x1=true;var y1=true;
		var isErrorMsg = false;
		var msg='';
		var selectedColumnDimension = new Array();
		var selectedRowDimension = new Array();
		var selectedColumnDimensionVal = new Array();
		var selectedRowDimensionVal = new Array();

		var maxCol = document.getElementById("maxNoOfColumn").value;

		for(i=0; i < maxCol; i++ ){
			selectedColumnDimension[i] = document.getElementById("selectedColumnDimension_" + ( i + 1)).value;
			selectedColumnDimensionVal[i] = document.getElementById("selectedColumnDimensionVal_" + (i+1));
		}		

		var maxRow ;
		var contentType = document.getElementById("contentType");
		if (contentType.checked == true){
			maxRow = document.getElementById("maxPivotTableRows").value;
		}else{
			maxRow = document.getElementById("maxNoOfRows").value;
		}
		for(i=0; i < maxRow; i++ ){
			selectedRowDimension[i] = document.getElementById("selectedRowDimension_" + ( i + 1)).value;
			selectedRowDimensionVal[i] =  document.getElementById("selectedRowDimensionVal_" + (i + 1));
		}		
		
		for(i=0, j=1;i<selectedRowDimension.length;i++,j++){			
			if(selectedRowDimension[i] != "None"){
				y = validateNumeric(selectedRowDimensionVal[i]);
				if(y == false) {
					msg = msg + "<bean:message key='ui.message.enter.non.zero.positive.integer.value.for' bundle='crosstab'/>" + "<bean:message key='ui.label.row' bundle='crosstab'/>" + j + "\n";
					isErrorMsg = true;
				}
			}
		}
		if (!contentType.checked  && selectedColumnDimension != null ) {
			for(i=0, j=1;i<selectedColumnDimension.length;i++, j++){
				if(selectedColumnDimension[i] != "None"){
					x = validateNumeric(selectedColumnDimensionVal[i]);
					if(x==false){
						msg =  msg + "<bean:message key='ui.message.enter.non.zero.positive.integer.value.for' bundle='crosstab'/>" + "\n" +"<bean:message key='ui.label.column' bundle='crosstab'/>" + j + "\n";
						isErrorMsg = true;
					}
				}
			}
		}
		if(isErrorMsg){		
			alert(msg);
			return false;
		}
		return true;		
	}
}

//validate if entered value is numeric.
function validateNumeric(obj){	
	var val = obj.value;
	if(val == "null" || val == null || val=='' || val ==""){
		obj.focus();
	   	return false;	
	}
	var iValue = parseInt(val);
	if (isNaN(iValue)){
		obj.focus();
		return false;	
	}
    if((iValue <= 0 || iValue >= 2147483647)) {
		obj.focus();
		return false;	
    }
	if (val != null && val.length > 0){
		val = val.toString();
		var validChars = "0123456789";
		var startFrom = 0;
		for (var n = startFrom; n < val.length; n++){
			if (validChars.indexOf(val.substring(n, n+1)) == -1){
				obj.focus();
				return false;	
			}
		}	 
		return true;
	}
	return true;
}

//to validate the dimension selection
function checkIfpreviousSelected(name ,index) {
	var totalElement;
	if(name=='selectedRowDimension'){
		// for row dimension
		var contentType = document.getElementById("contentType");
		if (contentType.checked == true){
			totalElement = document.getElementById("maxPivotTableRows").value;
		}else{
			totalElement = document.getElementById("maxNoOfRows").value;
		}
	}else{
		// for col dimension.		
		totalElement = document.getElementById("maxNoOfColumn").value
	}	

	if(document.getElementById(name + "_" + index ).value=='None' && index < totalElement ){		
		for (i = index ; i < totalElement ; i++){	
			document.getElementById(name + "_" + (i+1) ).selectedIndex = 0 ;
			document.getElementById(name + "Level" + "_" + (i+1)).length = 1 ;
			document.getElementById(name + "Level" + "_"  + (i+1)).options[0] = new Option(0,0);
			document.getElementById(name + "Val" + "_" + (i+1)).value = "";
			document.getElementById(name + "Level" + "_" + (i+1)).disabled = true;
			document.getElementById(name + "Val" + "_" + (i+1)).disabled = true;

		}
	}
	if(index > 1)
		for(i = index - 1 ; i > 0 ; i-- ){
			var currentElement = document.getElementById(name + "_" + i);
			var userSelectedElement = document.getElementById(name + "_" + ( i + 1 ));
			if(userSelectedElement.value!='None' && (currentElement.value =='' || currentElement.value =='None')) {
				alert("<bean:message key='ui.select.previous.option.first' bundle='crosstab'/>");
				userSelectedElement.selectedIndex = 0;
				return false;
			}		
		}
  return true;
} 

function displayPivotTable() {
	var contentType = document.getElementById("contentType");
	var pivottablecolumndiv = document.getElementById("ptabcoldiv");
	var pivottablerowdiv = document.getElementById("ptabrowdiv");
	var rowvaldiv = document.getElementById("rowValDiv");
	var colvaldiv = document.getElementById("colValDiv");
	var selectedRowDimension = new Array();

	var maxRow ;
	var contentType = document.getElementById("contentType");
	if (contentType.checked == true){
		maxRow = document.getElementById("maxPivotTableRows").value;
	}else{
		maxRow = parseInt(document.getElementById("maxNoOfRows").value);
		var maxPivotTableRows = parseInt(document.getElementById("maxPivotTableRows").value);
		var diff = maxPivotTableRows - maxRow;
		for (i=1; i<=diff; i++){
			document.getElementById("selectedRowDimension_"+(maxRow+i)).value = "None";
		}
	}
	
	for(i=0; i < maxRow; i++ ){
		selectedRowDimension[i] = document.getElementById("selectedRowDimension_" + (i+1)).value;
	}	

	var prefValue = document.getElementById("prefType").value;
	
	if (contentType.checked == true) {
		pivottablerowdiv.style.visibility = 'visible';
		pivottablecolumndiv.style.visibility = 'hidden';
		colvaldiv.style.visibility = 'hidden';
		
		pivottablerowdiv.style.display = '';
		
		if (prefValue == 'override') {
			rowvaldiv.style.visibility = 'visible';
			rowvaldiv.style.display = '';
			setDimensionLevels();
		} else {
			rowvaldiv.style.visibility = 'hidden';
			rowvaldiv.style.display = 'none';
		}
	} else {
		pivottablerowdiv.style.visibility = 'hidden';
		pivottablecolumndiv.style.visibility = 'visible';
		rowvaldiv.style.display = 'none';
		pivottablerowdiv.style.display = 'none';
		if (prefValue == 'override') {
			colvaldiv.style.visibility = 'visible';
		} else {
			colvaldiv.style.visibility = 'hidden';
		}
		rowvaldiv.style.visibility = 'hidden';
		//Make selected dimensions more that maxNoOfRows to null.
		for(i=maxRow; i < selectedRowDimension.length; i++){
			if(selectedRowDimension[i].toLowerCase() != "none"){
				selectedRowDimension[i]= "None";
			}
		}		
	}
}

//Update levels upon dimension selection.
function changeDimLevels(obj,index,name){
	if(!checkIfpreviousSelected(name , index)){
	  return;
	}	
	var dimName = obj.value;
	if(dimName != "None") {				
		document.getElementById(name + "Level" + "_" + index).disabled= false;
		document.getElementById(name + "Level" + "_" + index).length = 0;
		document.getElementById(name + "Val" + "_" + index).disabled= false;
		document.getElementById(name + "Val" + "_" + index).value = getValueByDimId(obj);
		var level=getLevelsBydimensionId(obj);
		var selevel=getSelLevelByDimId(obj);
	} else {
		document.getElementById(name + "Level" + "_" + index).length = 1;
		document.getElementById(name + "Level" + "_" + index).options[0] = new Option(0,0);
		document.getElementById(name + "Level" + "_" + index).disabled = true;
		document.getElementById(name + "Val" + "_" + index).value = "";
		document.getElementById(name + "Val" + "_" + index).disabled = true;
	}
	
	for( i = 1 ; i <= level;i++)
	{
	    document.getElementById(name + "Level" + "_" + index).options[i-1] = new Option(i-1,i);
	}
	if(dimName!="None"){
		document.getElementById(name + "Level" + "_" + index).options[0].selected=true;
	}
}





</SCRIPT>

</HEAD>

<jsp:include page="../chart/chartToolBar.jsp">
	<jsp:param name="displayType" value="" />
	<jsp:param name="ctId" value="" />
	<jsp:param name="viewCrossTab" value="" />
	<jsp:param name="ExportType" value="CrossTab" />
	<jsp:param name="columnDimensionName1" value="" />
	<jsp:param name="columnDimensionName2" value="" />
	<jsp:param name="rowDimensionName1" value="" />
	<jsp:param name="rowDimensionName2" value="" />
</jsp:include>

	<body LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onload="return init();">

  <DIV ID="mainpage" style="padding-top:22px">
	<logic:messagesPresent message="true">
	<font color="red" face="Verdana" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="crosstab">
			<%=pageContext.findAttribute("msg")%>
		</html:messages>
		</b>
	</font>
	</logic:messagesPresent>
	
	<html:form action="/saveCrosstab.do" method="post" styleId="createCrosstabForm" >
	<TABLE align="center" width="100%"  BORDER="0" CELLPADDING="6" CELLSPACING="0"  class="POPTABLE oneUITable">
	  <TR>
	    <TD WIDTH="30%" BGCOLOR="#B5B4B4" CLASS="POPTD oneUITableFirstColumn" NOWRAP><bean:message bundle="crosstab" key="ui.label.Name" />:</TD>
	    <TD COLSPAN="3" CLASS="POPTD" ALIGN="left" NOWRAP>
	    <html:text name="createCrosstabForm" styleId="name" property="name" size="25" maxlength="50" /></TD>
	  </TR>
	  <TR>
	    <TD WIDTH="30%" BGCOLOR="#B5B4B4" CLASS="POPTD oneUITableFirstColumn" NOWRAP><bean:message bundle="crosstab" key="ui.label.Display.Type" />:</TD>
	    <TD COLSPAN="3" ALIGN="left" NOWRAP>
	    	<TABLE width="100%"  BORDER="0" CELLPADDING="0" CELLSPACING="0">
	    	<TR><TD class="oneUIFormField" align="left">
		    	<html:radio name="createCrosstabForm" styleId="displayChart" property="displayChart" value="false" onclick="toggleDiv(false);"><bean:message bundle="crosstab" key="ui.label.Table" /></html:radio>
		    	</TD>
		    	<TD class="oneUIFormField" align="right">
		    	<html:radio name="createCrosstabForm" styleId="displayChart" property="displayChart" value="true" onclick="toggleDiv(true);"><bean:message bundle="crosstab" key="ui.label.Graph" /></html:radio>
		    	<html:select styleClass="controlStyleDDLB" name="createCrosstabForm" size="1" property="graphType" >
					<html:optionsCollection name="createCrosstabForm" property="graphTypes" label="label" value="value" />
				</html:select>
				</TD>
				</TR>
				</TABLE>
		</TD>
	  </TR>
	  <TR>
	    <TD WIDTH="30%" BGCOLOR="#B5B4B4" CLASS="POPTD oneUITableFirstColumn" NOWRAP><bean:message bundle="crosstab" key="ui.label.Content" />:</TD>
	    <TD COLSPAN="3" CLASS="POPTD" ALIGN="left" NOWRAP>
	    	<TABLE width="100%"  BORDER="0" CELLPADDING="0" CELLSPACING="0">
	    		
 			  
			<c:set var="loopCounter" value="${createCrosstabForm.maxNoOfRows}"/>
			<c:choose>	
				<c:when test="${ createCrosstabForm.maxNoOfRows>createCrosstabForm.maxNoOfColumn }" >
					<c:set var="loopCounter" value="${createCrosstabForm.maxNoOfRows}"/>
				</c:when>
				<c:otherwise>				
					<c:set var="loopCounter" value="${createCrosstabForm.maxNoOfColumn}"/>
				</c:otherwise>
			</c:choose>	
				<c:set var="totalNoOfColumnAdded" value="0"/>
				<c:set var="totalNoOfRowAdded" value="0"/>
				
				<TR>
				<TD>
				<TABLE width="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
					<TR height="30"><TD class="oneUIFormField" align="left">
					 	<html:checkbox name="createCrosstabForm" styleId="contentType" property="contentType" value="true" onclick="displayPivotTable();"/><bean:message bundle="crosstab" key="ui.label.nested.pivot.table"/>
 			  		</TD></TR>
 			  		
					<c:forEach var="i" begin="1" end="${loopCounter+1}" step="1">				 
						<TR>				
							<TD ALIGN="left"  class="oneUIFormField" NOWRAP>
								<c:if test="${totalNoOfRowAdded < createCrosstabForm.maxNoOfRows}">
									<c:set var="totalNoOfRowAdded" value="${totalNoOfRowAdded+1}"/>
									<span class="oneUITableFormFieldCategory"><bean:message bundle="crosstab" key="ui.label.rows" />&nbsp;<c:out value="${totalNoOfRowAdded}" /></span>
									<select name="selectedRowDimension" id="selectedRowDimension_${totalNoOfRowAdded}" size="1" onchange="changeDimLevels(this,${totalNoOfRowAdded},'selectedRowDimension')" class="controlStyleDDLB">
									<c:if test="${totalNoOfRowAdded!=1}">
										<option value="None"><bean:message key='ui.label.None' bundle="crosstab" /></option>
									</c:if>

									 <c:forEach items="${createCrosstabForm.dimensions}" var="dimensions"  begin="0" >
										<c:choose>	
											<c:when test="${ createCrosstabForm.selectedRowDimension[totalNoOfRowAdded-1] == dimensions.value }" >
												 <option value="${dimensions.value}" selected="selected">${dimensions.label}</option>
											</c:when>
											<c:otherwise>				
												<option value="${dimensions.value}" >${dimensions.label}</option>
											</c:otherwise>
										</c:choose>	
									 </c:forEach>
									</select>			  	
								</c:if>
						</TD>
						</TR>
					</c:forEach>
				</TABLE>
				</TD>
				
				<TD>
				<div id="ptabcoldiv">
				<TABLE width="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
					<TR height="30"><TD>&nbsp;</TD></TR>
					<c:forEach var="i" begin="1" end="${loopCounter+1}" step="1">
						<TR>
						<TD ALIGN="left" class="oneUIFormField" NOWRAP>
						<c:if test="${totalNoOfColumnAdded < createCrosstabForm.maxNoOfColumn}">
							<c:set var="totalNoOfColumnAdded" value="${totalNoOfColumnAdded+1}"/>
							<span class="oneUITableFormFieldCategory"><bean:message bundle="crosstab" key="ui.label.columns" />&nbsp;<c:out value="${totalNoOfColumnAdded}" /></span>
							<select name="selectedColumnDimension" id="selectedColumnDimension_${totalNoOfColumnAdded}" size="1" onchange="changeDimLevels(this,${totalNoOfColumnAdded},'selectedColumnDimension')" class="controlStyleDDLB">
								<option value="None"><bean:message key='ui.label.None' bundle="crosstab" /></option>
									<c:forEach items="${createCrosstabForm.dimensions}" var="dimensions"  begin="0" >
										<c:choose>	
											<c:when test="${ createCrosstabForm.selectedColumnDimension[totalNoOfColumnAdded-1] == dimensions.value }" >
												 <option value="${dimensions.value}" selected="selected">${dimensions.label}</option>
											</c:when>
											<c:otherwise>				
												<option value="${dimensions.value}" >${dimensions.label}</option>
											</c:otherwise>
										</c:choose>	
									 </c:forEach>
							</select>					  	
						</c:if>
					</TD>				
					</TR>
					</c:forEach>
				</TABLE>
				</div>
				</TD>
				</TR>

			    <TR>
					<TD>
					   <div id="ptabrowdiv" style="visibility:hidden;">
					   	<TABLE width="100%"  BORDER="0" CELLPADDING="0" CELLSPACING="0">
			   				<c:set var="loopCounter" value="${createCrosstabForm.maxPivotTableRows - createCrosstabForm.maxNoOfRows}"/>
							   	<c:forEach var="i" begin="1" end="${loopCounter+1}" step="1">				 
								<TR>				
									<TD ALIGN="left"  class="oneUIFormField" NOWRAP>
			   							<c:if test="${totalNoOfRowAdded < createCrosstabForm.maxPivotTableRows}">
											<c:set var="totalNoOfRowAdded" value="${totalNoOfRowAdded+1}"/>
											<span class="oneUITableFormFieldCategory"><bean:message bundle="crosstab" key="ui.label.rows" />&nbsp;<c:out value="${totalNoOfRowAdded}" /></span>
											<select name="selectedRowDimension" id="selectedRowDimension_${totalNoOfRowAdded}" size="1" onchange="changeDimLevels(this,${totalNoOfRowAdded},'selectedRowDimension')" class="controlStyleDDLB">
												<c:if test="${totalNoOfRowAdded!=1}">
													<option value="None"><bean:message key='ui.label.None' bundle="crosstab" /></option>
												</c:if>

												<c:forEach items="${createCrosstabForm.dimensions}" var="dimensions"  begin="0" >
													<c:choose>	
														<c:when test="${ createCrosstabForm.selectedRowDimension[totalNoOfRowAdded-1] == dimensions.value }" >
															 <option value="${dimensions.value}" selected="selected">${dimensions.label}</option>
														</c:when>
														<c:otherwise>				
															<option value="${dimensions.value}" >${dimensions.label}</option>
														</c:otherwise>
													</c:choose>	
												</c:forEach>
											</select>
										</c:if>
									</TD>
								</TR>
							</c:forEach>
						</TABLE>
				    </div>
			    </TD>
			</TR>
	    	</TABLE>
	    </TD>
	  </TR>
	  <TR>
	    <TD WIDTH="30%" BGCOLOR="#B5B4B4" CLASS="POPTD oneUITableFirstColumn" align="left" NOWRAP>
	    	&nbsp;<bean:message bundle="crosstab" key="ui.label.Display.Measures" />:&nbsp;
	    </TD>
		<TD COLSPAN="3" CLASS="POPTD" ALIGN="left" NOWRAP id="measures">

	    </TD>
	   </TR>
	   <logic:equal name="createCrosstabForm" property="canCreateTopReport" value="true">
	   <TR>
	    <TD WIDTH="30%" BGCOLOR="#B5B4B4" CLASS="POPTD oneUITableFirstColumn" align="left" NOWRAP>&nbsp;<bean:message bundle="crosstab" key="ui.label.CrosstabType" />:&nbsp;</TD>
		<TD COLSPAN="3" class="POPTD" ALIGN="left" NOWRAP>
			<TABLE width="100%"  BORDER="0" CELLPADDING="0" CELLSPACING="0">
			<TR><TD class="oneUIFormField" align="left">
 			  <html:radio name="createCrosstabForm" styleId="crosstabTypeOrig" property="crosstabType" value="1"><bean:message bundle="crosstab" key="ui.label.Original" /></html:radio></TD>
	    	  <TD class="oneUIFormField" align="right"><html:radio name="createCrosstabForm" styleId="crosstabTypeTop" property="crosstabType" value="2"><bean:message bundle="crosstab" key="ui.label.TopReports" /></html:radio>
	    	  <html:select styleClass="controlStyleDDLB" name="createCrosstabForm" size="1" property="topReportCategory" >
				  <html:optionsCollection name="createCrosstabForm" property="topReportCategoriesList" label="label" value="value" />
			  </html:select></TD>
			</TR>
			</TABLE>
	    </TD>
	   </TR>
	   </logic:equal>
	   <TR>
	    <TD WIDTH="30%" BGCOLOR="#B5B4B4" CLASS="POPTD oneUITableFirstColumn" align="left" NOWRAP>&nbsp;<bean:message bundle="crosstab" key="ui.label.preferences" />:&nbsp;</TD>
		<TD COLSPAN="3" class="POPTD" ALIGN="left" NOWRAP>
			<TABLE width="100%"  BORDER="0" CELLPADDING="0" CELLSPACING="0">
	    	<TR><TD class="oneUIFormField">
 			<html:radio name="createCrosstabForm" styleId="overridePreferences" property="overridePreferences" value="false" onclick="selectPreferenceType('restrict');"><bean:message bundle="crosstab" key="ui.label.restrict.pref" /></html:radio>
 			</TD>
	    	<TD class="oneUIFormField"><html:radio name="createCrosstabForm" styleId="overridePreferences" property="overridePreferences" value="true" onclick="selectPreferenceType('override');"><bean:message bundle="crosstab" key="ui.label.override.pref" /></html:radio>
	    	</TD>
	    	</TR>
	    	</TABLE>
	    </TD>
	   </TR>
	   <TR id="noOfRowColTR">
	     <TD WIDTH="30%" BGCOLOR="#B5B4B4" CLASS="POPTD oneUITableFirstColumn" align="left" NOWRAP>
	     	<div id="noofrowcoldiv" style="visibility:hidden;">
			<TABLE width="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
				<TR>
				<TD class="controlStyle oneUITableFirstColumn">&nbsp;<bean:message key="ui.label.noOfRowCol" bundle="crosstab" /></TD>
				</TR>
			</TABLE>		
		</div>
	     </TD>
	     <TD CLASS="POPTD" align="left" NOWRAP>
	     	<!-- divs -->
	     	<div id="val1div" style="visibility:hidden;display:none">	
					<TABLE width="100%"  BORDER="0" CELLPADDING="0" CELLSPACING="0">
					 <c:set var="totalNoOfValColumnAdded" value="0"/>
					 <c:set var="totalNoOfValRowAdded" value="0"/>
					
					<TR>
						<TD>
							<TABLE width="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">							
								<TR>
									<TD ALIGN="left" class="oneUIFormField" NOWRAP>&nbsp;&nbsp;</TD>
									<TD ALIGN="left" class="oneUIFormField" NOWRAP><span class="oneUITableFormFieldCategory"><bean:message key="ui.label.level" bundle="crosstab" /></span></TD>
									<TD ALIGN="left"class="oneUIFormField" NOWRAP><span class="oneUITableFormFieldCategory"><bean:message key="ui.label.rows" bundle="crosstab" /></span></TD>
								</TR>
								<c:forEach var="i" begin="1" end="${loopCounter+1}" step="1">
								<TR>
									<c:if test="${totalNoOfValRowAdded < createCrosstabForm.maxNoOfRows}">
										<c:set var="totalNoOfValRowAdded" value="${totalNoOfValRowAdded+1}"/>
										<TD ALIGN="left" class="oneUIFormField" NOWRAP ><span class="oneUITableFormFieldCategory"><bean:message key="ui.label.rows" bundle="crosstab" />&nbsp;<c:out value="${totalNoOfValRowAdded}"/> :</span></TD>
										<TD ALIGN="left" class="oneUIFormField" NOWRAP ><select name="selectedRowDimensionLevel" id="selectedRowDimensionLevel_${totalNoOfValRowAdded}" size="1" class="controlStyleDDLB" disabled></select></TD>
										<TD ALIGN="left" class="oneUIFormField" NOWRAP ><font color="#000000"><input type="text" name="selectedRowDimensionVal" id="selectedRowDimensionVal_${totalNoOfValRowAdded}"  size="5" disabled/></font></TD>
									</c:if>
								</TR>
								</c:forEach>
							</TABLE>
						</TD>
						<TD>
							<div id="colValDiv">
								<TABLE width="100%"  BORDER="0" CELLPADDING="0" CELLSPACING="0">
									<TR>
										<TD ALIGN="left" class="oneUIFormField" NOWRAP>&nbsp;&nbsp;</TD>
										<TD ALIGN="left" class="oneUIFormField" NOWRAP><span class="oneUITableFormFieldCategory"><bean:message key="ui.label.level" bundle="crosstab" /></span></TD>
										<TD ALIGN="left"  class="oneUIFormField" NOWRAP><span class="oneUITableFormFieldCategory"><bean:message key="ui.label.columns" bundle="crosstab" /></span></TD>
									</TR>
									<c:forEach var="i" begin="1" end="${loopCounter+1}" step="1">
									<TR>
										<c:if test="${totalNoOfValColumnAdded < createCrosstabForm.maxNoOfColumn}">
										<c:set var="totalNoOfValColumnAdded" value="${totalNoOfValColumnAdded+1}"/>
											<TD ALIGN="left" class="oneUIFormField" NOWRAP><span class="oneUITableFormFieldCategory"><bean:message key="ui.label.columns" bundle="crosstab" /> &nbsp;<c:out value="${totalNoOfValColumnAdded}"/>:</span></TD>
											<TD ALIGN="left" class="oneUIFormField" NOWRAP><select name="selectedColumnDimensionLevel" id="selectedColumnDimensionLevel_${totalNoOfValColumnAdded}" size="1" class="controlStyleDDLB" disabled></select></td>
											<TD ALIGN="left" class="oneUIFormField" NOWRAP><font color="#000000"><input type="text" id="selectedColumnDimensionVal_${totalNoOfValColumnAdded}" name="selectedColumnDimensionVal" size="5" disabled/></font></TD>
										</c:if>
									</TR>
									</c:forEach>
								</TABLE>
							</div>
						</TD>
					</TR>
					<TR>
					<TD>
					<div id="rowValDiv" style="visibility:hidden;">
						<TABLE width="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
						<c:set var="loopCounter" value="${createCrosstabForm.maxPivotTableRows - createCrosstabForm.maxNoOfRows}"/>
						<c:forEach var="i" begin="1" end="${loopCounter+1}" step="1">
							<TR>
							<c:if test="${totalNoOfValRowAdded < createCrosstabForm.maxPivotTableRows}">
								 <c:set var="totalNoOfValRowAdded" value="${totalNoOfValRowAdded+1}"/>
								<TD ALIGN="left" class="oneUIFormField" NOWRAP ><span class="oneUITableFormFieldCategory"><bean:message key="ui.label.rows" bundle="crosstab" />&nbsp;<c:out value="${totalNoOfValRowAdded}"/> :</span></TD>
								<TD ALIGN="left" class="oneUIFormField" NOWRAP ><select name="selectedRowDimensionLevel" id="selectedRowDimensionLevel_${totalNoOfValRowAdded}" size="1" class="controlStyleDDLB" disabled></select></TD>
								<TD ALIGN="left" class="oneUIFormField" NOWRAP ><font color="#000000"><input type="text" id="selectedRowDimensionVal_${totalNoOfValRowAdded}" name="selectedRowDimensionVal" size="5" disabled/></font></TD>
							</c:if>
							</TR>
						</c:forEach>
					</TABLE>
					</div>
					</TD></TR>
					</table>
				</div>				
	     </TD>
	   </TR>
	   <TR><TD COLSPAN="4" align="center">
	   <input type="button" id="btnSubmit" onclick="return submitCrosstabForm();" value="<bean:message key='button.submit' bundle="crosstab" />" />				
		</TD></TR>
	   </TABLE>
	   <input type="hidden" id="prefType" name="prefType" value="null">
	    <html:hidden name="createCrosstabForm" styleId="maxNoOfRows" property="maxNoOfRows" />
		<html:hidden name="createCrosstabForm" styleId="maxNoOfColumn"  property="maxNoOfColumn"/>
		<html:hidden name="createCrosstabForm" styleId="maxPivotTableRows"  property="maxPivotTableRows" value='${createCrosstabForm.maxPivotTableRows}'/>
	   		<DIV id="displayMeasuresChk" style="visibility:hidden;position:absolute">
			<table width="100%" border="0" cellpadding="0" cellspacing="0" >
				<c:forEach begin="0" end="${ createCrosstabForm.measureRows }" var="rowCount" >
					<tr>
						<c:forEach begin="0" end="2" var="colCount" varStatus="colStatus"  >
							<td align="left" class="oneUIFormField">
								<c:set var="itemIndex" value="${ (rowCount*3) + (colCount) }"/>
								<c:set scope="page" var="displayMeasure" value="${ createCrosstabForm.displayMeasures[itemIndex] }" />
								<c:if test="${ ! empty displayMeasure }">
									<bean:define id="bean" name="displayMeasure" scope="page" type="org.apache.struts.util.LabelValueBean" />
									<!-- create the checkbox and selected attribute -->
									<html:multibox styleId="selectedMeasures" property="selectedMeasures" >
										<bean:write name="bean" property="value"/>
									</html:multibox>
									<!-- create the label, note that "br" tag will format it vertically -->
									<bean:write name="bean" property="label"/>
								</c:if> 
							</td>
						</c:forEach>
					</tr>
				</c:forEach>
			</table>
		</DIV>

		<DIV id="displayMeasuresDrdw" style="visibility:hidden;position:relative">
			<table width="100%" border="0" cellpadding="0" cellspacing="0" >
			<TR>
			 	<TD ALIGN="left" class="oneUIFormField">
					<html:select styleClass="controlStyleDDLB" name="createCrosstabForm" size="1" property="selectedMeasure" >
					<html:optionsCollection name="createCrosstabForm" property="displayMeasures" label="label" value="value" />
					</html:select>
				</TD>
				<TD ALIGN="left" class="oneUIFormField" NOWRAP><font color="#000000">
					<span class="oneUITableFormFieldCategory">
					<bean:message bundle="crosstab" key="ui.label.Show.as.Percent" />
					</span>
					<html:checkbox name="createCrosstabForm" property="showAsPercent" value="true" ></html:checkbox>
				</TD> 
			</tr></table>	
			</DIV>
			
			<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
	   </html:form>
	   </DIV>
</body>
</HTML>
<%@ include file="../end_page.jspf"%>