<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="/jsp/includes/tlib.jspf"%>
<%@ page import="com.zeborg.expensemap.view.*"%>
<%@ page import="java.net.URLEncoder,com.zeborg.util.EncodeUtil"%>
<%@ page import="com.zeborg.acl.util.LocaleUtil" %>
<%@ page import ="com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="java.io.InputStream" %>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties" %>
<%@ page import="com.zeborg.expensemap.view2.ZSession" %>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.model3.DataSet" %>
<%@ page import="java.util.Locale,java.util.*,java.text.*" %>
<%@ page import="com.emptoris.viewer.util.CSRFHelper" %>
<html>
<head>
<%
	// get the ZSession
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	Locale locale = zs.getUser().getLocale();
	String servletPath = request.getServletPath();
	String returnToURL="";
	if(servletPath.lastIndexOf("/")>0) {
		returnToURL=servletPath.substring(servletPath.lastIndexOf("/")+1);
	}
	//encoding url for security fixes
	String qryStr = request.getQueryString(); 
	if(!(qryStr==null || qryStr.equals("null"))) {
        returnToURL+="?"+EncodeUtil.encodeInput(qryStr);
    }
    HelpUtil emHelp = HelpUtil.getHelpUtil();
        
    EmResourceBundle baseBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, zs.getUser().getLocale());
	String title = ExpenseMapAppProperties.getExpensemapTitle()+ " - "+ baseBundle.getValue("ui.button.Select");
	
    pageContext.setAttribute("returnToURL", returnToURL, PageContext.SESSION_SCOPE);
   
	DataSet ds = (DataSet) request.getAttribute("selectedDataset");
	if (ds != null && ds.isMaintenanceModeActivated()) {
		boolean datasetUnderMaintenance = true;
		pageContext.setAttribute("datasetUnderMaintenance", datasetUnderMaintenance);
		String maintenanceModeNotificationMessage = ds.getMaintenanceModeNotificationMessage();
		pageContext.setAttribute("maintenanceModeNotificationMessage", maintenanceModeNotificationMessage.replace("\n", "<br />"));
	}
%>

<title><%= title %> </title>

<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/macromap.css">
<link rel='shortcut icon' href='/expensemap/jsp/images/favicon.ico' type='image/x-icon'>
<style type="text/css">
	<!--
	td { font-family: Arial,Helvetica,sans-serif; font-size:14px; color:#000000; }
	.hrblue {width:3px; noshade; color:blue; width:100%;}
	.headrow{color:#003163; background-color:#d9e2eb; border-colour:#B5B4B4; }
	.tabgcolor{background-color:#EFEFEF; }
	#maintenanceMessageDiv {
		background-color: #F4F4F4;
		border: 1px solid #ccc;
		height: 250px;
		width: 550px;
		text-align: center;
		margin: 50px 0;
	}
	#maintenanceModeMessageTitle { margin: 40px 0 26px 0; }
	#maintenanceModeNotificationMessage { margin: 0 auto; height: 120px; width: 500px; font-size: 14px; overflow-y: auto; }
	-->
</style>

<script language="javascript">
	function refreshPage(type) {
		var frm = document.cubeSelectForm;
	 	frm.action = "/expensemap/cubeSelectPage.do?refreshType="+type;
	 	frm.submit();
	}
	
	function clickGO() {
    	var frm = document.cubeSelectForm;
	 	frm.action = "/expensemap/processSelectedCube.do";
	 	document.getElementById("hideMe").style.visibility = "hidden";
	 	frm.submit();
	}
      
	function init(){
		var obj = document.getElementById("selectedDataSetId");
		if(obj!=null && obj!='null' && obj!='undefined'){
			obj.focus();
		}		
	}

</script>
</head>

<body LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onload="init();">

<%-- build the masthead --%>
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<%
	CubeUtil.buildExpMapMastHead(out, "cubeSelect.jsp", zs, true, null,zs.getUser().getLocale(), null);
	String pagename = request.getRequestURI();
%>

<form id="cubeSelect" name="cubeSelectForm" method="post" onSubmit="return hideGO();" style="padding-top:18px; padding-top:0px !ie;">
<% boolean errorFlag = false; %>
	<logic:messagesPresent message="true">
		<% errorFlag = true; %>
	</logic:messagesPresent>
	<logic:equal value="" name="cubeSelectForm" property="selectedCompanyId">
		<% errorFlag = true; %>
	</logic:equal>
	<logic:equal value="" name="cubeSelectForm" property="selectedDataSetId">
		<% errorFlag = true; %>
	</logic:equal>	
<%-- this table holds the form elements to select a company and a dataset --%>
<table width="700" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="49"><img src="/expensemap/jsp/nav_images/<%=LocaleUtil.getLocaleLanguage(locale)%>/one.gif" ></td>
    <td width="50%" align="left" valign="middle" nowrap background="/expensemap/jsp/images/tile.gif" class="DialogTabSep">&nbsp;<bean:message bundle="emMessages" key='ui.label.Select.Company' />: &nbsp;&nbsp;</td>
    <td width="10" align="center" valign="middle" bgcolor="31659C"><img src="/expensemap/jsp/images/transparent.gif" width="10" height="8"></td>
	<td width="100" align="center" valign="middle" bgcolor="31659C">
        <html:select styleClass="controlStyleDDLB" name="cubeSelectForm" size="1" property="selectedCompanyId" styleId="selectedCompanyId" onchange="refreshPage('company');">
        	<c:if test="${ ! empty cubeSelectForm.companies }">
				<html:optionsCollection name="cubeSelectForm" property="companies" label="label" value="value" />
			</c:if>
		</html:select>
	</td>

	<td width="10" align="center" valign="middle" bgcolor="31659C"><img src="/expensemap/jsp/images/transparent.gif" width="10" height="8"></td>
	<td width="44"><a target="_blank" href="<%=emHelp.getHelpURL(pagename,locale)%>"><img src="/expensemap/jsp/images/help-sp.gif" width="44" height="36" border="0" title="<bean:message bundle="emMessages" key='ui.label.Help' />"></a></td>
    <td width="51"><img src="/expensemap/jsp/nav_images/<%=LocaleUtil.getLocaleLanguage(locale)%>/two.gif" ></td>
    <td width="50%" align="left" valign="middle" nowrap background="/expensemap/jsp/images/tile.gif"><span class="DialogTabSep"><bean:message bundle="emMessages" key='ui.label.Select.Dataset' />: &nbsp;&nbsp;</span></td>
	<td width="10" align="center" valign="middle" bgcolor="31659C"><img src="/expensemap/jsp/images/transparent.gif" width="10" height="8"></td>
    <td width="100" align="center" valign="middle" bgcolor="31659C">
		<html:select styleClass="controlStyleDDLB" name="cubeSelectForm" size="1" property="selectedDataSetId" styleId="selectedDataSetId" onchange="refreshPage('dataset');">
			<c:if test="${ ! empty cubeSelectForm.selCompaniesDatasets }">
				<html:optionsCollection name="cubeSelectForm" property="selCompaniesDatasets" label="label" value="value" />
			</c:if>
		</html:select>
		<%-- end dataset dropdown --%>
	</td>
	<td width="10" align="center" valign="middle" bgcolor="31659C"><img src="/expensemap/jsp/images/transparent.gif" width="10" height="8"></td>
    <td width="63">
    <% if (errorFlag) {%>
    	<span id="hideMe" style="visibility:hidden"><img src="/expensemap/jsp/nav_images/<%=LocaleUtil.getLocaleLanguage(locale)%>/go.gif" border="0"></A></span></td>
    <% } else { %>
		<c:if test="${!datasetUnderMaintenance}">
			<span id="hideMe" style="visibility:visible"><A target="_self" HREF="javascript:clickGO();"><img src="/expensemap/jsp/nav_images/<%=LocaleUtil.getLocaleLanguage(locale)%>/go.gif" border="0"></A></span></td>
		</c:if>
		<c:if test="${datasetUnderMaintenance}">
			<span id="hideMe" style="visibility:visible"><img src="/expensemap/jsp/nav_images/go_disabled.gif" border="0"></span></td>
		</c:if>
    <% } %>
  </tr>
</table>

<table border=0 cellpadding=0 cellspacing=0 width="96%" >
<tr><td align="middle">
	<logic:messagesPresent message="true">
	<br>
	<font color="red" face="Verdana" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="errors" >
			<%=pageContext.findAttribute("msg")%>
		</html:messages>
		</b>
	</font>
	</logic:messagesPresent>
	<br>
</td>
</tr>
<tr>
<td align="center">
<%-- this table holds cube stats and dimension count stuff --%>

<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zs.getUser().getTimeZone().getID()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	
    <c:choose>
		<%-- Show maintenance mode message --%>
        <c:when test="${datasetUnderMaintenance}">
			<div id="maintenanceMessageDiv">
				<div id="maintenanceModeMessageTitle"><b><h1> ${maintenanceModeMessageTitle} </h1></b></div>
				<div id="maintenanceModeNotificationMessage"> ${maintenanceModeNotificationMessage} </div>
			</div>
		</c:when>
		<c:otherwise>
			<%-- Show usual dataset and related info when dataset isn't in maintenance mode --%>
			<table width="96%" border=0 cellpadding=0 cellspacing=0>
				<tr>
					<td style="font-size:20px" colspan=3 nowrap class="DialogTabSep">
						<b> ${ cubeSelectForm.selectedDataSet.displayName}</b>
						<hr class="DialogTabSep">
					</td>
				</tr>
				<tr>
					<td   width="28%" style="font-size:12px" nowrap align="center"  valign="middle">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
						<b> <bean:message bundle="emMessages" key='ui.label.Date.Range' />:</b>           
						<c:if test="${cubeSelectForm.selectedDataSet.cubeMeta.beginDate!=null }">
								<bean:define id="cubeMetaBeginDate" name="cubeSelectForm" property="selectedDataSet.cubeMeta.beginDate" />					
								<fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern}" value="${cubeMetaBeginDate }" /> : 
						</c:if> 				
						<c:if test="${cubeSelectForm.selectedDataSet.cubeMeta.endDate!=null }">
							<bean:define id="cubeMetaendDate" name="cubeSelectForm" property="selectedDataSet.cubeMeta.endDate" />			 
							<fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern}" value="${cubeMetaendDate }" />
						</c:if>
					</td>
					
					<td style="font-size:12px" width="32%" align="center" nowrap>&nbsp;
						
					</td>
					<td style="font-size:12px" width="32%" nowrap>&nbsp;
						<b><bean:message bundle="emMessages" key='ui.label.Publish.Date' />:</b>
						<c:if test="${cubeSelectForm.selectedDataSet.cubeMeta.lastBuiltTime!=null }">
							<bean:define id="cubeMetalastBuiltTime" name="cubeSelectForm" property="selectedDataSet.cubeMeta.lastBuiltTime" />			  
							<fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern}" value="${ cubeMetalastBuiltTime }" />
						</c:if>
					</td>
				</tr>
				<!-- spacer between date and descriptsion -->
				<tr> <td  colspan=3 nowrap valign=bottom> <hr class="DialogTabSep" > </td> </tr>
				<!-- manisha -->
				<tr>
						<!-- start history & descriptions -->
						<td width="50%" valign="top" colspan=2 nowrap>
						<div id="d.and.m" style="width:; height:;  overflow-x:hidden; overflow-y:hidden; ">
						<table width="100%" border=0 cellpadding=0 cellspacing=0 >
							<tr>
								<td valign="top">
									<table border="0" cellpadding="0" cellspacing="0" width="40%" >
										<tr><td style="font-size:12px" class="headrow"  colspan="2"><b>&nbsp;<bean:message bundle="emMessages" key='ui.label.Data.History' /></b></td></tr>
											<tr rowspan="3"> <td  bgcolor="#EFEFEF" >
											<div id=layer1 style="overflow:auto;width:420px ;height:125px; display:block;">
												<span class=tabgcolor>${historyNotes}</span>
											</div>
											</td>
										</tr>
									</table>
								</td></tr>
						</table>
						</div>
						</td>
						<!-- end history & descriptions -->
						<td width="50%" nowrap valign="top"  rowspan=2>
							<!-- start dimension count stuff -->
							<div id="scroll" style="width:; height:325; overflow-x:hidden; overflow-y:scroll; border:1px outset">
							<table width="100%" border=0 cellpadding=1 cellspacing=1 BORDERCOLOR="gray">
								<tr><td class="headrow"  colspan="2"  style="font-size:12px"><b>&nbsp;<bean:message bundle="emMessages" key='ui.label.Measures' /></b></td></tr>
									<c:forEach items="${ cubeSelectForm.measures }" var="row" >
										<tr>
									<td align="left" bgcolor="#EFEFEF" nowrap style="font-size:12px" ><b> ${row.label} &nbsp;</b></td>
									<td align="right" nowrap style="font-size:12px">&nbsp; ${row.value} </td>
									</tr>
									</c:forEach>
				
								<tr><td class="headrow"  colspan="2"  style="font-size:12px"><b>&nbsp;<bean:message bundle="emMessages" key='ui.label.Dimensions' /></b></td></tr>
									<c:forEach items="${ cubeSelectForm.dimensions }" var="row" >
										<tr>
										<td align="left" bgcolor="#EFEFEF" nowrap style="font-size:12px" ><b> ${row.label}  &nbsp;</b></td>
										<td align="right" nowrap style="font-size:12px">&nbsp; ${row.value} </td>
										</tr>
									</c:forEach>
							</table>
							</div>
							<!-- end dimension count stuff -->
						</td>
				</tr>
				<!-- manisha -->
				<tr><td colspan=2 valign="bottom">
					<table border="0" cellpadding="0" cellspacing="0" width="40%" >
						<tr><td class="headrow"  colspan="2" style="font-size:12px" ><b>&nbsp;<bean:message bundle="emMessages" key='ui.label.Description' /></b></td></tr>
						<tr>
							<td bgcolor="#EFEFEF" valign="bottom">
								<div id=layer2 style="overflow:auto;width:420px ;height:125px; display:block;">
									<span class=tabgcolor>${descriptionNotes}</span>
								</div>
							</td>
						</tr>
					</table>
				</td></tr>
			</table>
		</c:otherwise>
    </c:choose>

</td></tr>
<tr> <td  colspan=3 nowrap valign=bottom> <hr class="DialogTabSep" > </td> </tr>
</table>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</form>

<jsp:include page="/jsp/includes/pageFooter.jsp"/>

</body>
</html>

<%
	pageContext.removeAttribute("viewFrameURL", PageContext.SESSION_SCOPE);
%>
