<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page language="java" contentType="text/html; charset=UTF-8"  pageEncoding="UTF-8"%>
<%@page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>

<html>
<head>

<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/css/listPage.css" />
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="cube.job.id.synchronization.title" bundle="sdmMessages"/></title>

</head>
<body>
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
<logic:messagesPresent message="true">
	<font color="red" face="Arial, Helvetica, sans-serif" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="sdmMessages">
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=pageContext.findAttribute("msg")%>
		</html:messages>
		</b>
	</font>
</logic:messagesPresent>

<form name="checkCubeJobs" method="post" action="/expensemap/datamanager/CheckCubeJobsAction.do?method=submitSyncIdJob" >

	<table class="tableWithBorder">
		<tr>
			<td class="POPFORMTITLE" style="padding-left: 4px" nowrap><bean:message key="cube.job.id.synchronization.title" bundle="sdmMessages" /></td>
			<td class="POPFORMTITLE" style="TEXT-ALIGN: right;" colspan="8"><img src="/expensemap/jsp/images/help.gif" border="0" alt="Help" style="cursor: pointer"></td>
		</tr>
	</table>

	<table class="InnerTableWithBorder" >

		<tr>
			<td class="thead" align="center" valign="top">
				<bean:message key="cube.job.id.synchronization.dimension.name" bundle="sdmMessages" />
			</td>
			<td class="thead" align="center">
				<bean:message key="cube.job.id.synchronization.sync.parent.dim.id" bundle="sdmMessages" /><BR>
				<input type="checkbox" class="selectAll" name="ruleEnabledForDimParentIdSync" id="ruleEnabledForDimParentIdSync">
			</td>
			<td class="thead" align="center">
				<bean:message key="cube.job.id.synchronization.sync.fact.legacy.dim.id" bundle="sdmMessages" /><BR>
				<input type="checkbox" class="selectAll" name="ruleEnabledForFactLegacyIdSync" id="ruleEnabledForFactLegacyIdSync">
			</td>
			<td class="thead" align="center"  valign="bottom">
				<input type="checkbox" name="selectAll" id="selectAll">
			</td>
		</tr>

		<logic:iterate id="idSyncRuleInfo" name="checkCubeJobs" property="idSyncRuleInfos" type="com.emptoris.spendmanager.components.cube.spi.job.IdSyncRuleInfo" indexId="ctr">
			<c:choose>
				<c:when test="${ctr % 2 == 0}">
					<c:set var="rowClass" value="trEven" scope="page" />
				</c:when>
				<c:otherwise>
					<c:set var="rowClass" value="trOdd" scope="page" />
				</c:otherwise>
			</c:choose>

			<tr class="${rowClass}">
				<td class=".tdStyle" style="padding-left: 4px">
					<c:out value="${idSyncRuleInfo.dimensionName}" />
					<html:hidden name="idSyncRuleInfo" styleId="idSyncRuleInfo" property="dimensionName" indexed="true" />
				</td>
				<td class=".tdStyle" align="center">
					<html:checkbox styleClass="selectAll ${idSyncRuleInfo.dimensionName} ruleEnabledForDimParentIdSync" name="idSyncRuleInfo" property="ruleEnabledForDimParentIdSync" indexed="true" />
				</td>
				<td class=".tdStyle" align="center">
					<html:checkbox styleClass="selectAll ${idSyncRuleInfo.dimensionName} ruleEnabledForFactLegacyIdSync" name="idSyncRuleInfo" property="ruleEnabledForFactLegacyIdSync" indexed="true" />
				</td>
				<td class=".tdStyle" align="center">
					<input class="selectAll" name="<c:out value='${idSyncRuleInfo.dimensionName}' />" id="<c:out value='${idSyncRuleInfo.dimensionName}' />" type="checkbox" >
				</td>
			</tr>
		</logic:iterate>
	</table>

	<table class="tableWithoutBorder" align="center">
		<tr>
			<td  colSpan="8" align="center" class="buttonStyle">&nbsp;</td>
		</tr>

		<tr>
			<td colspan="8" align="center" class="buttonStyle">
				<html:submit property="submitBtn" onclick="return validateSubmission();" ><bean:message key="ui.cube.job.submit.button" bundle="sdmMessages"/></html:submit>&nbsp;
				<html:button property="cancel" onclick="window.close();"><bean:message key="ui.import.cancle.button" bundle="sdmMessages" /></html:button>
			</td>
		</tr>
	</table>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</form>

<script type="text/javascript" src="/expensemap/scripts/selectAllCheckbox.js"></script>

<script>
	var selectAll = null;
	(
		function() {
			var Event = YAHOO.util.Event;
			var Dom = YAHOO.util.Dom;

			YAHOO.util.Event.onDOMReady(function() {
				selectAll = new YAHOO.emptoris.reports.widgets.selectAllCheckBox(Dom.get('selectAll'),Dom.get("checkCubeJobs"),'selectAll' );
				
				selectAll.childrens.push(new YAHOO.emptoris.reports.widgets.selectAllCheckBox(Dom.get('ruleEnabledForDimParentIdSync'),Dom.get("checkCubeJobs"),'ruleEnabledForDimParentIdSync' ));

				selectAll.childrens.push(new YAHOO.emptoris.reports.widgets.selectAllCheckBox(Dom.get('ruleEnabledForFactLegacyIdSync'),Dom.get("checkCubeJobs"),'ruleEnabledForFactLegacyIdSync' ));

				<c:forEach items="${ checkCubeJobs.idSyncRuleInfos }" var="idSyncRuleInfo" varStatus="status">
					selectAll.childrens.push(new YAHOO.emptoris.reports.widgets.selectAllCheckBox(Dom.get('${idSyncRuleInfo.dimensionName}'),Dom.get("checkCubeJobs"),'${idSyncRuleInfo.dimensionName}' ));
				</c:forEach>
			});	
				}
			)();

			function validateSubmission(){
				if(selectAll.getSelectedCount()>0){
					if(confirm("<bean:message key='cube.job.id.cube.msg.confirm.id.sync.job' bundle='sdmMessages'/>")){		
						return true;
					}
				}else{
					alert("<bean:message key='ui.cube.msg.select.atleast.one.dimension' bundle='sdmMessages'/>");					
				}
				return false;
		}
</script>

</body>
</html>