<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@page import="com.zeborg.util.WebUtil"%>
<%@page import="com.zeborg.expensemap.view2.ZSession"%>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="java.util.Locale"%>
<%@ page import="com.zeborg.acl.util.LocaleUtil" %>
<%
	//No client side caching
    WebUtil.addNoCache(response);
    WebUtil.addType(response,request);
	// get the ZSession
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	// create help URL
	String helpURL = HelpUtil.getHelpUtil().getHelpURLString("cubeSelect", WebUtil.getAppLocale(pageContext)); 

	boolean pollingEnabled = request.getSession().getAttribute("pollingEnabled")!=null? (Boolean)request.getSession().getAttribute("pollingEnabled"):false;
	//default polling interval is 10 sec. 1000 ms = 1 sec
	long pollingInterval = 10000L;
	if(ExpenseMapAppProperties.getServerPollingRequestTimeInSecond()>0){
		pollingInterval = 1000 *  ExpenseMapAppProperties.getServerPollingRequestTimeInSecond();
	}

%>
<html:html>
<head>

<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.datamanager.cube.select.title" bundle="sdmMessages" /></title>

<LINK REL="stylesheet" TYPE="text/css" HREF="stylesheets/macromap.css">
<link rel='shortcut icon' href='/expensemap/jsp/images/favicon.ico' type='image/x-icon'>
<style type="text/css">
<!--
td { font-family:Arial,Helvetica,sans-serif; font-size:14px; color:#000000; }
.hrblue {width:"3"; noshade; color:"blue"; width="100%"}
.headrow{color:"#003163"; background-color="#D9E2EB" ; border-colour:"#B5B4B4"}
.tabgcolor{background-color="#EFEFEF" ; }
-->

</style>
<SCRIPT LANGUAGE="javascript" SRC="javascript/header.js"></SCRIPT>
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<script language="javascript">
	
	function clickGO(){
		var selectCube = document.getElementById("selectCubeId");
		var frm = document.getElementById("Cube_CompId");
		var cubeId = selectCube.value;
		if(cubeId=="new"){
			var url = '/expensemap/datamanager/CreateNewCubeAction.do?AuthCode=' + encodeURIComponent(document.getElementById('AuthCode').value);
			window.open(url, "Import_Window",'resizable=no,width=650,height=400');
		}
		else if(cubeId=="loadKb"){
		var url = '/expensemap/knowledgebase/LoadKbAction.do?parameter=loadKbDetails&AuthCode=' + encodeURIComponent(document.getElementById('AuthCode').value);
			window.open(url, "LoadKB_Window",'resizable=no,width=650,height=360');
		}
		else{
			frm.action = "/expensemap/datamanager/LoadCubeAction.do";
			frm.method = "POST";
			frm.submit();
		}
	}

	if (<%=pollingEnabled%>) {
		setInterval(pollOnlineFeedbackJob, <%=pollingInterval%>);
	}

/**
* Polls for the submission of OLF
*/

function pollOnlineFeedbackJob() {
  try {        
	jQuery.ajax({
		url: "/expensemap/PollOnlineFeedbackJob.do",
		type: "POST",
		success: function(data) {
					 //session handling 
					if (checkIfSessionActive(data) == false) {
						return;
					}
					
					//Notification of OLF job submission
					if (data[1] == 'true' && data[2] == 'false') {        
						alert(data[3]);
					}
				 }
		});
	} catch(e) { 
		//alert(e);
	}	   
}

/** 
* Checks if session is  active
*/

function checkIfSessionActive(data) {
	if (data[0] == "Error"){
		var errorCode = data[1];
		var isForceLogOut = false;
		var jobStartTime = "";
		if(errorCode == "force.timeout"){
			isForceLogOut = true;
			jobStartTime = data[4];			
		}
		
		if(errorCode == "session.timeout" || errorCode == "force.timeout") {

			var timeoutURL = data[3];
			var submitForm = createNewSubmitForm();
				
			if(isForceLogOut){				
				createNewFormElementWithTime(submitForm, "forceLogout", isForceLogOut, "jobStartTime", jobStartTime );
			}else{				
				createNewFormElement(submitForm, "forceLogout", isForceLogOut);
			}
				
			submitForm.action = timeoutURL;
			submitForm.submit();
			return false;
				 
		}
	}
	return true;
}

function createNewSubmitForm(){
	var submitForm = document.createElement("FORM");
	document.body.appendChild(submitForm);
	submitForm.method = "POST";
	return submitForm;
}

function createNewFormElement(inputForm, forceLogoutElementName, forceLogoutElementValue){
	var forceLogoutElement = document.createElement("input");
	forceLogoutElement.setAttribute('name', forceLogoutElementName);
	forceLogoutElement.setAttribute('type', 'hidden');
	inputForm.appendChild(forceLogoutElement);
	forceLogoutElement.value = forceLogoutElementValue;
	
	return forceLogoutElement;
}

function createNewFormElementWithTime(inputForm, forceLogoutElementName, forceLogoutElementValue, jobStartTimeElementName, jobStartTimeElementValue ){
	var forceLogoutElement = document.createElement('input');
	forceLogoutElement.setAttribute('name', forceLogoutElementName);
	forceLogoutElement.setAttribute('type', 'hidden');
	
	var jobStartTimeElement = document.createElement('input');
	jobStartTimeElement.setAttribute('name', jobStartTimeElementName);
	jobStartTimeElement.setAttribute('type', 'hidden');
	
	inputForm.appendChild(forceLogoutElement);
	inputForm.appendChild(jobStartTimeElement);
	forceLogoutElement.value = forceLogoutElementValue;
	jobStartTimeElement.value = jobStartTimeElementValue;
	
	return forceLogoutElement;
}

/**
* End - polling online feedback job
*/

function populateCubeList() {
	var selCom = document.getElementById("selectCompId");
	// Cube list should be populated only when at least one company is available
	if (selCom.length >= 1) {
		try {
			var selectedCompany = selCom.options[selCom.selectedIndex].value;
			if(selectedCompany == '' ){
				var selectCubeId = document.getElementById("selectCubeId");
				for( i=1; i < selectCubeId.options.length;){
					selectCubeId.options[i]=null;
				}
				return false;
			}
			
			jQuery.ajax({
				url: "/expensemap/datamanager/CubeListAction.do?operation=populateCubes",
				type: "GET",
				data: { selectedCompany: selectedCompany },
				success: responseHandler,
				error: function(xhr, status, error) {
					alert('Error: ' + xhr.statusText);
				}
			});
		} catch(e) {
			 alert(e);
		}
	}
}

	//handle the ajax response
	function responseHandler(response) {   
		data = eval(response);
		// If there is no data in the response, ignore this
		if (data == null) {
			return;
		} else if( data[0]=="populateCubes") {
	
			var selectCubeId = document.getElementById("selectCubeId");
			for( i=0; i < selectCubeId.options.length;){
				selectCubeId.options[i]=null;
			}
	
			for(i=1 ; i<data.length ; i=i+2){
				selectCubeId.options[selectCubeId.options.length] = new Option(data[i], data[i+1]);
			}
			if(selectCubeId.options.length > 0){
				selectCubeId.options[0].selected=true;
			}
		}
	}
	
	function loadCubeList(){
		var selectedCompany = document.getElementById("selectCompId");
		populateCubeList();
	}
</script>

</head>

<body bgcolor="#FFFFFF" LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onload="loadCubeList();">

<%-- build the masthead --%>
<%
	CubeUtil.buildExpMapMastHead(out,"dataManager_cubeSelect.jsp",zs,true,null,zs.getUser().getLocale(),null);
%>

<html:form styleId="Cube_CompId" action="/CubeListAction.do" style="margin-top: 20px;"> 

<table width="700" border="0" cellspacing="0" cellpadding="0">
  <tr>
	    <td width="49"><img src="/expensemap/jsp/nav_images/en_US/one.gif" ></td>
	    <td width="50%" align="left" valign="middle" nowrap background="/expensemap/jsp/images/tile.gif" class="DialogTabSep">&nbsp;<bean:message key="select.company" bundle="sdmMessages" />: &nbsp;&nbsp;</td>	    <td width="10" align="center" valign="middle" bgcolor="31659C"><img src="/expensemap/jsp/images/transparent.gif" width="10" height="8"></td>
		<td width="100" align="center" valign="middle" bgcolor="31659C">
			 <html:select styleId="selectCompId" name="cubeListForm" property="selectedCompany" onchange="populateCubeList();">
				<html:options collection="compList" property="value" labelProperty="label" />
			</html:select>
		</td>
		<td width="10" align="center" valign="middle" bgcolor="31659C"><img src="/expensemap/jsp/images/transparent.gif" width="10" height="8"></td>
	  	<td width="44"><a target="_blank" href="/expensemap/en/help/mergedProjects/SAUserGuide/Getting_Started4.html"><img src="/expensemap/jsp/images/help-sp.gif" width="44" height="36" border="0" title="Help"></a></td>
	    <td width="51"><img src="/expensemap/jsp/nav_images/en_US/two.gif" ></td>
	    <td width="50%" align="left" valign="middle" nowrap background="/expensemap/jsp/images/tile.gif"><span class="DialogTabSep"><bean:message key="select.cube" bundle="sdmMessages" />: &nbsp;&nbsp;</span></td>
		<td width="10" align="center" valign="middle" bgcolor="31659C"><img src="/expensemap/jsp/images/transparent.gif" width="10" height="8"></td>
	    <td width="100" align="center" valign="middle" bgcolor="31659C">
			<html:select styleId="selectCubeId" name="cubeListForm"  property="selectedCube">
				
			</html:select>
		</td>
		<td width="10" align="center" valign="middle" bgcolor="31659C"><img src="/expensemap/jsp/images/transparent.gif" width="10" height="8"></td>
		<c:if test="${! empty compList}">
			<td width="63"><span id="onGo"><A target="_self" HREF="javascript:clickGO();"><img src="/expensemap/jsp/nav_images/<%=LocaleUtil.getLocaleLanguage(zs.getUser().getLocale())%>/go.gif" border="0"></A></span></td>
		</c:if>
		</td>
  </tr>
  
</table>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</html:form>
<!--  To pass child value to parent window -->
<form name="cubeListFromId" method="post" action="/expensemap/jobcontroller/JobListAction.do?operation=loadJobList&isSysAdminRequest=false&clearSearch=true">
<input type="hidden" id="selectedCube" name="selectedCube" value=""/>
</form>
</body>
</html:html>