<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page language="java" contentType="text/html; charset=UTF-8"  pageEncoding="UTF-8"%>
<%@page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>

<html>
<head>

<style type="text/css">
	#oracleConfig td { height: 25px; }
	#db2config td { height: 25px; }
	
</style>

<script type="text/javascript">

	function submitForm(){
		var theForm =  document.getElementById("publishCube");
		var argStr= "method=";
		if(document.getElementById("mysqlDb").checked){
			if (document.getElementById("registerBox").checked) { 
				 argStr = argStr + "publishCubeSARegistration";
			}else{
				argStr = argStr + "publishCube";
			}
		}else if(document.getElementById("oracleDb").checked){
			if(validateData()){
					if(confirm("<bean:message key='cube.job.oracle.publish.confirm.message' />")){
						argStr = argStr + "publishOracleCube";	
					}else{
						return false;
					}
				}else{
					return false;
			 }	
		}else{
			if(validateDB2Data()){
				argStr = argStr + "publishDB2Cube";	
			}else{
					return false;
			 }
		}
		var url = "/expensemap/datamanager/PublishInputSetJobAction.do?" + argStr;
		theForm.action=url;
		theForm.method="post";
		theForm.submit();
	}
	function validateData(){
		
			if(!validateoracleHost()){
				return false;
			}
			if(!validateoraclePort()){
				return false;
			}
			if(!validateoracleServiceName()){
				return false;
			}
			if(!validateoracleUser()){
				return false;
			}
			if(!validateoraclePassword()){
				return false;
			}
			return true;
	}
	
	function validateDB2Data(){
		
			if(!validateDB2Host()){
				return false;
			}
			if(!validateDB2Port()){
				return false;
			}
			if(!validateDB2DatabaseName()){
				return false;
			}
			if(!validateDB2User()){
				return false;
			}
			if(!validateDB2Password()){
				return false;
			}
			return true;
	}
	
	function validateoracleHost(){
		var inputHost = document.publishCube.oracleHost;
		return validateRequired(inputHost, "<bean:message key='ui.enter.oracle.database.host' />") ;
	}
	
	function validateDB2Host(){
		var inputdb2Host = document.publishCube.db2Host;
		return validateRequired(inputdb2Host, "<bean:message key='ui.enter.db2.database.host' />") ;
	}
	
	function validateoraclePort(){
		var allowedChar = "0123456789";
		var inputOraclePort = document.publishCube.oraclePort;
		return validateRequired(inputOraclePort, "<bean:message key='ui.enter.oracle.database.port' bundle='sdmMessages' />") &&
			validateAllowedCharacter(inputOraclePort, "<bean:message key='ui.enter.numeric.only.oracle.database.port' bundle='sdmMessages' />",allowedChar);
	}
	
	
	function validateDB2Port(){
		var allowedChar = "0123456789";
		var inputdb2Port = document.publishCube.db2Port;
		return validateRequired(inputdb2Port, "<bean:message key='ui.enter.db2.database.port' bundle='sdmMessages' />") &&
			validateAllowedCharacter(inputdb2Port, "<bean:message key='ui.enter.numeric.only.db2.database.port' bundle='sdmMessages' />",allowedChar);
	}

	function validateoracleServiceName(){
		var inputServiceName = document.publishCube.oracleServiceName;
		return validateRequired(inputServiceName, "<bean:message key='ui.enter.oracle.database.service.name' bundle='sdmMessages' />") ;
	}
	
	function validateDB2DatabaseName(){
		var db2DatabaseName = document.publishCube.db2DatabaseName;
		return validateRequired(db2DatabaseName, "<bean:message key='ui.enter.db2.database.name' bundle='sdmMessages' />") ;
	}

	function validateoracleUser(){
		var inputOracleUser = document.publishCube.oracleUserName;
		return validateRequired(inputOracleUser, "<bean:message key='ui.enter.oracle.database.user' bundle='sdmMessages' />") ;
	}
	
	
	function validateDB2User(){
		var inputDb2User = document.publishCube.db2Username;
		return validateRequired(inputDb2User, "<bean:message key='ui.enter.db2.database.user' bundle='sdmMessages' />") ;
	}

	function validateoraclePassword(){
		var inputOraclePassword = document.publishCube.oraclePassword;
		return validateRequired(inputOraclePassword, "<bean:message key='ui.enter.oracle.database.password' bundle='sdmMessages' />") ;
	}
	
	function validateDB2Password(){
		var inputDb2Password = document.publishCube.db2Password;
		return validateRequired(inputDb2Password, "<bean:message key='ui.enter.db2.database.password' bundle='sdmMessages' />") ;
	}
		
	function validateRequired(field, message){	
		if ( typeof field != "undefined" ) {
			if( (field.type == 'text' || (field.type=='password' && field.disabled==false)) && isEmpty(field.value.replace(/^\s+/,''))){
				alert(message);
				field.focus();
				return false;		
			}else if( field.type == 'select-one' && ( field.options.length < 1 || isEmpty( field.options[field.selectedIndex].value) ) ){
				alert(message);
				field.focus();
				return false;
			}
		}
		return true;
	}
	
	function validateAllowedCharacter(userInput, message, allowedChar){	
		if( typeof userInput != "undefined"){
			var userInputValue = userInput.value;
			for (var i = 0; i < userInputValue.length; i++) {
				if (allowedChar.indexOf(userInputValue.charAt(i)) == -1){
					userInput.value="";
					userInput.focus();
					alert(message);					
					return false;
				}
			}
		}
		return true;
	}
	
	function isEmpty(fieldVal) {
		if(fieldVal==null || fieldVal=='' || fieldVal=='null' ) {			
			return true;
		}
		return false;
	}
	// This method will display dataset List 
	function showDataSetList(){		
		if(document.getElementById("registerBox").checked) {		
			if(document.getElementById('allowedRegistration').value=="false"){
				document.getElementById('submitBtn').disabled=true;
				document.getElementById('dataSetListTR').style.display='table-row-group';
				document.getElementById('cubeVersionInExternalForm').disabled=true;
				document.getElementById('msgDiv').style.display='table-row-group';
			}else{
				document.getElementById('dataSetListTR').style.display='table-row-group';
			}		
		}else{
			document.getElementById('dataSetListTR').style.display='none';
			document.getElementById('submitBtn').disabled=false;
			document.getElementById('msgDiv').style.display='none';			
		}
	}
	
	function showOracleCofig(){
		document.getElementById('oracleConfig').style.display='table-row-group';
		document.getElementById('registerCheck').style.display="none";
		document.getElementById('dataSetListTR').style.display='none';
		document.getElementById('db2config').style.display='none';
	}
	
	function showDB2Config(){
		document.getElementById('db2config').style.display='table-row-group';
		document.getElementById('registerCheck').style.display="none";
		document.getElementById('dataSetListTR').style.display='none';
		document.getElementById('oracleConfig').style.display='none';
	
	}
	
	function showsqlConfig(){ 
		document.getElementById('registerCheck').style.display='table-row-group';
		document.getElementById('oracleConfig').style.display="none";
		document.getElementById('db2config').style.display='none';
		showDataSetList();
	}
	
	function changePassword(obj){
		obj.style.display="inline";
		obj.removeAttribute("disabled");
		obj.value="";
		document.getElementById('changePwd').value='true';
		obj.focus();
	}
	
    function onloadChecks(){
        var inputHost = document.publishCube.oracleHost.value;
        if(inputHost.indexOf('spend.oracle.database.host') != -1){
                document.publishCube.oracleHost.value="";
                document.publishCube.oraclePort.value="";
                document.publishCube.oracleServiceName.value="";
                document.publishCube.oracleUserName.value="";
                document.publishCube.oraclePassword.value="";
        }

        inputHost = document.publishCube.db2Host.value;
        if(inputHost.indexOf('spend.db2.database.host') != -1){
                document.publishCube.db2Host.value="";
                document.publishCube.db2Port.value="";
                document.publishCube.db2DatabaseName.value="";
                document.publishCube.db2Username.value="";
                document.publishCube.db2Password.value="";
        }
	}


</script>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="cube.job.publish.title" bundle="sdmMessages"/></title>
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/scripts/sdm.css">
</head>
<body  onload="onloadChecks();">
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
<div id="msgDiv" style="display:none">
<logic:messagesPresent message="true">
	<font color="red" face="Arial, Helvetica, sans-serif" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="sdmMessages">
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=pageContext.findAttribute("msg")%>
		</html:messages>
		</b>
	</font>
</logic:messagesPresent>
</div>
<form name="publishCube" id="publishCube" action="/PrePublishInputSetJobActionb" method="post">

	<table class="InnerTableWithBorder"  cellSpacing="0" align="center" cellPadding="0"  border="0">
		<tr>
			<td class=POPFORMTITLE ><bean:message key="cube.job.publish.title" bundle="sdmMessages"/></td>
			<td class=POPFORMTITLE style="TEXT-ALIGN: right;"><img src="/expensemap/jsp/images/help.gif" border="0" title="Help"	 style="cursor: pointer"></td>
		</tr>
		<tr>
			<td class="POPFORMLABEL" width="50%" style="padding-right:8px" ><bean:message key="ui.label.target.database" bundle="sdmMessages"/></td>
			<td class="POPFORMFIELD" ><input type="radio" name="targetDB" id="mysqlDb" checked onclick="showsqlConfig();"><bean:message key="ui.label.database.mysql" bundle="sdmMessages"/></input>
			<input type="radio" name="targetDB" id="oracleDb"   onclick="showOracleCofig();"/><bean:message key="ui.label.database.oracle" bundle="sdmMessages"/></input>
			</td>
		</tr>
		<tbody width="100%" id="oracleConfig" style="display: none" >
			<tr style="height: 28px" valign="center">
			   <td class="POPFORMLABEL" width="50%" style="padding-right:8px"><bean:message key="ui.label.oracle.database.host" bundle="sdmMessages"/>&nbsp;<font  color="red">*</font></td>
			   <td class="POPFORMFIELD" align="left" width="50%" style="padding-right:8px">&nbsp;<html:text name="publishInputSetJobForm" property="oracleHost"  size="20" maxlength="100"/></td>
			</tr>
			<tr>
			   <td class="POPFORMLABEL" width="50%" style="padding-right:8px"><bean:message key="ui.label.oracle.database.port" bundle="sdmMessages"/>&nbsp;<font  color="red">*</font></td>
			   <td class="POPFORMFIELD" align="left" width="50%" style="padding-right:8px">&nbsp;<html:text name="publishInputSetJobForm" property="oraclePort" size="20" maxlength="10"/></td>
			</tr>
			<tr>
			  <td class="POPFORMLABEL" width="50%" style="padding-right:8px"><bean:message key="ui.label.oracle.database.service.name" bundle="sdmMessages"/>&nbsp;<font  color="red">*</font> </td>
			   <td class="POPFORMFIELD" align="left" width="50%" style="padding-right:8px">&nbsp;<html:text name="publishInputSetJobForm" property="oracleServiceName" size="20" maxlength="100"/></td>
			</tr>
			<tr>
			   <td class="POPFORMLABEL" width="50%" style="padding-right:8px"><bean:message key="ui.label.oracle.database.user" bundle="sdmMessages"/>&nbsp;<font  color="red">*</font> </td>
			   <td class="POPFORMFIELD" align="left"  width="50%" style="padding-right:8px">&nbsp;<html:text name="publishInputSetJobForm" property="oracleUserName" size="20" maxlength="100"/></td>
			</tr>
			<tr>
			   <td class="POPFORMLABEL" width="50%" style="padding-right:8px"><bean:message key="ui.label.oracle.database.password" bundle="sdmMessages"/>&nbsp;<font  color="red">*</font></td>
			   <td class="POPFORMFIELD" align="left" width="50%" style="padding-right:8px">&nbsp;<html:password name="publishInputSetJobForm" property="oraclePassword" size="20" maxlength="100" disabled="disabled"  style="display: none"  />
			   <A onclick="changePassword(document.publishCube.oraclePassword);" style="cursor: pointer;"><IMG border=0 src="/expensemap/jsp/images/edit.gif" title="<bean:message key='ui.label.Change.Password'/>"> </A>
			  </td>
			</tr>
		</tbody>
		<tbody width="100%" id="db2config" style="display: none" >
			<tr style="height: 28px" valign="center">
			   <td class="POPFORMLABEL" width="50%" style="padding-right:8px">DB2 Database host<font  color="red">*</font></td>
			   <td class="POPFORMFIELD" align="left" width="50%" style="padding-right:8px">&nbsp;<html:text name="publishInputSetJobForm" property="db2Host"  size="20" maxlength="100"/></td>
			</tr>
			<tr>
			   <td class="POPFORMLABEL" width="50%" style="padding-right:8px">DB2 Database port<font  color="red">*</font></td>
			   <td class="POPFORMFIELD" align="left" width="50%" style="padding-right:8px">&nbsp;<html:text name="publishInputSetJobForm" property="db2Port" size="20" maxlength="10"/></td>
			</tr>
			<tr>
			  <td class="POPFORMLABEL" width="50%" style="padding-right:8px">DB2 Database Name<font  color="red">*</font> </td>
			   <td class="POPFORMFIELD" align="left" width="50%" style="padding-right:8px">&nbsp;<html:text name="publishInputSetJobForm" property="db2DatabaseName" size="20" maxlength="100"/></td>
			</tr>
			<tr>
			   <td class="POPFORMLABEL" width="50%" style="padding-right:8px">DB2 Database User<font  color="red">*</font> </td>
			   <td class="POPFORMFIELD" align="left"  width="50%" style="padding-right:8px">&nbsp;<html:text name="publishInputSetJobForm" property="db2Username" size="20" maxlength="100"/></td>
			</tr>
			<tr>
			   <td class="POPFORMLABEL" width="50%" style="padding-right:8px">DB2 Database Password<font  color="red">*</font></td>
			   <td class="POPFORMFIELD" align="left" width="50%" style="padding-right:8px">&nbsp;<html:password name="publishInputSetJobForm" property="db2Password" size="20" maxlength="100" disabled="disabled"  style="display: none"  />
			   <A onclick="changePassword(document.publishCube.db2Password);" style="cursor: pointer;"><IMG border=0 src="/expensemap/jsp/images/edit.gif" title="<bean:message key='ui.label.Change.Password'/>"> </A>
			  </td>
			</tr>
		</tbody>
		<tr>
		   <td class="POPFORMRULE" colSpan="5" height="1"> </td>
		</tr>
		<tbody id="registerCheck" >
		<tr>
			<td class="POPFORMLABEL" width="50%" style="padding-right:8px"><bean:message key="cube.job.publish.with.sa.registration.message" bundle="sdmMessages"/></td>
			<td class="POPFORMFIELD" ><input type="checkbox" name="registerBox" id="registerBox" onclick="showDataSetList();"/></td>
		</tr>
		</tbody >
		<tr>
		   <td class="POPFORMRULE" colSpan="5" height="1"> </td>
		</tr>
		
		<tbody id="dataSetListTR" style="display: none">
		<tr> 
			<td class="POPFORMLABEL" width="50%" style="padding-right:10px" ><bean:message key="cube.job.older.cube.msg" bundle="sdmMessages"/></td>
			<td class="POPFORMFIELD" style="padding-left:5px">
				<html:select name="publishInputSetJobForm" style="cubeVersionInExternalForm" styleId="cubeVersionInExternalForm" property="cubeVersionInExternalForm">
					<html:options collection="compatibleDataSetList" property="value" labelProperty="label"/>
				</html:select>
			</td>
		</tr>
		<tr>
		    <td class="POPFORMRULE" colSpan="5" height="1"></td>
		</tr>
		</tbody>
	    <tr>
           <td  colSpan="5" align="center" class="buttonStyle">&nbsp;</td>
        </tr>
		<tr>
			<td colspan="2" align="center" class="buttonStyle">
				<html:button style="submitBtn" styleId="submitBtn" property="submitBtn" onclick="submitForm();"><bean:message key="ui.cube.job.submit.button" bundle="sdmMessages"/></html:button>&nbsp;
				<html:button property="cancel" styleId="cancel" onclick="window.close();"><bean:message key="ui.import.cancle.button" bundle="sdmMessages"/></html:button>
			</td>
		</tr>
	    <tr>
           <td  colSpan="5" align="center" class="buttonStyle">&nbsp;</td>
        </tr>
	</table>
	<input type="hidden" name="allowedRegistration" id="allowedRegistration"  value="<c:out value='${requestScope.allowedRegistration}'/>"/>
	<input type="hidden" name="changePwd" id="changePwd" value="false"/>
	<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</form>
</body>
</html>