<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf"%>
<%@ page import ="com.zeborg.expensemap.view.*"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<html>
<head>

<c:set var="displayNumberFormat" value="##.##" />	

<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.dashboard.label.dashboard.preference" bundle="dashboard"  /></title>
<script type="text/javascript">
function initFrm(){		
	//for enabling,disabling listBox according to checkbox(checked) 
	enableDisableLegendPosition();
	
}

function savePreferences(){
	var frm = document.getElementById("dashboardCrosstabPanelPreferenceForm");
	var rot=document.getElementById("rotation").value;
	var elev=document.getElementById("elevation").value;
	var dep=document.getElementById("depth").value;
	var depg=document.getElementById("depthGap").value;	
	var noOfChars  = document.getElementById("maxNoOfChars").value;
	var msg='';
	
	if(trim(noOfChars) == ''){
		msg=msg+'<bean:message key="ui.message.max.x.label.characters" bundle="dashboard"/>  \n ';
	}else if(!IsNumeric(trim(noOfChars))){
		msg=msg+'<bean:message key="ui.message.valid.value.max.x.label.characters" bundle="dashboard"/>  \n ';
	}
		var temp = parseInt(trim(noOfChars));
		if(temp == 0 || temp < 0){
			msg = msg + '<bean:message key="ui.message.zero.less.max.x.label.characters" bundle="dashboard"/>  \n ';
		} 
	
	if(trim(rot)==''){
		msg=msg+'<bean:message key="ui.message.rotation" bundle="dashboard"/>  \n ';
	}else if(!IsNumeric(trim(rot))){
		msg=msg+'<bean:message key="ui.message.valid.value.rotation" bundle="dashboard"/>  \n ';
	}else if(!isWithinRange(trim(rot), -90, +90)){
		msg=msg+'<bean:message key="ui.message.valid.range.value.rotation" bundle="dashboard"/>  \n ';
	}

	if(trim(elev)==''){
		msg=msg+'<bean:message key="ui.message.elevation" bundle="dashboard"/>  \n ';
	}else if(!IsNumeric(trim(elev))){
		msg=msg+'<bean:message key="ui.message.valid.value.elevation" bundle="dashboard"/>  \n ';
	}else if(!isWithinRange(trim(elev), -90, +90)){
		msg=msg+'<bean:message key="ui.message.valid.range.value.elevation" bundle="dashboard"/>  \n ';
	}

	if(trim(dep)==''){
		msg=msg+'<bean:message key="ui.message.depth" bundle="dashboard"/>  \n ';
	}else if(!IsNumeric(trim(dep))){
		msg=msg+'<bean:message key="ui.message.valid.value.depth" bundle="dashboard"/>  \n ';
	}else if(!isWithinRange(trim(dep), 0, 100)){
		msg=msg+'<bean:message key="ui.message.valid.range.value.depth" bundle="dashboard"/>  \n ';
	}
	
	if(trim(depg)==''){
		msg=msg+'<bean:message key="ui.message.depth.gap" bundle="dashboard"/>  \n ';
	}else if(!IsNumeric(trim(depg))){
		msg=msg+'<bean:message key="ui.message.valid.value.depth.gap" bundle="dashboard"/>  \n ';
	}else if(!isWithinRange(trim(depg), 0, 100)){
		msg=msg+'<bean:message key="ui.message.valid.range.value.depth.gap" bundle="dashboard"/>  \n ';
	}

	var minValue  = trim(document.getElementById("yScaleMinValue").value);
	if(minValue == '') {
		msg = msg + "<bean:message key='ui.message.enter.min.value' bundle='dashboard' />" + "\n ";
	} else if(!isDecimal(minValue)) {
		msg=msg + "<bean:message key='ui.message.valid.value.min.axis.option' bundle='dashboard' />" + "\n";
	}

	var maxValue  = trim(document.getElementById("yScaleMaxValue").value);
	if(maxValue == '') {
		msg = msg + "<bean:message key='ui.message.enter.max.value' bundle='dashboard' />" + "\n ";
	} else if(!isDecimal(maxValue)) {
		msg=msg + "<bean:message key='ui.message.valid.value.max.axis.option' bundle='dashboard' />" + "\n";
	}

	if(parseFloat(minValue) >= parseFloat(maxValue)) {
		msg=msg + "<bean:message key='ui.message.valid.value.min.max.axis.option' bundle='dashboard' />" + "\n";
	}
	
	if(trim(msg)!=''){
		alert(msg);
		return false;
	}
	
	if (confirm("<bean:message	key='ui.chart.refresh.msg' bundle='dashboard' />")){
		frm.submit();		
	}
}

function closePrefsWindow(){
	window.close();
}

function trim(str, chars) {
    return ltrim(rtrim(str, chars), chars);
}

function ltrim(str, chars) {
    chars = chars || "\\s";
    return str.replace(new RegExp("^[" + chars + "]+", "g"), "");
}

function rtrim(str, chars) {
    chars = chars || "\\s";
    return str.replace(new RegExp("[" + chars + "]+$", "g"), "");
}

function IsNumeric(strString){
	var strValidChars = "0123456789-";
	var strChar;
	var blnResult = true;
	if (strString.length == 0) return false;
	//  test strString consists of valid characters listed above
	for (i = 0; i < strString.length && blnResult == true; i++){
		strChar = strString.charAt(i);
		if (strValidChars.indexOf(strChar) == -1) {
      		blnResult = false;
      	}
   }
   return blnResult;
}
   
// check to see if value is within min and max
function isWithinRange(val, min, max){
	if (val >= min && val <= max){
		return true;
	}else{
		return false;
	}
}

//Generic function to check if number is valid or not 
//var tests = [1, '89 768', 1099511627776,20000000, 0, 1, "0", 0x0, 0x000, "0000", "0x89f", 8e5, 0x23, -0, 0.0, "1.0", 1.0, -1.5, 0.42, '075', "01", '-01', "0.", ".0", "a", "a2", true, false, "#000", '1.2.3', '#abcdef', '', "", "\n", "\t", '-', null, undefined];
function isNumber(n) { 
  return !isNaN(parseFloat(n)) && isFinite(n);
}

function isDecimal(n) {
	return isNumber(n)
}

function enableDisableLegendPosition() {
	var legendPosition=document.getElementById("legendPosition");
	var legend=document.getElementById("showLegend");
	if (legend.checked) {
		legendPosition.disabled=false;
	} else{
		legendPosition.disabled=true;
	}
}

</script>
<style>
.panelHeadingStyle { font-family: Arial, Helvetica, sans-serif;font-weight:bold;font-size: 13px; color: #000000; text-align:left; background-color: #ECF4FE; }
.rowHeadingStyle { font-family: Arial, Helvetica, sans-serif;font-size: 12px; color: #000000; text-align:left; background-color: #ECF4FE; }
.infoStyle { font-family: Arial, Helvetica, sans-serif;font-size: 11px; color: red; text-align:left; background-color: #ECF4FE; }
table.my {background-color: #ECF4FE;border: 1px solid light gray;}
</style>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/tabview/assets/skins/sam/tabview.css">
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/dashboardscss.css">
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/tabview/tabview-min.js"></script>

<script type="text/javascript">
//Instantiate Tab View divs appearing in markup below render tabs for the TabView 
var myTabs = new YAHOO.widget.TabView("demo");
</script>
</head>
<body class="yui-skin-sam" onload="javascript:initFrm();">
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
<logic:messagesPresent message="true">
<table  align="right">
	<tr>
	<td align="left" valign="top" >
		<br>
		<font color="red" face="Verdana" size="2">
			<b>
			<html:messages id="msg" message="true" bundle="dashboard">
				<%=pageContext.findAttribute("msg")%>
			</html:messages>
			</b>
		</font>
		</td>
	</tr>
</table>
</logic:messagesPresent>
<html:form action="/saveCrosstabPanelPreferences" method="post" styleId="dashboardCrosstabPanelPreferenceForm">

<div id="demo" class="yui-navset">

<ul class="yui-nav">
	<li class="selected"><a id="tabStyle" href="#tab1"><em><bean:message key='ui.label.mainViewMode.Chart' bundle='dashboard' /></em></a></li>
	<li><a id="tabStyle" href="#tab2"><em><bean:message key='ui.dashboard.label.gridlines' bundle='dashboard' /></em></a></li>
	<li><a id="tabStyle" href="#tab3"><em><bean:message key='ui.dashboard.label.legend' bundle='dashboard' /></em></a></li>
	<li><a id="tabStyle" href="#tab4"><em><bean:message key='ui.dashboard.label.threed.view' bundle='dashboard' /></em></a></li>
	<li><a id="tabStyle" href="#tab5"><em><bean:message key='ui.dashboard.label.titles' bundle='dashboard' /></em></a></li>
	<li><a id="tabStyle" href="#tab6"><em><bean:message key='ui.dashboard.label.formatting' bundle='dashboard' /></em></a></li>	
</ul>

<div class="yui-content">
<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.type' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
			<html:select styleId="chartType" name="dashboardCrosstabPanelPreferenceForm" size="1" style="width:185px" property="chartType">
				<c:forEach items="${ dashboardCrosstabPanelPreferenceForm.supportedChartTypes }" var="chartType">
					<html:option value="${ chartType.intValue }"><bean:message key='${ chartType.resourceKey }' bundle='dashboard' /></html:option>
				</c:forEach>
			</html:select>
		</TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.crosstab.label.max.x.characters' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:text property="maxNoOfChars" styleId="maxNoOfChars" size="5" maxlength="2"/>
		</TD>					
	</TR>
	
<TR>
<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left">
<bean:message key='ui.label.show.data.points' bundle='dashboard' />
</TD>
<TD rowspan="1" colspan="1" align="left" nowrap>
<html:checkbox name="dashboardCrosstabPanelPreferenceForm" property="showMeasureValues" styleId="showMeasureValues" ></html:checkbox>
</TD>			
</TR>	
	
		
</TABLE>
</div>

<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.show.xgrid' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
			<html:checkbox name="dashboardCrosstabPanelPreferenceForm" styleId="showYGrid" property="showYGrid" ></html:checkbox>
	    </TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.show.ygrid' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
			<html:checkbox name="dashboardCrosstabPanelPreferenceForm" styleId="showYGrid" property="showXGrid" ></html:checkbox>
		
		</TD>
	</TR>
</TABLE>
</div>

<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.show.legend' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
			<html:checkbox name="dashboardCrosstabPanelPreferenceForm" property="showLegend" styleId="showLegend" onclick="enableDisableLegendPosition();" ></html:checkbox>
		</TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.legend.position' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
			<html:select name="dashboardCrosstabPanelPreferenceForm" size="1" style="width:185px" property="legendPosition" styleId="legendPosition" >
			<html:option value="TOP"><bean:message key="ui.dashboard.label.legend.position.top" bundle="dashboard"/></html:option>
			<html:option value="RIGHT"><bean:message key="ui.label.Right" bundle="dashboard"/></html:option>
			<html:option value="BOTTOM"><bean:message key="ui.dashboard.label.legend.position.bottom" bundle="dashboard"/></html:option>
			<html:option value="LEFT"><bean:message key="ui.label.Left" bundle="dashboard"/></html:option>
		</html:select></TD>
	</TR>
</TABLE>
</div>

<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.projection' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:select name="dashboardCrosstabPanelPreferenceForm" size="1" style="width:185px" property="projection" styleId="projection" >
			<html:option value="1"><bean:message key="ui.dashboard.label.oblique" bundle="dashboard"/></html:option>
			<html:option value="0"><bean:message key="ui.dashboard.label.orthographic" bundle="dashboard"/></html:option>
		</html:select></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.rotation' bundle='dashboard' /></TD>
		<TD class="infoStyle" rowspan="1" colspan="1" align="left" nowrap>
		<html:text property="rotation" styleId="rotation" size="5" />
			<bean:message key="ui.dashboard.label.rotation.range" bundle="dashboard"/></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message	key='ui.dashboard.label.elevation' bundle='dashboard' /></TD>
		<TD class="infoStyle" rowspan="1" colspan="1" align="left" nowrap>
		<html:text property="elevation" styleId="elevation" size="5" />
		
		<bean:message key="ui.dashboard.label.elevation.range" bundle="dashboard"/> </TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.depth' bundle='dashboard' /></TD>
		<TD class="infoStyle" rowspan="1" colspan="1" align="left" nowrap>
		<html:text property="depth" size="5" styleId="depth"/>
		<bean:message key="ui.dashboard.label.depth.range" bundle="dashboard"/></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message	key='ui.dashboard.label.depth.gap' bundle='dashboard' /></TD>
		<TD class="infoStyle" rowspan="1" colspan="1" align="left" nowrap>
		<html:text property="depthGap" styleId="depthGap" size="5"/>
		<bean:message key="ui.dashboard.label.depth.gap.range" bundle="dashboard"/></TD>
	</TR>
</TABLE>
</div>

<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.chart.title' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:text property="chartTitle" styleId="chartTitle" size="5"/>
		</TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.chart.footer' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:text property="chartFooter" styleId="chartFooter" size="5"/>
		</TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.xaxis.title' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:text property="xaxisTitle" styleId="xaxisTitle" size="5"/>
		</TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.yaxis.title' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:text property="yaxisTitle" styleId="yaxisTitle" size="5"/>
		</TD>
	</TR>
</TABLE>
</div>

<div>
<TABLE>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.font' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:select name="dashboardCrosstabPanelPreferenceForm" size="1" style="width:185px" property="fontName" styleId="fontName">
			<html:option value="Arial"><bean:message key="ui.dashboard.label.arial" bundle="dashboard"/></html:option>
			<html:option value="Arial Black"><bean:message key="ui.dashboard.label.arialblack" bundle="dashboard"/></html:option>
			<html:option value="Arial Narrow"><bean:message key="ui.dashboard.label.arialnarrow" bundle="dashboard"/></html:option>
			<html:option value="Arial Rounded MT Bold"><bean:message key="ui.dashboard.label.arialroundedbold" bundle="dashboard"/></html:option>
			<html:option value="Courier"><bean:message key="ui.dashboard.label.courier" bundle="dashboard"/></html:option>
			<html:option value="Courier New"><bean:message key="ui.dashboard.label.couriernew" bundle="dashboard"/></html:option>
			<html:option value="default"><bean:message key="ui.label.Default" bundle="dashboard"/></html:option>
			<html:option value="Dialog"><bean:message key="ui.dashboard.label.dialog" bundle="dashboard"/></html:option>
			<html:option value="Times"><bean:message key="ui.dashboard.label.times" bundle="dashboard"/></html:option>
			<html:option value="Times New Roman"><bean:message key="ui.dashboard.label.timesnewroman" bundle="dashboard"/></html:option>
			<html:option value="Verdana"><bean:message key="ui.dashboard.label.verdana" bundle="dashboard"/></html:option>
		</html:select></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.font.style' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:select name="dashboardCrosstabPanelPreferenceForm" size="1" style="width:185px" property="fontStyle" styleId="fontStyle" >
			<html:option value="0"><bean:message key="ui.dashboard.label.regular" bundle="dashboard"/></html:option>
			<html:option value="1"><bean:message key="ui.dashboard.label.bold" bundle="dashboard"/></html:option>
			<html:option value="2"><bean:message key="ui.dashboard.label.italic" bundle="dashboard"/></html:option>
			<html:option value="3"><bean:message key="ui.dashboard.label.bolditalic" bundle="dashboard"/></html:option>
		</html:select></TD>
	</TR>
	<TR>
		<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message key='ui.dashboard.label.font.size' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<html:select name="dashboardCrosstabPanelPreferenceForm" size="1" style="width:185px" property="fontSize" styleId="fontSize" >
			<html:option value="7"><bean:message key="ui.dashboard.label.seven" bundle="dashboard"/></html:option>
			<html:option value="8"><bean:message key="ui.dashboard.label.eight" bundle="dashboard"/></html:option>
			<html:option value="9"><bean:message key="ui.dashboard.label.nine" bundle="dashboard"/></html:option>
			<html:option value="10"><bean:message key="ui.dashboard.label.ten" bundle="dashboard"/></html:option>
			<html:option value="11"><bean:message key="ui.dashboard.label.eleven" bundle="dashboard"/></html:option>
			<html:option value="12"><bean:message key="ui.dashboard.label.twelve" bundle="dashboard"/></html:option>
			<html:option value="13"><bean:message key="ui.dashboard.label.thirteen" bundle="dashboard"/></html:option>
			<html:option value="14"><bean:message key="ui.dashboard.label.fourteen" bundle="dashboard"/></html:option>
			<html:option value="15"><bean:message key="ui.dashboard.label.fifteen" bundle="dashboard"/></html:option>
			<html:option value="16"><bean:message key="ui.dashboard.label.sixsteen" bundle="dashboard"/></html:option>
			<html:option value="17"><bean:message key="ui.dashboard.label.seventeen" bundle="dashboard"/></html:option>
			<html:option value="18"><bean:message key="ui.dashboard.label.eighteen" bundle="dashboard"/></html:option>
			<html:option value="19"><bean:message key="ui.dashboard.label.nineteen" bundle="dashboard"/></html:option>
			<html:option value="20"><bean:message key="ui.dashboard.label.twenty" bundle="dashboard"/></html:option>
			<html:option value="21"><bean:message key="ui.dashboard.label.twentyone" bundle="dashboard"/></html:option>
		</html:select></TD>
	</TR>
	<TR>
	<TD class="rowHeadingStyle" rowspan="1" colspan="2" align="left"><b><bean:message
				key='ui.label.axis.options' bundle='dashboard' /></b></TD>
	</TR>
	<TR>
	<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message	key='ui.label.axis.option.min.value' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>
		<fmt:formatNumber pattern="${displayNumberFormat}" value="${dashboardCrosstabPanelPreferenceForm.yScaleMinValue}" var="yScaleMinValue_fmt"/>	
		<html:text name="dashboardCrosstabPanelPreferenceForm" property="yScaleMinValue" styleId="yScaleMinValue" size="16" maxlength="16" value="${yScaleMinValue_fmt}"  />
		</TD>		
	</TR>
	<TR>
	<TD class="rowHeadingStyle" rowspan="1" colspan="1" align="left"><bean:message	key='ui.label.axis.option.max.value' bundle='dashboard' /></TD>
		<TD rowspan="1" colspan="1" align="left" nowrap>	
		<fmt:formatNumber pattern="${displayNumberFormat}" value="${dashboardCrosstabPanelPreferenceForm.yScaleMaxValue}" var="yScaleMaxValue_fmt"/>	
		<html:text name="dashboardCrosstabPanelPreferenceForm" property="yScaleMaxValue" styleId="yScaleMaxValue" size="16" maxlength="16" value="${yScaleMaxValue_fmt}"  />
		</TD>		
	</TR>
</TABLE>
</div>
</div>
</div>
<TABLE class="my" width="100%">
<TR>
	<TD rowspan="1" colspan="1" align="right" nowrap><button onclick="javascript:return savePreferences();"><bean:message key='ui.label.Save' bundle='dashboard' /></button></TD>
	<TD rowspan="1" colspan="1" align="left" nowrap><button onclick="javascript:closePrefsWindow();"><bean:message	key='ui.label.Cancel' bundle='dashboard' /></button></TD>
</TR>
</TABLE>

<input type="hidden" name="dbid" value="<c:out value='${param.dbId}'/>" > 
<input type="hidden" name="dbpanelid" value="<c:out value='${param.dbPanelId}'/>" >

</html:form>
</body>
</html>