<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../../includes/tlib.jspf"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="com.zeborg.util.WebUtil, com.emptoris.viewer.util.CSRFHelper" %>

<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="java.util.Locale"%>
<%@ page import="org.owasp.esapi.ESAPI"%>

<%
    ZSession zs = ZSessionUtil.getFromSession(pageContext);
    Locale locale = zs.getUser().getLocale();
	String helpURL = com.zeborg.expensemap.view.HelpUtil.getHelpUtil().getHelpURLString("ui.help.dashboards.pdf.export.dashboardpanel",locale);
%>

<html:html>
<head>
<html:javascript formName="exportPDFForm"/>
<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.dashboard.menu.export.to.pdf" bundle="dashboard" /></title>
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/dashboardscss.css">
<script type="text/javascript" src="/expensemap/jsp/javascript/export_pdf.js"></script>
<script language="JavaScript">
var errmessage_PDFFileName = "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' bundle='dashboard'/>";
var errmessage_PDFNotes ="<bean:message key='ui.pdf.create.page.error.message.notes' bundle='dashboard'/>";

function openHelp(){
	window.open('<%=helpURL%>',"_blank");
}

function validateForm() {
	setFilterAndPagingValues();
	if (!validatePdfForm(errmessage_PDFFileName,errmessage_PDFNotes)) {
		return false;
	}
}

function setFilterAndPagingValues(){
	/* Applied filter information and paging information is set in renderDashboard.jsp. 
	Read those value using window.opener.parent.document.getElementById and set it locally.*/

	var fstr = '';var pageStr = '';
	
	if(window.opener.parent.document.getElementById("PDFpanelFilters")){
		fstr = window.opener.parent.document.getElementById("PDFpanelFilters").value;
	}
	
	if(window.opener.parent.document.getElementById("PDFpanelPageString")){
		pageStr = window.opener.parent.document.getElementById("PDFpanelPageString").value;
	}
	
	document.getElementById("filtersApplied").value = fstr;
	document.getElementById("pagingInfo").value = pageStr;
}

function init(){
	document.getElementById("fileName").focus();
}

</script>
</head>
<body leftmargin=2 topmargin=2 marginwidth=1 marginheight=1 onload="init();">

<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
<logic:messagesPresent message="true">
	<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
	<font color="red" face="Arial" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="dashboard">
			<%=pageContext.findAttribute("msg")%>
		</html:messages>
		</b>
	</font>
</logic:messagesPresent>
<div>
	<font color="red" face="Arial" size="2">
		<logic:notEmpty name="pdfNonOptimalMoreColumnsPanels">
			<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<bean:message key="ui.message.pdf.panel.export.warning.more.columns" bundle="dashboard"/>
			<logic:iterate id="nonOptimalPanel" name="pdfNonOptimalMoreColumnsPanels">
			<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;- <c:out value='${nonOptimalPanel}'/>
			</logic:iterate>
		</logic:notEmpty>
		<logic:notEmpty name="pdfNonOptimalLargeImagePanels">
			<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<bean:message key="ui.message.pdf.panel.export.warning.large.image" bundle="dashboard"/>
			<logic:iterate id="nonOptimalPanel" name="pdfNonOptimalLargeImagePanels">
			<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;- <c:out value='${nonOptimalPanel}'/>
			</logic:iterate>
		</logic:notEmpty>
		<logic:notEmpty name="pdfNonOptimalMoreColumnsPanels">
			<br><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<bean:message key="ui.message.pdf.export.warning" bundle="dashboard"/>
		</logic:notEmpty>
		<logic:empty name="pdfNonOptimalMoreColumnsPanels">
			<logic:notEmpty name="pdfNonOptimalLargeImagePanels">
				<br><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<bean:message key="ui.message.pdf.export.warning" bundle="dashboard"/>
			</logic:notEmpty>
		</logic:empty>
	</font>
</div>
<br>
<html:form method="post" styleId="exportPDFForm" action="exportToPDF.do">
<input type="hidden" name="exportType" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("exportType"))%>">
<table class="InnerTableWithBorder" align="center" style="background-color: #ECF4FE;border: 1px solid light gray;width:94%">
	<tr>
		<td class="reportTitle" align="left"><bean:message key="ui.dashboard.menu.export.to.pdf" bundle='dashboard'  /></td>
		<td align="right"><a href="#" onclick="openHelp();"><img  src="/expensemap/jsp/images/help.gif" border="0" title="<bean:message  key='ui.label.Help' bundle='dashboard'/>"/></a></td>
	</tr>
	<tr><td colspan="2"><hr noshade size="1"></td></tr>
	<tr>
		<td align="right"><span class="pdfLabelStyle"><bean:message key="ui.label.File.Name"  bundle="dashboard" />:</span></td>
		<td align="left"><html:text property="fileName" styleId="fileName" size="40" styleClass="pdfInputStyle"/></td>	
	</tr>
	<tr>
		<td align="right"><span class="pdfLabelStyle"><bean:message key="ui.dashboard.create.page.panel.name" bundle="dashboard" />:</span></td>
		<td align="left"><span class="pdfLabelStyle"><b><c:out value='${ panelName }'/></b></span></td>			    
	</tr>
	<tr>
		<td align="right"><span class="pdfLabelStyle"><bean:message key="ui.dashboard.pdf.export.notes"  bundle="dashboard" />:</span></td>
		<td align="left"><html:textarea property="notes" styleId="notes" cols="50" rows="3" styleClass="pdfInputStyle"/></td>
	</tr>
	<tr><td colspan="2"><hr noshade size="1"></td></tr> 
	<tr>
		<td colspan="2" align="center">
			<html:submit property="submitBtn" onclick="javascript:return validateForm();"><bean:message key="button.submit"  bundle="dashboard" /></html:submit>&nbsp;
			<html:button property="cancel" onclick="window.close();"><bean:message key="ui.label.Cancel"  bundle="dashboard" /></html:button>
		</td>
	</tr>
</table>
<input type="hidden" name="panelId" value="<c:out value='${ panelId }'/>" />
<input type="hidden" name="dashboardId" value="<c:out value='${ dashboardId }'/>" />
<input type="hidden" name="filtersApplied" id="filtersApplied" />
<input type="hidden" name="pagingInfo" id="pagingInfo" />
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</html:form>
</body>
</html:html>