<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import ="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="java.util.Locale"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.text.SimpleDateFormat"%>

<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext); 
	Locale locale = WebUtil.getAppLocale(pageContext);
	//make url for help page    
	HelpUtil emHelp = HelpUtil.getHelpUtil();
	String helpURL = "To be done";
	String date = new SimpleDateFormat("EEE MMM d HH:mm:ss z Z yyyy").format(new Date());


%>

<html:html>
<head>
	<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.job.dimension.classification.wrt.kb.title" bundle="dataEnrichmentMessages" /></title>

<SCRIPT type="text/javascript">

	function initTrainKnowledgeBaseForm(){
		var kbType = document.trainKnowledgeBaseForm.kbType;
		kbType.fireEvent("onchange");
	}
	
	function onClickSaveForm() {
			if (validateData()){				
				var confirmMessage = '<bean:message key="ui.job.dimension.clustering.submission.confirmation" bundle="dataEnrichmentMessages" arg0="[JOB_NAME]" arg1="<%=zs.getUser().getName()%>" arg2="<%=date%>"/>';
				confirmMessage = confirmMessage.replace('[JOB_NAME]', document.trainKnowledgeBaseForm.jobName.value);
				if (confirm(confirmMessage)) {
						var frm = document.getElementById("trainKnowledgeBaseForm");
						var argStr = "operation=" + "submitTrainKnowledgeBaseJob";
						var url = "/expensemap/dataenrichment/TrainKnowledgeBaseAction.do?" + argStr;
						frm.action=url;
						return true;
				}
			}
			return false;
		}
	function validateData(){
	
		return validateJobName() && validateDescriptionField() && validateJobExpirationDate() 
			&& validateDimensionToEnrich() && validateKbTypeAndKbVersion();
	
	}
	
	function validateJobName(){
			var jobNameObj = document.trainKnowledgeBaseForm.jobName;
			var iChars = "*|,\":<>[]{}`\';()@&$#%";
			return validateRequired(jobNameObj, "<bean:message key='ui.job.dimension.clustering.jobName.required' bundle='dataEnrichmentMessages'/>") && validateSpecialChars(jobNameObj, "<bean:message key='ui.job.dimension.clustering.jobName.no.special.char' bundle='dataEnrichmentMessages'/>",  iChars );
		}
		
		function validateJobExpirationDate(){
			var jobExpirationDate = document.trainKnowledgeBaseForm.jobExpirationDate.value;	

			if ( isValidDate(jobExpirationDate) == false ) {
				alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.format' bundle='dataEnrichmentMessages'/>");
				return false;
			}

			if(!isEmpty(jobExpirationDate)){
				if(isValidDate(jobExpirationDate)){
					var jobExpirationDateHourMinute = document.trainKnowledgeBaseForm.jobExpirationDateHourMinute.value;	
					if(!validateHourMinute(jobExpirationDateHourMinute)){						
						document.trainKnowledgeBaseForm.jobExpirationDateHourMinute.value = '';	
						alert("<bean:message key='ui.job.dimension.clustering.time.format' bundle='dataEnrichmentMessages'/>");
						return false;
					}else {
						var tmArr = document.trainKnowledgeBaseForm.jobExpirationDateHourMinute.value.split(":");
						if( !checkWithCurrentDate(jobExpirationDate, tmArr[0]  , tmArr[1] )){
							alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.is.less' bundle='dataEnrichmentMessages'/>");
							return false;
						}
					}
				}
			}else
			{
				alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.required' bundle='dataEnrichmentMessages'/>");
				document.trainKnowledgeBaseForm.jobExpirationDate.value="";
				document.trainKnowledgeBaseForm.jobExpirationDate.focus();
				return false;
			}
			return true;
		}
			
		function validateDimensionToEnrich(){
			var dimensionToEnrichObj = document.trainKnowledgeBaseForm.clsssifiedDimension;
			return validateRequired(dimensionToEnrichObj, "<bean:message key='ui.job.dimension.clustering.dimension.to.enrich.required' bundle='dataEnrichmentMessages'/>" );
        }
        
        function validateKbTypeAndKbVersion(){
			var kbTypeObj = document.trainKnowledgeBaseForm.kbType;
			var kbVersionObj = document.trainKnowledgeBaseForm.kbVersion;
			if(!validateRequired(kbTypeObj,"<bean:message key='ui.job.dimension.classification.kbType.required' bundle='dataEnrichmentMessages'/>")){
				return false;
			}
			if(!validateRequired(kbVersionObj,"<bean:message key='ui.job.dimension.classification.kbVersion.required' bundle='dataEnrichmentMessages'/>")){
				return false;
			}
            return true;
        }
        
        function validateDescriptionField() {
			var descriptionObj = document.trainKnowledgeBaseForm.description;
			var len = descriptionObj.value.length;
			if(len > 255){
				alert("<bean:message key='ui.job.description.validation.msg' bundle='dataEnrichmentMessages'/>");
				descriptionObj.value="";
				descriptionObj.focus();
				return false;
			}
			return true;	
		}
        
</SCRIPT>
<SCRIPT type="text/javascript">

		// onchange populate the version list of KB type
	function submitRequestForKbVersion(operation, selectTag){

		try {
			var kbType = selectTag.options[selectTag.selectedIndex].value;
			
			var argStr = "operation=" + operation + "&" +"kbType=" + kbType;
			var url = "/expensemap/dataenrichment/TrainKnowledgeBaseAction.do?" + argStr;
			jQuery.ajax({
				url: url,
				type: "GET",
				success: kbTypeResponseHandler,
				error: function(xhr, status, error) {
					alert('Error: ' + xhr.statusText);
					return false;
				},
				async: false
			});
		} catch(e) {
			 alert(e);
		}	
	}

	//handle the ajax response
	function kbTypeResponseHandler(ajaxResponse) {    
		var data = eval(ajaxResponse);

		// If there is no data in the response, ignore this
		if (data == null) {
			return;
		} else if( data[0]=="getKbVersions") {
			var kbVersion = document.getElementById("kbVersion");
			for( i=0; i < kbVersion.options.length;){
				kbVersion.options[i]=null;
			}

			for(i=1 ; i<data.length ; i=i+2){
				kbVersion.options[kbVersion.options.length] = new Option(data[i], data[i+1]);
			}
			if(kbVersion.options.length > 0){
				kbVersion.options[0].selected=true;
			}
		}
	}
	</SCRIPT>
</head>
	
	<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
	<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
	<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/css/dataenrichmentui.css">
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource.js"></script>
	<script type="text/javascript" src="/expensemap/scripts/popup-cal.js"></script>
	<script type="text/javascript" src="/expensemap/scripts/localeData.js"></script>
	<SCRIPT LANGUAGE="JavaScript" SRC="/expensemap/jsp/javascript/dataenrichment.js"></SCRIPT>

	<body class="yui-skin-sam" leftmargin="2" topmargin="2" marginwidth="1" marginheight="1">
	<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>

<html:form method="post" styleId="trainKnowledgeBaseForm" action="/TrainKnowledgeBaseAction.do" >

<TABLE WIDTH="96%" CELLPADDING="0" CELLSPACING="0" BORDER="0" align="center">
	<TR CLASS="POPFORMBODY">
		<TD>
			<TABLE CLASS="POPFORMBORDER" CELLPADDING="0" CELLSPACING="1" BORDER="0" WIDTH="100%"><TR CLASS="POPFORMBODY"><TD>
			
			<TABLE width="100%" cellspacing="0" cellpadding="0" border="0" CLASS="POPFORMBODY">
				<TR>
					<TD CLASS="POPFORMTITLE" STYLE="padding-left:3px" nowrap>
						<bean:message key="ui.job.train.knowledge.title" bundle="dataEnrichmentMessages" />
					</TD>
					<TD align="left" CLASS="POPFORMTITLE">
						<IMG  src="/expensemap/jsp/images/help.gif" border="0" title="Help"  onClick="window.open('<%=helpURL%>','help','')" align="right" style="cursor: pointer">
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.clustering.jobName" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>&nbsp;&nbsp;
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:text property="jobName" styleId="jobName" styleClass="inputStyle" size="20" maxlength="80"/>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.clustering.description" bundle="dataEnrichmentMessages" />
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:textarea property="description" cols="25" rows="2" styleId="description"/>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.clustering.job.expiration.date" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:text property="jobExpirationDate" size="15" styleId="jobExpirationDate" styleClass="inputStyle" maxlength="10" readonly="true"/>&nbsp;
						<html:text property="jobExpirationDateHourMinute" size="5" styleId="jobExpirationDateHourMinute" styleClass="inputStyle" maxlength="5" value="0:00"/>
						&nbsp;<bean:message key="ui.job.dimension.gmt" bundle="dataEnrichmentMessages" />&nbsp;<%=new SimpleDateFormat("Z").format(new Date())%>&nbsp;
						&nbsp;&nbsp;<font size="1"><bean:message key="ui.dataEnrichment.datePattern" bundle='dataEnrichmentMessages' /></font>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px">
						<bean:message key="ui.job.dimension.clustering.dimension.selection" bundle="dataEnrichmentMessages" />
						<span style = "color:red;font-size:18px">*</span>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.classification.clasified.dimension" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:select styleId="selectCompId" property="clsssifiedDimension">
							<html:options collection="dimensionNames" property="value" labelProperty="label" />
						</html:select>
						<BR>
						<logic:messagesPresent name="dimnesionIsLocked">
							<FONT COLOR="red" FACE="Arial, Helvetica, sans-serif" SIZE="2">
								<html:messages  name="dimnesionIsLocked" id="msg" bundle="dataEnrichmentMessages">
									<%=pageContext.findAttribute("msg")%>
								</html:messages>
							</FONT>
						</logic:messagesPresent>
					</TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.classification.kbtype" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:select property="kbType" onchange="submitRequestForKbVersion('getKbVersions',this)">
							<html:options collection="kbTypes" property="value" labelProperty="label" />
						</html:select>
					</TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.classification.kb.version" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:select property="kbVersion" styleId="kbVersion" >
							<html:options collection="kbVersions" property="value" labelProperty="label" />
						</html:select>
					</TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
						<INPUT TYPE="HIDDEN" id="operation" name="operation"/>
			</TABLE>
			<BR/>
			<DIV CLASS="POPFORMBUTTONS">
				<html:submit onclick="return onClickSaveForm();"><bean:message key="ui.job.tain.knowledge.base.button.label" bundle="dataEnrichmentMessages" /></html:submit>&nbsp;

				<html:button property="abc" onclick="top.window.close();"><bean:message key="ui.job.dimension.classification.button.close" bundle="dataEnrichmentMessages" /></html:button>

			</DIV>			
			<BR/>
			</TD></TR></TABLE>

			<DIV CLASS="POPFORMINSTRUCTIONS"><br><span style = "color:red;font-size:18px">*</span><bean:message key="ui.job.dimension.clustering.required.field" bundle="dataEnrichmentMessages" /></DIV>
		</TD>	
	</TR>
			
</TABLE>
</TD></TR></TABLE>
</html:form>


<script language="JavaScript">
	YAHOO.namespace('train.kb');
		(function() {
		var Event = YAHOO.util.Event;
		var Dom = YAHOO.util.Dom;
		YAHOO.train.kb = {
			init: function() {
				var self = YAHOO.train.kb;
				var jobExpDate = document.getElementById("jobExpirationDate");
								
				Event.on(jobExpDate, "focus", self.openCalendar, [jobExpDate, jobExpDate]);				
			},
			openCalendar: function(e, args) {
				YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '','');
			}
		}
		
		Event.onDOMReady(YAHOO.train.kb.init, YAHOO.train.kb, true);
	})();
</script>

</body>
</html:html>