<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="tlib.jspf" %>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>

<%
	// Set variables needed for display e.g. user name and build information.
	String ssmPublicURL = ExpenseMapAppProperties.getProductVSMURL().substring(0,  ExpenseMapAppProperties.getProductVSMURL().lastIndexOf("/"));
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	String company = "";
	String userName = "";
	String productTitle = "";
	if (zs != null ) {
		if ( zs.getDataSet() != null ) {
			company = zs.getDataSet().getAcCompany().getName().toUpperCase();
		}
		userName = zs.getUser().getDisplayName();
		if (userName == null){
			userName = zs.getUser().getName();
		}
		if (userName.length() > 25){
			userName = userName.substring(0, 25) + "...";
		}
	}
	EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_SRC_RESOURCE_BUNDLE, zs.getUser().getLocale());
	DateFormat fullformatter = DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.SHORT, zs.getUser().getLocale());
	SimpleDateFormat simpleForm = new SimpleDateFormat();
	String formattedDateString;
	try {
		formattedDateString = fullformatter.format(simpleForm.parse(ExpenseMapProperties.getBuildDate()));
	} catch (Exception e) {
		formattedDateString = ExpenseMapProperties.getBuildDate();
	}
	productTitle = ExpenseMapAppProperties.getCubeselectProductName()		
		+ " v"
		+ ExpenseMapProperties.getVersionNumber()
		+ "&nbsp;-&nbsp;"
		+ bundle.getValue("ui.label.Build")
		+ ": "
		+ ExpenseMapProperties.getBuildNumberPrefix()
		+ ExpenseMapProperties.getVersionNumber()
		+ "-"
		+ ExpenseMapProperties.getBuildNumberSuffix()
		+ " "
		+ bundle.getValue("ui.label.On")
		+ " "
		+ formattedDateString;
%>

<%@page import="com.zeborg.expensemap.view2.ZSession"%>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@page import="java.text.DateFormat"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@page import="com.zeborg.expensemap.util.ExpenseMapProperties"%>
<%@page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@page import="com.zeborg.expensemap.il8n.EmResourceBundle"%>
<%@page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>

<style type="text/css">
<!--
body {
	background-color: #FFFFFF;
	margin-left: 0px;
	margin-top: 0px;
	margin-right: 0px;
	margin-bottom: 0px;
}

.breadcrumb {
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 10px;
	font-weight: normal;
	color: #000000;
	padding-left: 10px;
}

#username {
	margin-right: 25px;
	cursor: default !important;
}
-->
</style>

<link rel=StyleSheet href='/expensemap/jsp/css/banner.css' type='text/css' media=screen>
<link rel='stylesheet' type='text/css' href='/expensemap/jsp/css/customization.css' />
<link rel='shortcut icon' href='/expensemap/jsp/images/favicon.ico' type='image/x-icon'>
<link rel="stylesheet" type="text/css" href="<%= ssmPublicURL %>/css/timeout.css">

<script src="/expensemap/jsp/javascript/caparea.js"></script>
<!-- jQuery is required for Ajax calls and also for the session timeout functionality. -->
<script type="text/javascript" src="<%= ssmPublicURL %>/js/jquery-1.8.3.min.js"></script>
<script type="text/javascript" src="<%= ssmPublicURL %>/js/jquery.idle-timer.js"></script>
<script type="text/javascript" src="<%= ssmPublicURL %>/js/jquery.idle-timeout.js"></script>
<script type="text/javascript" src="<%= ssmPublicURL %>/js/session-timeout.js"></script>
<script type="text/javascript">
function initSessionTimeout() {
			jQuery.ajax({
				url: '<%= ssmPublicURL %>/jaxrs/session-timeout-config',
				dataType: 'json',
				cache: false,
				success: function(data) {
					SESSION_TIMEOUT.config(data, 'base');
					SESSION_TIMEOUT.display();
				}
			});
		}

jQuery.noConflict(false);
</script >
<jsp:include page="../idle-timeout.jsp"/>
<div class='banner' id='spendPopupBanner'>
	<div class='bannerInnerContainer'>
		<table id='spendBannerTable' width='100%' border='0' cellspacing='0' cellpadding='0'>
			<tr>
				<td id='leftTD'>
					<div id='popupLogoDiv'>
						<img id='popupLogo' src='/expensemap/jsp/images/customization/logos/popup_left_logo.gif' />
					</div>
					<span class='productName'><%= ExpenseMapAppProperties.getExpensemapBannerTitle().replaceAll("&reg;", "<sup>&reg;</sup>") %></span>
				</td>
				
				<td id="rightTD" align="right">
					<span id="userMenuPopupAnchor">
						<a href="#" id="bannerUsername"><%= userName %></a>
					</span>
					<span class='productAlternativeLogoDiv'></span>
				</td>
			</tr>
		</table>
	</div>
</div>