/** 
 * (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */ 

<!-- Function to check all the reports. -->

var buttonSelected = false;

function selectCheckBox(checkBox, flag) {
	if ( checkBox.disabled == false ) {
		checkBox.checked = flag ;
	}
}

function checkAll(obj,checkList,noOfRows, selectText, deselectText) {
       if(buttonSelected) {
	        for (i = 0; i < noOfRows; i++) {
	             if(noOfRows == 1) {
	                selectCheckBox(checkList, false);
	             } else {
	             	selectCheckBox(checkList[i], false);
	        	 }
	        }
	        obj.value = selectText;
	        buttonSelected=false;
       } else {
	        for (i = 0; i < noOfRows; i++) {
	             if(noOfRows == 1)
	        	    selectCheckBox(checkList, true);
	        	 else
	        	    selectCheckBox(checkList[i], true);
            }
            obj.value = deselectText;
	        buttonSelected=true;
       }
} 
function submitFormForDelete(checkList,noOfRows,message,noReport,reportDelete)
{
    var checkFlag = false;
    var reportTypeObj = document.getElementById("reportType");
    var reportAreaObj = document.getElementById("reportArea");
    var reportCategoryObj = document.getElementById("reportCategory");
    var isSearchAppliedObj = document.getElementById("isSearchApplied");
    var reportType = reportTypeObj.value;
    var reportArea = reportAreaObj.value;
    var reportCategory = reportCategoryObj.value;
    var isSearchApplied = isSearchAppliedObj.value;
 	
 	if(noOfRows==0){
 		alert(noReport);
 		return false;
 	}
 
	for(i=0; i < noOfRows; i++)
    {
           if(noOfRows == 1 && checkList.checked == true)
           {
              checkFlag = true;
              break;  
           }
		     else if(noOfRows == 1 && checkList.checked == false)
           {
              checkFlag = false;
              break;  
           }
           else if(checkList[i].checked == true)
           {
			  checkFlag = true;
              break;  
           } 
    }
    if(checkFlag == false)
    {
        alert(reportDelete);
        return false;
    }
    else 
    { 
	    var confirmDelete = message;
	    if (confirm(confirmDelete))
		{
			document.listForm.method="post";
			if(reportType != null)
      			document.listForm.action="/expensemap/deleteReportRecord.do?reportCategory="+reportCategory+"&reportType="+reportType+"&reportArea="+reportArea+"&isSearchCriteria="+isSearchApplied;
      	    else
      	        document.listForm.action="/expensemap/deleteReportRecord.do?reportCategory="+reportCategory+"&reportArea="+reportArea+"&isSearchCriteria="+isSearchApplied;
			document.listForm.submit();		
		}
	    else
		{
			return false;
		}
    }
	
}

<!-- Function to decode HTML entities or ISO Latin codes to special characters . -->

function htmlDecode(encodedValue) {
	if (encodedValue != null){	
		encodedValue = encodedValue.replace(/&lt;/g, "<");
		encodedValue = encodedValue.replace(/&gt;/g, ">");		
		encodedValue = encodedValue.replace(/&quot;/g, "\"");
		encodedValue = encodedValue.replace(/&#33;/g, "!");
		encodedValue = encodedValue.replace(/&#39;/g, "'");     
		encodedValue = encodedValue.replace(/&#40;/g, "(");
		encodedValue = encodedValue.replace(/&#41;/g, ")");
		encodedValue = encodedValue.replace(/&#91;/g, "[");
		encodedValue = encodedValue.replace(/&#93;/g, "]");
		encodedValue = encodedValue.replace(/&#123;/g, "{");
		encodedValue = encodedValue.replace(/&#125;/g, "}");
		encodedValue = encodedValue.replace(/&amp;/g, "&");
	}
	return encodedValue;
}


<!-- Function to encode HTML special characters to HTML entities or ISO Latin codes . -->
function htmlEncode(decodedValue) {
	if (decodedValue == null)
		return decodedValue;

	var newEncodedValue = '';
	for (var i=0; i<decodedValue.length; i++)
	{
		var newChar = decodedValue.charAt(i);
		switch (newChar)
		{
			case '<':
				newChar = '&lt;';
			break;
			case '>':
				newChar = '&gt;';
			break;
			case '"':
				newChar = '&quot;';
			break;
			case '!':
				newChar = '&#33;';
			break;
			case '\'':
				newChar = '&#39;';
			break;
			case '(':
				newChar = '&#40;';
			break;
			case ')':
				newChar = '&#41;';
			break;
			case '[':
				newChar = '&#91;';
			break;
			case ']':
				newChar = '&#93;';
			break;
			case '{':
				newChar = '&#123;';
			break;
			case '}':
				newChar = '&#125;';
			break;
		}
		newEncodedValue += newChar;
	}

	return newEncodedValue;
}

/**
 * This function will escape hex encoded (ESAPI does that) 
 * problematic characters such as " ' \
 * This needs to be done if the string contains problematic characters 
 * and has to be used in JavaScript.
 * If not escaped, JavaScript throws unterminated string error messages. 
 */
function escapeHexEncodedHTML(encodedValue) {
	return encodedValue.replace(/&#x27;/g, "\\\&#x27;") // ' (single quote)
					   .replace(/&#x22;/g, "\\\&#x22;") // " (double quote)
					   .replace(/&#x5c;/g, "\\\&#x5c;"); // \ (backslash)
}

<!-- Function to decode XML character entities to HTML special characters . -->
function xmlDecode(encodedValue) {
	if (encodedValue != null){	
		encodedValue = encodedValue.replace(/&lt;/g, "<");
		encodedValue = encodedValue.replace(/&gt;/g, ">");
		encodedValue = encodedValue.replace(/&amp;/g, "&");
	}
	return encodedValue;
}

//Checks if input string is undefined, null or blank (with/without spaces)
function IsEmptyString(name) {
	return (!name || /^\s*$/.test(name));
}

//Checks if string is integer value. It should have only numbers.
function IsNumeric(strString) {
	var strVal = trim(strString.value);
	if (strVal != null && strVal != 0 && strVal.length > 0){
		if(!/\D/.test(strVal)) 
			return true;
	}
	return false;
}

// validate file name for blank or invalid chars.
function validateFileName(fileName, nameRequired, invalidChars) {
    var message = '';
    if (IsEmptyString(fileName.value)) {
		message = nameRequired;
	} 
	if (!validateInput(fileName)) {
		if (message != '') {
			message += '\n';
		}
		message += invalidChars;
	}
	if (message != '') {
		alert(message);
		return false;
	}
	return true;
}

/* This function will trim the given string and return.*/
function trim(s) {
    return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}