<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="/jsp/includes/tlib.jspf"%>
<%@ page import="com.zeborg.expensemap.web.*"%>
<%@ page import="com.zeborg.util.EncodeUtil" %>
<%@ page import="com.zeborg.util.WebUtil"%>
<%@ page import ="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil" %>
<%@ page import="com.zeborg.expensemap.view.*, com.emptoris.viewer.util.CSRFHelper"%>
<%//No client side caching
    WebUtil.addNoCache(response);
%>
<%@ include file="../begin_page.jspf"%>
<%
	String returnToURL = "../preferences/ManageCubePreferences.do?operation=list";       
    pageContext.setAttribute("returnToURL",returnToURL,pageContext.SESSION_SCOPE);
	String helpURL =HelpUtil.getHelpUtil().getHelpURLString("preferencesGeneral",zs.getUser().getLocale());  	
%>
<HTML>
<HEAD>
<fmt:setBundle basename="ExpensemapMessagesBundle" />
<TITLE><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message bundle="EmSrcMessagesBundle" key="ui.label.general.preferences"/></TITLE>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/preferences.css"> 
<link rel='shortcut icon' href='/expensemap/jsp/images/favicon.ico' type='image/x-icon'>
<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js" ></script>
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<script type="text/javascript">
	function setOperation(operation){
		document.getElementById('operation').value=operation;
	    return true;
	}
	//submit the ajax request
	function submitRequest(operation, selectTag){
		try {
			var argStr = "operation=" + operation + "&" + selectTag.name + "=" + selectTag.value;
			var url = "/expensemap/preferences/ManageCubePreferences.do?" + argStr;
			jQuery.ajax({
				url: url,
				type: "GET",
				success: responseHandler,
				error: function(xhr, status, error) {
					alert("<bean:message bundle='EmMessagesBundle' key='ui.message.There.was.a.problem.retrieving.data.from.server'/> " + xhr.statusText);
				}
			});
			
		} catch(e) {
			 alert(e);
		}	
	}
	//handle the ajax response
	function responseHandler(ajaxResponse) {  
		var data = eval(ajaxResponse);
		
		// If there is no data in the response, ignore this
		if (data == null) {
		   return;
		}
		if (data[0] == "Error") {
			var errorCode = data[1];
			if(errorCode == "session.timeout")
			{
			   var timeoutURL = data[3];
			   parent.location.href=timeoutURL;
			   return;
			}else{
				//alert the error
				alert(data[2]);
			}
		} else if( data[0]=="getSearchAttributeList") {
			var searchAttribute = document.getElementById("searchAttribute");
			for( i=0; i < searchAttribute.options.length;){
				searchAttribute.options[i]=null
			}
			for(i=1 ; i<data.length ; i=i+2){
				searchAttribute.options[searchAttribute.options.length] = new Option(data[i], data[i+1]);
			}
			if(searchAttribute.options.length > 0)
				searchAttribute.options[0].selected=true					
		} else if( data[0]=="getInitialPageViewList") {
			var initialPageView = document.getElementById("initialPageView");
			for( i=0; i < initialPageView.options.length;){
				initialPageView.options[i]=null
			}
			for(i=1 ; i<data.length ; i=i+2){
				initialPageView.options[initialPageView.options.length] = new Option(htmlDecode(data[i]), data[i+1]);
			}
			if(initialPageView.options.length > 0)
				initialPageView.options[0].selected=true					
		} 
	}
	
	function init(){
		document.getElementById('sessionFilter').focus();
	}
</script>
</HEAD>
<BODY LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onload="init();" >
<html:form styleId="cubePreferencesForm" action="/ManageCubePreferences">
<html:hidden property="operation" styleId="operation"/>

<%-- build the masthead --%>
<%  //Handled BugNo: 22928
	CubeUtil.buildExpMapMastHead(out,"preferences_main_frame.jsp",zs,true,null,zs.getUser().getLocale(),null);
%>

<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="helpUrl" value="<%=helpURL%>"/>
</jsp:include>

<TABLE width="100%" border="0" cellspacing="0" cellpadding="0">
  <TR>
    <TD colspan="2" valign="middle" class="TableHdr"><bean:message bundle="EmSrcMessagesBundle" key="ui.label.general.preferences"/></TD>
  </TR>
  <TR>
	<TD colspan="2"><TABLE border="0" cellspacing="0" cellpadding="0" class="popformTable" align="center">
	<TR>
	   <TD class="popformLeft"><fmt:message key='ui.label.Select.Session.Filter'/></TD>
		<TD CLASS="popformRight" > 
			<html:select  name="cubePreferencesForm" property="sessionFilter" styleId="sessionFilter" styleClass="tabledata">
				<html:options collection="sessionFilterList" property="value" labelProperty="label"/>
			</html:select>
		</TD>
	</TR>
	<TR >
	   <TD class="popformLeft"><fmt:message key='ui.label.Current.Session.Filter'/></TD>
		<TD CLASS="popformRight"> ${cubePreferencesForm.currentSessionFilterName}&nbsp;</TD>
	</TR>
	<TR>
	   <TD class="popformLeft"><fmt:message key='ui.label.Current.Filter.Description'/></TD>
		<TD CLASS="popformRight"> ${cubePreferencesForm.currentSessionFilterDesc}&nbsp;</TD>
	</TR>
	<TR>
	   <TD class="popformLeft"><fmt:message key='ui.label.Default.Search.Dimension'/></TD>
		<TD CLASS="popformRight"> 
			<html:select  name="cubePreferencesForm" property="searchDimension" styleId="searchDimension"  onchange="submitRequest('getSearchAttributeList',this)" styleClass="tabledata">
				<html:options collection="searchDimensionList" property="value" labelProperty="label"/>
			</html:select>
		</TD>
	</TR>
	<TR>
	   <TD class="popformLeft"><fmt:message key='ui.label.Default.Search.Attribute'/></TD>
		<TD CLASS="popformRight"> 
			<html:select  name="cubePreferencesForm" property="searchAttribute" styleId="searchAttribute" styleClass="tabledata">
				<html:options collection="searchAttributeList" property="value" labelProperty="label"/>
			</html:select>
		</TD>
	</TR>
	<TR>
	   <TD class="popformLeft"><fmt:message key='ui.label.Default.Initial.Page.Type'/></TD>
		<TD CLASS="popformRight"> 
			<html:select  name="cubePreferencesForm" property="initialPageType" styleId="initialPageType"  onchange="submitRequest('getInitialPageViewList',this)" styleClass="tabledata">
				<html:options collection="initialPageTypeList" property="value" labelProperty="label"/>
			</html:select>
		</TD>
	</TR>
	<TR>
	   <TD class="popformLeft"><fmt:message key='ui.label.Default.Initial.Page.View'/></TD>
		<TD CLASS="popformRight"> 
			<html:select  name="cubePreferencesForm" property="initialPageView" styleId="initialPageView" styleClass="tabledata">
				<html:options collection="initialPageViewList" property="value" labelProperty="label"/>
			</html:select>
		</TD>
	</TR>	
	<TR>
	<TD  class="popformLeft"><fmt:message key='ui.label.is.default.dataset'/> (${cubePreferencesForm.datasetDisplayName})
	</TD>
	<TD CLASS="popformRight">
		<html:checkbox  styleClass="tabledata" name="cubePreferencesForm" property="defaultDataset" styleId="defaultDataset" ></html:checkbox>
	</TD>
	</TR>
	<TR>
	  <TD colspan="2" class="popformBot">
		<html:submit onclick="setOperation('save')"><fmt:message key='ui.label.Save'/></html:submit>
		<html:submit onclick="setOperation('restoreDefaults')"><fmt:message key='ui.label.Restore.Defaults'/></html:submit>
		</TD>
	</TR>	
	</TABLE></TD>
   </TR>
   <input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</TABLE>
</html:form>
</BODY>
</HTML>
<%@ include file="../end_page.jspf"%>