<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="java.util.Locale"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.text.SimpleDateFormat"%>
<%@page import="com.zeborg.expensemap.view2.ZSession"%>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>

<%
	Locale locale = WebUtil.getAppLocale(pageContext);
	//make url for help page    
	String helpURL = HelpUtil.getHelpUtil().getHelpURLString("help.url.feedback.submitOnline.page", locale);
	String date = new SimpleDateFormat("EEE MMM d HH:mm:ss z Z yyyy").format(new Date());
	Date expectedOlfJobDate = request.getAttribute("expectedOlfJobDate")!=null? (Date)request.getAttribute("expectedOlfJobDate"):new Date();
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
%>
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zs.getUser().getTimeZone().getID()%>" />
	
<html:html>
<head>
<script type="text/javascript">

	function onClickSaveForm() {
		var selectedFeedbackIds;
		var theParentForm = window.opener.document.getElementById("feedbackListModel");
		var theChildForm = document.submitOnlineFeedBackForm;
	    if(theParentForm.feedbackIds){
			selectedFeedbackIds = new StringBuffer();
			if(theParentForm.feedbackIds.checked){
				selectedFeedbackIds.append(theParentForm.feedbackIds.value);
		    }else{
				for(var i=0;i<theParentForm.feedbackIds.length;i++){
					if(theParentForm.feedbackIds[i].checked){
					selectedFeedbackIds.append(theParentForm.feedbackIds[i].value);
						if(i<theParentForm.feedbackIds.length-1){
							selectedFeedbackIds.append(",");
						}
					}
				}
			}
			theChildForm.feedbackIds.value = selectedFeedbackIds;
		}
		if (validateData()){		
			var confirmMessage = '<bean:message key="ui.online.feedback.job.confirm.msg" bundle="emMessages" arg0="JOB_SCHEDULE_DATE" arg1="JOB_SCHEDULE_TIME"/>';
			confirmMessage = confirmMessage.replace('JOB_SCHEDULE_DATE', document.submitOnlineFeedBackForm.jobStartDate.value);
			confirmMessage = confirmMessage.replace('JOB_SCHEDULE_TIME', document.submitOnlineFeedBackForm.jobStartDateHourMinute.value);
			if (confirm(confirmMessage)) {
						document.getElementById('submitButton').disabled= true;
						var frm = document.getElementById("submitOnlineFeedBackForm");
						var argStr = "operation=" + "loadFeedBackXml";
						var url = "/expensemap/rulemanagement/SubmitOnlineFeedBackAction.do?" + argStr;
						frm.action=url;
						frm.method="post";
						frm.submit();
						return true;
				}
		}
			return false;
	}
		
	function validateData(){
	
		return validateJobName() && validateJobDescriptionField() && validatejobStartDate() ;
		
	}
	
	function validateJobName(){
			var jobNameObj = document.submitOnlineFeedBackForm.jobName;
			var iChars = "*|,\":<>[]{}`\';()@&$#%";
			return validateRequired(jobNameObj, "<bean:message key='ui.job.dimension.clustering.jobName.required' bundle='emMessages'/>") && validateSpecialChars(jobNameObj, "<bean:message key='ui.job.dimension.clustering.jobName.no.special.char' bundle='emMessages'/>",  iChars );
		}
		
		function validatejobStartDate(){
			var jobStartDate = document.submitOnlineFeedBackForm.jobStartDate.value;
			if(!isEmpty(jobStartDate)){
				var jobStartDateHourMinute = document.submitOnlineFeedBackForm.jobStartDateHourMinute.value;
				if(!validateHourMinute(jobStartDateHourMinute)){
					document.submitOnlineFeedBackForm.jobStartDateHourMinute.value = '';
					alert("<bean:message key='ui.job.dimension.clustering.time.format' bundle='emMessages'/>");
					return false;
				}else{
					var tmArr = document.submitOnlineFeedBackForm.jobStartDateHourMinute.value.split(":");						
					if( !checkWithServerDate(jobStartDate, tmArr[0] , tmArr[1] )){
						var expectedJobStartTime = new Date();
						var message = "<bean:message key='ui.job.online.feedback.submit.schedule.date.less.block.out.time' arg0="JOB_SCHEDULE_DATE" bundle='emMessages'/>";
						<fmt:setLocale value='${formatLocale}'/>
						var formatedDate = '<fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern}" value="<%=expectedOlfJobDate%>"/>';						
						message = message.replace("JOB_SCHEDULE_DATE", formatedDate);
						alert(message);
						return false;
					}
				}
			}else{
				alert("<bean:message key='ui.job.online.feedback.submit.schedule.date.required' bundle='emMessages'/>");
				document.submitOnlineFeedBackForm.jobStartDate.value="";
				document.submitOnlineFeedBackForm.jobStartDate.focus();
				return false;
			}
			return true;
		}
		
		function validateJobDescriptionField() {
			var jobDescriptionObj = document.submitOnlineFeedBackForm.jobDescription;
			var len = jobDescriptionObj.value.length;
			if(len > 255){
				alert("<bean:message key='ui.job.description.validation.msg' bundle='emMessages'/>");
				jobDescriptionObj.value="";
				jobDescriptionObj.focus();
				return false;
			}
			return true;	
		}

	function checkWithServerDate(userDateString, hours, minutes){
		if( typeof hours == "undefined" ){
			hours = 0;
		}
		if( typeof minutes == "undefined" ){
			minutes = 0;
		}

		var expectedJobStartYear = document.getElementById('expectedOLFJobStartYear').value;
		var expectedJobStartMonth = document.getElementById('expectedOLFJobStartMonth').value;
		var expectedJobStartDay = document.getElementById('expectedOLFJobStartDate').value;
		var expectedJobStartHours = document.getElementById('expectedOLFJobStartHour').value;
		var expectedJobStartMinutes = document.getElementById('expectedOLFJobStartMin').value;
		var expectedJobStartDate = new Date(expectedJobStartYear, expectedJobStartMonth, 
											expectedJobStartDay, expectedJobStartHours, 
											expectedJobStartMinutes);
		
		if(userDateString!='' || userDateString!=null || userDateString!='null'){
			var userDate =  getUserDate(userDateString, hours, minutes );
			if(userDate > expectedJobStartDate){
				return true;
			}else{
				return false;	
			}
		}
	}
	
	/**
	 * For given dateFormat(compatible with Yahoo Calender) and user chosen date string
	 * return parsed date, month and year.
	 *
	 * ASSUMPTION: dateFormat could be anything from "%d/%m/%Y", "%m/%d/%Y", "%Y/%d/%m".
	 *
	 * @param dateFormat - String representing date format
	 * @param userDateString - String representing user chosen date from the Yahoo calender
	 * @return Day, month and array stored in an array
	 */
	function getDateFromDateFormat(dateFormat, userDateString) {
		var dayIndex = dateFormat.indexOf("d");
		var monthIndex = dateFormat.indexOf("m");
		var yearIndex = dateFormat.indexOf("Y");

		// adjust indexes properly at the start of the day, month, year blocks
		// check for "%Y/%d/%m"
		if (yearIndex < dayIndex) {
			dayIndex = dayIndex + 1;
			monthIndex = monthIndex + 1;
		} else {
			dayIndex = dayIndex - 1;
			monthIndex = monthIndex - 1;
		}

		yearIndex = yearIndex - 1;

		var day = userDateString.substring(dayIndex, dayIndex + 2);
		var month = userDateString.substring(monthIndex, monthIndex + 2);
		var year = userDateString.substring(yearIndex, yearIndex + 4);

		return [day, month, year];		
	}

	 function getUserDate(userDateString,hours,minutes) {
		var localeDateFormat = "${dateFormatPattern}";
		var dateArr = getDateFromDateFormat(localeDateFormat, userDateString);
		var day = dateArr[0];
		var month = dateArr[1];
		var year = dateArr[2];

		return new Date (year, month-1, day, hours, minutes);
	}

	function init(){
		document.getElementById("jobName").focus();	
	}


</script>
</head>
<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.title.online.feedback" bundle="emMessages"/></title>
<link rel="stylesheet" type="text/css"	href="/expensemap/jsp/stylesheets/macromap.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/dynamicView.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource.js"></script>	
<script type="text/javascript" src="/expensemap/scripts/popup-cal.js"></script>
<script type="text/javascript" src="/expensemap/scripts/localeData.js"></script>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/css/dataenrichmentui.css">
<SCRIPT LANGUAGE="JavaScript" SRC="/expensemap/jsp/analytics/scripts/calendar.js"></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC="/expensemap/jsp/javascript/dataenrichment.js"></SCRIPT>
<script type="text/javascript" src="/expensemap/jsp/javascript/stringbuffer.js" ></script>
<body class="yui-skin-sam" leftmargin="2" topmargin="2" marginwidth="1" marginheight="1" onload="init();">
	<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>

<logic:messagesPresent message="true">
	<font color="red" face="Arial, Helvetica, sans-serif" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="ruleMessage">
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=pageContext.findAttribute("msg")%>
		</html:messages>
		</b>
	</font>
</logic:messagesPresent>
<br>
<html:form styleId="submitOnlineFeedBackForm" action="/SubmitOnlineFeedBackAction.do">
	<table width="96%" cellpadding="0" cellspacing="0" border="1"
		align="center">
		<tr class="POPFORMBODY">
			<td>
			<table class="POPFORMBORDER" cellpadding="0" cellspacing="1"
				border="0" width="100%">
				<tr class="POPFORMBODY">
					<td>

					<table width="100%" cellspacing="0" cellpadding="0" border="0"
						class="POPFORMBODY">
						<tr>
							<td class="POPFORMTITLE" style="padding-left: 3px" nowrap>
							<bean:message key="ui.title.online.feedback" bundle="emMessages"/></td>
							<td align="left" class="POPFORMTITLE"><img
								src="/expensemap/jsp/images/help.gif" border="0" title='<bean:message key="ui.label.Help" bundle="emMessages"/>'
								onclick="window.open('<%=helpURL%>','help','')" align="right"
								style="cursor: pointer"></td>
						</tr>
						<tr>
							<td colspan="2" height="0.1px" class="POPFORMRULE"><img
								border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif'
								width='100%' height='1'></td>
						</tr>
						<tr>
							<td class="POPFORMLABEL" style="padding-right: 10px">
							<div class="DIVSTYLE"><bean:message key="ui.job.dimension.clustering.jobName" bundle="emMessages" /> <span
								style="color: red; font-size: 18px">*</span>&nbsp;&nbsp;</div>
							</td>
							<td class="POPFORMFIELD" width="60%" style="padding-left: 10px">
							<html:text property="jobName" styleId="jobName" styleClass="inputStyle" size="20" maxlength="80"/></td>
						</tr>
						<tr>
							<td colspan="2" height="0.1px" class="POPFORMRULE"><img
								border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif'
								width='100%' height='1'></td>
						</tr>
						<tr>
							<td class="POPFORMLABEL" style="padding-right: 10px">
							<div class="DIVSTYLE"><bean:message key="ui.label.Description" bundle="emMessages" /></div>
							</td>
							<td class="POPFORMFIELD" width="60%" style="padding-left: 10px">
							<html:textarea property="jobDescription" cols="25" rows="2" styleId="jobDescription"/>
							</td>
						</tr>
						<tr>
							<td colspan="2" height="0.1px" class="POPFORMRULE"><img
								border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif'
								width='100%' height='1'></td>
						</tr>
						<tr>
							<td class="POPFORMLABEL" style="padding-right: 10px">
							<div class="DIVSTYLE"><bean:message key="ui.job.online.feedback.submit.schedule.date" bundle="emMessages" /> <span
								style="color: red; font-size: 18px">*</span></div>
							</td>
							<td class="POPFORMFIELD" width="60%" style="padding-left: 10px">
							<html:text property="jobStartDate" size="15" styleId="jobStartDate" styleClass="inputStyle" maxlength="10" readonly="true"/>
							<html:text property="jobStartDateHourMinute" size="5" styleId="jobStartDateHourMinute" styleClass="inputStyle" maxlength="5" value="0:00"/>&nbsp;<bean:message key="ui.job.dimension.gmt" bundle="dataEnrichmentMessages" />&nbsp;<%=new SimpleDateFormat("Z").format(new Date())%>&nbsp;				
						</td>
						</tr>
						<tr>
							<td colspan="2" height="0.1px" class="POPFORMRULE"><img
								border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif'
								width='100%' height='1'></td>
						</tr>
					</table>
					<br/>
					<div class="POPFORMBUTTONS">
						<input type="submit" id="submitButton" value="<bean:message key='button.submit' bundle='emMessages'/>" onclick="return onClickSaveForm();">&nbsp;
	
						<input type="button" name="close" value="<bean:message key='button.close' bundle='emMessages'/>" onclick="top.window.close();">
					</div>
					<br/>
					</td>
				</tr>
			</table>
			</td>
		</tr>
		<tr>
		<td>
			<table>
				<tr>
					<td>
						<div class="POPFORMINSTRUCTIONS"><br><span class="requiredFields">*</span><bean:message key="ui.import.required.fields" bundle="emMessages" /></div>
					</td>
				</tr>
		  	</table>
			</td>
		</tr>
	</table>
	<input type="hidden" id="feedbackIds" name="feedbackIds"/>
	<input type="hidden" name="blockOutTimeInDays" id="expectedOLFJobStartYear" value="<c:out value='${requestScope.expectedOLFJobStartYear}'/>"/>
	<input type="hidden" name="blockOutTimeInDays" id="expectedOLFJobStartMonth" value="<c:out value='${requestScope.expectedOLFJobStartMonth}'/>"/>
	<input type="hidden" name="blockOutTimeInDays" id="expectedOLFJobStartDate" value="<c:out value='${requestScope.expectedOLFJobStartDate}'/>"/>
	<input type="hidden" name="blockOutTimeInDays" id="expectedOLFJobStartHour" value="<c:out value='${requestScope.expectedOLFJobStartHour}'/>"/>
	<input type="hidden" name="blockOutTimeInDays" id="expectedOLFJobStartMin" value="<c:out value='${requestScope.expectedOLFJobStartMin}'/>"/>
	<input type ='hidden' name="AuthCode" id="AuthCode" value="<c:out value='${sessionScope.hma_code_allActions}'/>"/>
</html:form>

<script language="JavaScript">
 
 
	YAHOO.namespace('submit.olfjob');
	(function() {
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	YAHOO.submit.olfjob = {
		init: function() {
			var self = YAHOO.submit.olfjob;
			var jobStartDate = document.getElementById("jobStartDate");
			
			Event.on(jobStartDate, "focus", self.openCalendar, [jobStartDate, jobStartDate]);			
		},

		openCalendar: function(e, args) {
			YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '${languageLocale}', '${dateFormatPattern}'); 
		}
	}
	Event.onDOMReady(YAHOO.submit.olfjob.init, YAHOO.submit.olfjob, true);
})();


</script>

</body>
</html:html>