""" 
 * (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
"""

############################################################################
# wsadmin script to deploy SPEND ANALYSIS Application Server
############################################################################

from install.GetProfilePath import GetProfilePath
from install.WASService import WASService

from util.Boolean import * 
import util.utility as util

import was_objs.import_was as wasScript
execfile(wasScript.__file__)

print "Installing Spend Application Server..."

wasHome = args['wasHome']
profileName = args['profileName']
serverName = args['serverName']
nodeName = args['nodeName']
cellName = args['cellName']

profilePath = GetProfilePath(wasHome).getProfilePath(profileName)

if profilePath is None:
	raise Exception('Could not find target profile path for profile [' + profileName + ']') 

try:
	# Create a new server
	svr = server.Server(serverName, nodeName, cellName)
	svr.setPortSet(args['portSet'])
	svr.configure()
	print "set server"
	
	#jvm 
	jvmconfig = jvm.JavaVirtualMachine(svr)
	jvmconfig.setInitialHeapSize(args['heapSize'])
	jvmconfig.setMaximumHeapSize(args['heapSize'])
	jvmconfig.setClasspath([args['genericClasspath']])
	jvmconfig.setGenericJvmArguments([args['genericJvmArguments']]); 
	jvmconfig.configure()
	print "set jvm"
	
	#jdbc provider
	jdbcP = jdbcProvider.JDBCProvider()
	jdbcP.setName("MYSQL Provider")
	jdbcP.setVendor(args['databaseVendor'])
	jdbcP.setClasspath(args['jdbcDriverLocation'])
	jdbcP.setServer(svr)
	jdbcP.configure()
	
	print "set jdbc"
	
	
	# Create a DataSource
	ds1 = dataSource.DataSource()
	ds1.setName("ejbPool_mssql4")
	ds1.setJndiName("jdbc/ejbPool_mssql4")
	ds1.setServer(svr)
	ds1.setJdbcProvider(jdbcP)
	ds1.configure()
	ds1.configure()
	datasourceConfigId1 = ds1.getConfigId()
	connectionPoolId1 = AdminConfig.list('ConnectionPool', datasourceConfigId1)
	AdminConfig.modify(connectionPoolId1, '[[minConnections "5"] [maxConnections "20"] [agedTimeout "3600"] [testConnection "true"] [testConnectionInterval "3600"]]')
	ds1.setProperty('databaseName',args['databaseName']+'?autoReconnect=true')
	ds1.setProperty('factory','com.mysql.jdbc.jdbc2.optional.MysqlDataSourceFactory')
	ds1.setProperty('user',args['dbServerUser'])
	ds1.setProperty('password',args['dbServerPassword'])
	ds1.setProperty('port',args['dbServerPort'])
	ds1.setProperty('serverName',args['dbServerHost'])

	print "set datasource1"

	# Create a DataSource
	ds2 = dataSource.DataSource()
	ds2.setName("mySQLDB")
	ds2.setJndiName("mySQLDB")
	ds2.setServer(svr)
	ds2.setJdbcProvider(jdbcP)
	ds2.configure()
	datasourceConfigId2 = ds2.getConfigId()
	connectionPoolId2 = AdminConfig.list('ConnectionPool', datasourceConfigId2)
	AdminConfig.modify(connectionPoolId2, '[[minConnections "10"] [maxConnections "250"] [agedTimeout "3600"] [testConnection "true"] [testConnectionInterval "3600"]]')
	ds2.setProperty('databaseName',args['databaseName']+'?autoReconnect=true')
	ds2.setProperty('factory','com.mysql.jdbc.jdbc2.optional.MysqlDataSourceFactory')
	ds2.setProperty('user',args['dbServerUser'])
	ds2.setProperty('password',args['dbServerPassword'])
	ds2.setProperty('port',args['dbServerPort'])
	ds2.setProperty('serverName',args['dbServerHost'])	
	print "set datasource2"

	# Create a DataSource
	ds3 = dataSource.DataSource()
	ds3.setName("rdatasource")
	ds3.setJndiName("rdatasource")
	ds3.setServer(svr)
	ds3.setJdbcProvider(jdbcP)
	ds3.configure()
	datasourceConfigId3 = ds3.getConfigId()
	connectionPoolId3 = AdminConfig.list('ConnectionPool', datasourceConfigId3)
	AdminConfig.modify(connectionPoolId3, '[[minConnections "5"] [maxConnections "20"] [agedTimeout "3600"] [testConnection "true"] [testConnectionInterval "3600"]]')
	ds3.setProperty('databaseName',args['databaseName']+'?autoReconnect=true')
	ds3.setProperty('factory','com.mysql.jdbc.jdbc2.optional.MysqlDataSourceFactory')
	ds3.setProperty('user',args['dbServerUser'])
	ds3.setProperty('password',args['dbServerPassword'])
	ds3.setProperty('port',args['dbServerPort'])
	ds3.setProperty('serverName',args['dbServerHost'])	
	print "set datasource3"
	
	################Data Source Configuration for User Registry START ################
	
	oracleDatabase = 'Oracle'
	db2Database = 'DB2'
	
	auth = jaasAuthData.JAASAuthData()
	auth.setAlias(args['urDataSourceName'])
	auth.setDescription("Credentials for  SSM DS")
	auth.setUserId(args['ssmDataSourceUserId'])
	auth.setPassword(args['ssmDataSourcePassword'])
	auth.setServer(svr)
	auth.configure()

	jdbcP = jdbcProvider.JDBCProvider()
	jdbcP.setName(args['urDataSourceName'])
	jdbcP.setVendor(args['ssmRdbmsVendor'])
	jdbcP.setClasspath(args['ssmJdbcDriverLocation'])
	jdbcP.setServer(svr)
	jdbcP.configure()

	ds4 = dataSource.DataSource()
	ds4.setName(args['urDataSourceName'])
	ds4.setCategory(args['urDataSourceName'])
	ds4.setJndiName(args['urDataSourceJndiName'])
	if 'ssmDataSourceUrl' in args.keys() and args['ssmRdbmsVendor'] == oracleDatabase :
		ds4.setURL(args['ssmDataSourceUrl'])
	else:
		ds4.setResourceAttribute('databaseName', args['ssmDatabaseServicename'])
		ds4.setResourceAttribute('driverType', 4, 'java.lang.Integer')
		ds4.setResourceAttribute('serverName', args['ssmDatabaseIP'])
		ds4.setResourceAttribute('portNumber', args['ssmDatabasePort'], 'java.lang.Integer')
	ds4.setAuthDataAlias(auth)
	ds4.setServer(svr)
	ds4.setJdbcProvider(jdbcP)
	ds4.configure()
	ds4.setProperty("nonTransactionalDataSource", "true", propType="java.lang.Boolean")
	datasourceConfigId = ds4.getConfigId()
	connectionPoolId = AdminConfig.list('ConnectionPool', datasourceConfigId)
	AdminConfig.modify(connectionPoolId, '[[maxConnections "10"] [minConnections "5"]]')
	if args['ssmRdbmsVendor'] == db2Database :
		ds4.setResourceAttribute('currentSchema', args['ssmDb2Schema'])
		ds4.setResourceAttribute('currentFunctionPath', args['ssmDb2Schema'])
		ds4.configure()
	################Data Source Configuration for User Registry END ################
	
	print "set all datasource"
	
	# SPEND login entries
	spendLoginEntry = jaasLoginEntry.JAASLoginEntry()
	spendLoginEntry.setLoginEntryAlias('EM')
	spendLoginEntry.setLoginType('application')
	# login module
	nativeLoginModule = jaasAppLoginModule.JAASApplicationLoginModule()
	nativeLoginModule.setLoginModule('com.zeborg.sso.EmLoginModule')
	nativeLoginModule.setAuthStrategy('REQUIRED')
	nativeLoginModule.addCustomProperty('debug','false')
	nativeLoginModule.addCustomProperty('userNameParam','frm_comzzzzeborgzzzaclzzzwebzzzLoginForm_0_def_userName')
	nativeLoginModule.addCustomProperty('passwordParam','frm_comzzzzeborgzzzaclzzzwebzzzLoginForm_0_def_password')
	
	spendLoginEntry.addLoginModule(nativeLoginModule)
	spendLoginEntry.configure()

    # SPEND SSO login entries
	ssoLoginEntry1 = jaasLoginEntry.JAASLoginEntry()
	ssoLoginEntry1.setLoginEntryAlias('SsoToken')
	ssoLoginEntry1.setLoginType('application')
	# login module
	nativeLoginModule1 = jaasAppLoginModule.JAASApplicationLoginModule()
	nativeLoginModule1.setLoginModule('com.emptoris.framework.SSO.authentication.module.SsoTokenLoginModule')
	nativeLoginModule1.setAuthStrategy('REQUIRED')
	nativeLoginModule1.addCustomProperty('debug','false')
	
	ssoLoginEntry1.addLoginModule(nativeLoginModule1)
	ssoLoginEntry1.configure()
	
	# SPEND GSKSSO login entries
	ssoLoginEntry2 = jaasLoginEntry.JAASLoginEntry()
	ssoLoginEntry2.setLoginEntryAlias('GSKSsoToken')
	ssoLoginEntry2.setLoginType('application')
	# login module
	nativeLoginModule2 = jaasAppLoginModule.JAASApplicationLoginModule()
	nativeLoginModule2.setLoginModule('com.zeborg.gsksso.GSKSSOTokenLoginModule')
	nativeLoginModule2.setAuthStrategy('REQUIRED')
	nativeLoginModule2.addCustomProperty('debug','false')
	nativeLoginModule2.addCustomProperty('ssoTokenParam','SSOTOKEN')
	nativeLoginModule2.addCustomProperty('userParam','USER')
	
	ssoLoginEntry2.addLoginModule(nativeLoginModule2)
	ssoLoginEntry2.configure()
	
	print "set nativeLoginModule"
	print "Saving changes..."
	AdminConfig.save()
	print "Changes saved."
   
	#spend.ear
	inst = installer.Installer(args['appWarLocation'], args['installerPropertiesLocation'])
	inst.setServer(svr)
	inst.setCtxRootForWebMod([["SPEND Server WAR", 'expensemap-web-uber.war,WEB-INF/web.xml', '/expensemap']])	
	inst.setCtxRootForWebMod([["SPEND DATAMANAGER Integration Server WAR", 'integration-server-webapp.war,WEB-INF/web.xml', '/integration']])	
	inst.setProcessEmbeddedConfig(false)
	inst.setNoprocessEmbeddedConfig(true)
	inst.setMapResRefToEJB([["SPEND Server WAR", "", 'expensemap-web-uber.war,WEB-INF/web.xml', 'jdbc/ejbPool_mssql4', 'javax.sql.DataSource', ds1.getJndiName(), "", "", "",]])

	
	if 'overlayPath' in args.keys() and args['overlayPath'] is not None and not args['overlayPath'] == '':
		inst.setOverlay(args['overlayPath'])
	
	inst.configure()
	print "set installer"	
	print "Saving changes..."
	AdminConfig.save()
	print "Changes saved."
	
except Exception, e:
	print "Server configuration failed.  Rolling back changes."
	AdminConfig.reset()
	raise # Re-throw to terminate the script
	